# CyberSource.Ptsv2paymentsTravelInformationTransitAirline

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**isDomestic** | **String** | Specifies if the flight is: Domestic (01) International (02) If Y then 01 else 02  | [optional] 
**bookingReferenceNumber** | **String** | Reference number for the airline booking. Required if ticket numbers are not issued.  | [optional] 
**carrierName** | **String** | Airline that generated the ticket. Format: English characters only. Optional request field.  | [optional] 
**ticketIssuer** | [**Ptsv2paymentsTravelInformationTransitAirlineTicketIssuer**](Ptsv2paymentsTravelInformationTransitAirlineTicketIssuer.md) |  | [optional] 
**ticketNumber** | **String** | Ticket number. Format: English characters only. Restricted string data type that indicates a sequence of letters, numbers, and spaces; special characters are not included. Optional request field.  | [optional] 
**checkDigit** | **String** | Check digit for the ticket number. CyberSource recommends that you validate the check digit. With Discover and Diners Club, a valid ticket number has these characteristics: - The value is numeric. - The first three digits are a valid IATA2 license plate carrier code. - The last digit is a check digit or zero (0). - All remaining digits are nonzero.  | [optional] 
**restrictedTicketIndicator** | **Number** | Flag that indicates whether or not the ticket is restricted (nonrefundable). Possible values: - 0: No restriction (refundable) - 1: Restricted (nonrefundable) Format: English characters only. Restricted string data type that indicates a sequence of letters, numbers, and spaces; special characters are not included. Optional request field.  | [optional] 
**transactionType** | **Number** | Type of charge. Possible values: - 01: Charge is for an airline ticket - 02: Charge is for an item that is not an airline ticket  | [optional] 
**extendedPaymentCode** | **String** | The field is not currently supported.  | [optional] 
**passengerName** | **String** | Name of the passenger to whom the ticket was issued.  This will always be a single passenger's name. If there are more than one passengers, provide only the primary passenger's name. Do not include special characters such as commas, hyphens, or apostrophes. Only ASCII characters are supported. Format: English characters only. Optional request field.  | [optional] 
**customerCode** | **String** | Reference number or code that identifies the cardholder. Format: English characters only. Restricted string data type that indicates a sequence of letters, numbers, and spaces; special characters are not included. Optional request field.  | [optional] 
**documentType** | **String** | Airline document type code that specifies the purpose of the transaction. Format: English characters only. Optional request field.  | Code | Description | | --- | --- | | 01 | Passenger ticket | | 02 | Additional collection | | 03 | Excess baggage | | 04 | Miscellaneous charge order (MCO) or prepaid ticket authorization | | 05 | Special service ticket | | 06 | Supported refund | | 07 | Unsupported refund | | 08 | Lost ticket application | | 09 | Tour order voucher | | 10 | Ticket by mail | | 11 | Undercharge adjustment | | 12 | Group ticket | | 13 | Exchange adjustment | | 14 | SPD or air freight | | 15 | In-flight adjustment | | 16 | Agency passenger ticket | | 17 | Agency tour order or voucher | | 18 | Agency miscellaneous charge order (MCO) | | 19 | Agency exchange order | | 20 | Agency group ticket | | 21 | Debit adjustment for duplicate refund or use | | 22 | In-flight merchandise order | | 23 | Catalogue merchandise order | | 24 | In-flight phone charges | | 25 | Frequent flyer fee or purchase | | 26 | Kennel charge | | 27 | Animal transportation charge | | 28 | Firearms case | | 29 | Upgrade charge | | 30 | Credit for unused transportation | | 31 | Credit for class of service adjustment | | 32 | Credit for denied boarding | | 33 | Credit for miscellaneous refund | | 34 | Credit for lost ticket refund | | 35 | Credit for exchange refund | | 36 | Credit for overcharge adjustment | | 37 | Credit for multiple Unused tickets | | 38 | Exchange order | | 39 | Self-service ticket | | 41 | In-flight duty-free purchase | | 42 | Senior citizen discount booklets | | 43 | Club membership fee | | 44 | Coupon book | | 45 | In-flight charges | | 46 | Tour deposit | | 47 | Frequent flyer overnight delivery charge | | 48 | Frequent flyer fulfillment | | 49 | Small package delivery | | 50 | Vendor sale | | 51 | Miscellaneous taxes or fees | | 52 | Travel agency fee | | 60 | Vendor refund or credit | | 64 | Duty free sale | | 65 | Preferred seat upgrade | | 66 | Cabin upgrade | | 67 | Lounge or club access or day pass | | 68 | Agent assisted reservation or ticketing fee | | 69 | Ticket change or cancel fee | | 70 | Trip insurance | | 71 | Unaccompanied minor | | 72 | Standby fee | | 73 | Curbside baggage | | 74 | In-flight medical equipment | | 75 | Ticket or pass print fee | | 76 | Checked sporting or special equipment | | 77 | Dry ice fee | | 78 | Mail or postage fee | | 79 | Club membership fee or temporary trial | | 80 | Frequent flyer activation or reinstatement | | 81 | Gift certificate | | 82 | Onboard or in-flight prepaid voucher | | 83 | Optional services fee | | 84 | Advance purchase for excess baggage | | 85 | Advance purchase for preferred seat upgrade | | 86 | Advance purchase for cabin upgrade | | 87 | Advance purchase for optional services | | 88 | WiFi | | 89 | Packages | | 90 | In-flight entertainment or internet access | | 91 | Overweight bag fee | | 92 | Sleep sets | | 93 | Special purchase fee |  | [optional] 
**documentNumber** | **String** | The field is not currently supported.  | [optional] 
**documentNumberOfParts** | **Number** | The field is not currently supported.  | [optional] 
**invoiceNumber** | **String** | Invoice number for the airline transaction.  | [optional] 
**invoiceDate** | **Number** | Invoice date. The format is YYYYMMDD. If this value is included in the request, it is used in the creation of the invoice number. See \"Invoice Number,\"  | [optional] 
**additionalCharges** | **String** | Description of the charge if the charge does not involve an airline ticket. For example: Excess baggage.  | [optional] 
**totalFeeAmount** | **String** | Total fee for the ticket. This value cannot exceed `99999999999999999999` (twenty 9s). Format: English characters only. Optional request field.  | [optional] 
**clearingSequence** | **String** | Number that identifies the clearing message when multiple clearing messages are allowed per authorized transaction. Each clearing message linked to one authorization request must include a unique clearing sequence number between 1 and the total number of clearing records. Format: English characters only. Optional request field.  | [optional] 
**clearingCount** | **String** | Total number of clearing messages associated with the authorization request. Format: English characters only. Optional request field.  | [optional] 
**totalClearingAmount** | **String** | Total clearing amount for all transactions in the clearing count set. This value cannot exceed `99999999999999999999` (twenty 9s). Format: English characters only. If this field is not set and if the total amount from the original authorization is not NULL, the total clearing amount is set to the total amount from the original authorization.  | [optional] 
**numberOfPassengers** | **Number** | Number of passengers for whom the ticket was issued. Format: English characters only. Optional request field.  | [optional] 
**reservationSystemCode** | **String** | Code that specifies the computerized reservation system used to make the reservation and purchase the ticket. Format: English characters only. Restricted string data type that indicates a sequence of letters, numbers, and spaces; special characters are not included. Optional request field.  | [optional] 
**processIdentifier** | **String** | Airline process identifier. This value is the airline's three-digit IATA1 code which is used to process extended payment airline tickets.  | [optional] 
**ticketIssueDate** | **String** | Date on which the transaction occurred. Format: `YYYYMMDD` Format: English characters only. Optional request field.  | [optional] 
**electronicTicketIndicator** | **Boolean** | Flag that indicates whether an electronic ticket was issued. Possible values: - `true` - `false` Optional request field.  | [optional] 
**originalTicketNumber** | **String** | Original ticket number when the transaction is for a replacement ticket.  | [optional] 
**purchaseType** | **String** | Type of purchase. Possible values: - `EXC`: Exchange ticket - `MSC`: Miscellaneous (not a ticket purchase and not a transaction related to an exchange ticket) - `REF`: Refund - `TKT`: Ticket Format: English characters only. Optional request field.  | [optional] 
**creditReasonIndicator** | **String** | Reason for the credit. Possible values: - `A`: Cancellation of the ancillary passenger transport purchase. - `B`: Cancellation of the airline ticket and the passenger transport ancillary purchase. - `C`: Cancellation of the airline ticket. - `O`: Other. - `P`: Partial refund of the airline ticket. Format: English characters only.  Optional request field.  | [optional] 
**ticketChangeIndicator** | **String** | Type of update. Possible values: - `C`: Change to the existing ticket. - `N`: New ticket. Format: English characters only Optional request field.  | [optional] 
**planNumber** | **String** | Plan number based on the fare. This value is provided by the airline. Format: English characters only. Optional request field.  | [optional] 
**arrivalDate** | **String** | Date of arrival for the last leg of the trip. Format: `MMDDYYYY` English characters only. Optional request field.  | [optional] 
**restrictedTicketDesciption** | **String** | Text that describes the ticket limitations, such as _nonrefundable_. Format: English characters only. Optional request field.  | [optional] 
**exchangeTicketAmount** | **String** | Amount of the exchanged ticket. Format: English characters only.  | [optional] 
**exchangeTicketFeeAmount** | **String** | Fee for exchanging the ticket. Format: English characters only. Optional request field.  | [optional] 
**reservationType** | **String** | The field is not currently supported.  | [optional] 
**boardingFeeAmount** | **String** | Boarding fee.  | [optional] 
**legs** | [**[Ptsv2paymentsTravelInformationTransitAirlineLegs]**](Ptsv2paymentsTravelInformationTransitAirlineLegs.md) |  | [optional] 
**ancillaryInformation** | [**Ptsv2paymentsTravelInformationTransitAirlineAncillaryInformation**](Ptsv2paymentsTravelInformationTransitAirlineAncillaryInformation.md) |  | [optional] 
**flightType** | **String** | Specifies the type of flight. One way (0) Return (1) Transit (2) Transit & Return (3) Multi-City (4)  | [optional] 
**insuranceAmount** | **String** | The total cost of the flight insurance. Example: 10000.00  | [optional] 
**frequentFlyerNumber** | **String** | The consumer's frequent flyer number. Leave 0 if there is no frequent flyer number  | [optional] 
**thirdPartyStatus** | **String** | Specifies if the travel agent joins the flight (0) or not (1)  | [optional] 
**passengerType** | **String** | List of passenger types in a booking code: A (Adult) C (Child) Comma separated values for total number of passenger  | [optional] 
**totalInsuranceAmount** | **String** | Total insurance amount. We have per leg and not total  | [optional] 


