# CyberSource.RiskV1DecisionsPost201ResponseConsumerAuthenticationInformation

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**accessToken** | **String** | JSON Web Token (JWT) used to authenticate the consumer with the authentication provider, such as, CardinalCommerce or Rupay. Note - Max Length of this field is 2048 characters.  | [optional] 
**acsRenderingType** | **String** | Identifies the UI Type the ACS will use to complete the challenge. **NOTE**: Only available for App transactions using the Cardinal Mobile SDK.  | [optional] 
**acsTransactionId** | **String** | Unique transaction identifier assigned by the ACS to identify a single transaction.  | [optional] 
**acsUrl** | **String** | URL for the card-issuing bank's authentication form that you receive when the card is enrolled. The value can be very large.  | [optional] 
**authenticationPath** | **String** | Indicates what displays to the customer during the authentication process. This field can contain one of these values: - `ADS`: (Card not enrolled) customer prompted to activate the card during the checkout process. - `ATTEMPTS`: (Attempts processing) Processing briefly displays before the checkout process is completed. - `ENROLLED`: (Card enrolled) the card issuer's authentication window displays. - `UNKNOWN`: Card enrollment status cannot be determined. - `NOREDIRECT`: (Card not enrolled, authentication unavailable, or error occurred) nothing displays to the customer.  The following values can be returned if you are using rules-based payer authentication. - `RIBA`: The card-issuing bank supports risk-based authentication, but whether the cardholder is likely to be challenged cannot be determined. - `RIBA_PASS`: The card-issuing bank supports risk-based authentication and it is likely that the cardholder will not be challenged to provide credentials, also known as _silent authentication_.  | [optional] 
**authorizationPayload** | **String** | The Base64 encoded JSON Payload of CB specific Authorization Values returned in the challenge Flow  | [optional] 
**authenticationType** | **String** | Indicates the type of authentication that will be used to challenge the card holder.  Possible Values:  01 - Static  02 - Dynamic  03 - OOB (Out of Band)  04 - Decoupled  20 - OTP hosted at merchant end. (Rupay S2S flow) **NOTE**:  EMV 3-D Secure version 2.1.0 supports values 01-03.  Version 2.2.0 supports values 01-04.  Decoupled authentication is not supported at this time.  | [optional] 
**authenticationTransactionId** | **String** | Payer authentication transaction identifier is used to link the check enrollment and validate authentication messages. For Rupay, this field should be passed as request only for Resend OTP use case.  | [optional] 
**authenticationTransactionContextId** | **String** | Payer authentication transaction identifier passed to link the validation and authorization calls.  | [optional] 
**validityPeriod** | **Number** | Describes validity of OTP in minutes for incoming transaction.        .  | [optional] 
**cardholderMessage** | **String** | Text provided by the ACS/Issuer to Cardholder during a Frictionless or Decoupled transaction.The Issuer can provide information to Cardholder. For example, \"Additional authentication is needed for this transaction, please contact (Issuer Name) at xxx-xxx-xxxx.\". The Issuing Bank can optionally support this value.  | [optional] 
**cavv** | **String** | Unique identifier generated by the card-issuing bank for Visa, American Express, JCB, Diners Club, and Discover transactions after the customer is authenticated. The value is in base64. When you request the card authorization service, CyberSource automatically converts the value, not the field name, to the format required by your payment processor.  | [optional] 
**cavvAlgorithm** | **String** | Field that is returned only when the CAVV is generated, which occurs when paresStatus contains the values Y (successful authentication) or A (attempted authentication). If you use the ATOS processor, send the value of this field in the `cavv_algorithm` request field of the authorization service. This field contains one of these values: - `2`: Visa, American Express, JCB, Diners Club, and Discover - `3`: Mastercard  | [optional] 
**challengeCancelCode** | **String** | An indicator as to why the transaction was canceled. Possible Values:  - `01`: Cardholder selected Cancel. - `02`: Reserved for future EMVCo use (values invalid until defined by EMVCo). - `03`: Transaction Timed Out—Decoupled Authentication - `04`: Transaction timed out at ACS—other timeouts - `05`: Transaction Timed out at ACS - First CReq not received by ACS - `06`: Transaction Error - `07`: Unknown - `08`: Transaction Timed Out at SDK  | [optional] 
**challengeRequired** | **String** | Indicates whether a challenge is required in order to complete authentication. **Note** Regional mandates might determine that a challenge is required.  Possible values: - `Y`: Challenge required - `N`: Challenge not required **Note**  Used by the Hybrid integration.  | [optional] 
**decoupledAuthenticationIndicator** | **String** | Indicates whether the 3DS Requestor requests the ACS to utilize Decoupled Authentication and agrees to utilize Decoupled Authentication if the ACS confirms its use.  Possible Values:  Y - Decoupled Authentication is supported and preferred if challenge is necessary  N - Do not use Decoupled Authentication  **Default Value**: N  | [optional] 
**directoryServerErrorCode** | **String** | The directory server error code indicating a problem with this transaction. Note - Max Length of this field is typically 3 characters.  | [optional] 
**directoryServerErrorDescription** | **String** | Directory server text and additional detail about the error for this transaction.  | [optional] 
**ecommerceIndicator** | **String** | Commerce indicator for cards not enrolled. This field contains one of these values: - `internet`: Card not enrolled, or card type not supported by payer authentication. No liability shift. - `js_attempted`: Card not enrolled, but attempt to authenticate is recorded. Liability shift. - `js_failure`: J/Secure directory service is not available. No liability shift. - `spa`: Mastercard card not enrolled in the SecureCode program. No liability shift. - `vbv_attempted`: Card not enrolled, but attempt to authenticate is recorded. Liability shift. - `vbv_failure`: For payment processor Barclays, Streamline, AIBMS, or FDC Germany, you receive this result if Visa's directory service is not available. No liability shift.  | [optional] 
**eci** | **String** | Note This field applies only to non-U.S-issued cards.  For enroll, Numeric electronic commerce indicator (ECI) returned only for Visa, American Express, JCB, Diners Club, and Discover transactions when the card is not enrolled. For more information, see \"Interpreting the Reply,\" page 22.  If you are not using the CyberSource payment services, you must send this value to your payment processor in the subsequent request for card authorization. This field contains one of these values: - `06`: The card can be enrolled. Liability shift. - `07`: The card cannot be enrolled. No liability shift.  For validate, Numeric electronic commerce indicator (ECI) returned only for Visa, American Express, JCB, Diners Club, and Discover transactions. The field is absent when authentication fails. You must send this value to your payment processor in the subsequent request for card authorization. This field contains one of these values: - `05`: Successful authentication - `06`: Authentication attempted - `07`: Failed authentication (No response from the merchant because of a problem.)  | [optional] 
**eciRaw** | **String** | ECI value that can be returned for Visa, Mastercard, American Express, JCB, Diners Club, and Discover. The field is absent when authentication fails. If your payment processor is Streamline, you must pass the value of this field instead of the value of `eci` or `ucafCollectionIndicator`.  This field can contain one of these values: - `01`: Authentication attempted (Mastercard) - `02`: Successful authentication (Mastercard) - `05`: Successful authentication (Visa, American Express, JCB, Diners Club, and Discover) - `06`: Authentication attempted (Visa, American Express, JCB, Diners Club, and Discover)  | [optional] 
**effectiveAuthenticationType** | **String** | This field describes the type of 3DS transaction flow that took place.  It can be one of three possible flows; CH - Challenge FR - Frictionless FD - Frictionless with delegation, (challenge not generated by the issuer but by the scheme on behalf of the issuer).  | [optional] 
**exemptionDataRaw** | **String** | Payer authentication exemption indicator for Carte Bancaire exemptions.  This is used with unbundled authentication and authorizations calls, for example: \"low fraud merchant program\". The value returned in this field should be passed in the authorization request under the field - `consumerAuthenticationInformation.strongAuthentication.issuerInformation.exemptionDataRaw`.  | [optional] 
**ivr** | [**PtsV2PaymentsPost201ResponseConsumerAuthenticationInformationIvr**](PtsV2PaymentsPost201ResponseConsumerAuthenticationInformationIvr.md) |  | [optional] 
**networkScore** | **String** | The global score calculated by the CB scoring platform and returned to merchants.  | [optional] 
**pareq** | **String** | Payer authentication request (PAReq) message that you need to forward to the ACS. The value can be very large. The value is in base64.  | [optional] 
**paresStatus** | **String** | Raw result of the authentication check. If you are configured for Asia, Middle East, and Africa Gateway Processing, you need to send the value of this field in your authorization request. This field can contain one of these values: - `A`: Proof of authentication attempt was generated. - `N`: Customer failed or canceled authentication. Transaction denied. - `U`: Authentication not completed regardless of the reason. - `Y`: Customer was successfully authenticated.  | [optional] 
**proofXml** | **String** | Date and time of the enrollment check combined with the VEReq and VERes elements. If you ever need to show proof of enrollment checking, you may need to parse the string for the information required by the payment card company. The value can be very large.  For cards issued in the U.S. or Canada, Visa may require this data for specific merchant category codes.For cards not issued in the U.S. or Canada, your bank may require this data as proof of enrollment checking for any payer authentication transaction that you re-present because of a chargeback.  | [optional] 
**proxyPan** | **String** | Encrypted version of the card number used in the payer authentication request message.  | [optional] 
**sdkTransactionId** | **String** | SDK unique transaction identifier that is generated on each new transaction.  | [optional] 
**signedParesStatusReason** | **String** | Provides additional information as to why the PAResStatus has a specific value.  | [optional] 
**specificationVersion** | **String** | This field contains the 3D Secure version that was used to process the transaction. For example: 2.2.0  | [optional] 
**stepUpUrl** | **String** | The fully qualified URL that the merchant uses to post a form to the cardholder in order to complete the Consumer Authentication transaction for the Cardinal Cruise API integration.  | [optional] 
**threeDSServerTransactionId** | **String** | Unique transaction identifier assigned by the 3DS Server to identify a single transaction.  | [optional] 
**ucafAuthenticationData** | **String** | AAV is a unique identifier generated by the card-issuing bank for Mastercard Identity Check transactions after the customer is authenticated. The value is in base64. Include the data in the card authorization request.  | [optional] 
**ucafCollectionIndicator** | **String** | For enroll, Returned only for Mastercard transactions. Indicates that authentication is not required because the customer is not enrolled. Add the value of this field to the authorization field ucaf_collection_indicator. This field can contain these values: 0, 1.  For validate, Numeric electronic commerce indicator (ECI) returned only for Mastercard Identity Check transactions. The field is absent when authentication fails. You must send this value to your payment processor in the request for card authorization. This field contain one of these values: - `0`: Authentication data not collected, and customer authentication was not completed. - `1`: Authentication data not collected because customer authentication was not completed. - `2`: Authentication data collected because customer completed authentication.  | [optional] 
**veresEnrolled** | **String** | Result of the enrollment check. This field can contain one of these values: - `Y`: Card enrolled or can be enrolled; you must authenticate. Liability shift. - `N`: Card not enrolled; proceed with authorization. Liability shift. - `U`: Unable to authenticate regardless of the reason. No liability shift.  **Note** This field only applies to the Asia, Middle East, and Africa Gateway. If you are configured for this processor, you must send the value of this field in your authorization request.  The following value can be returned if you are using rules-based Payer Authentication: - `B`: Indicates that authentication was bypassed.  | [optional] 
**whiteListStatusSource** | **String** | This data element will be populated by the system setting Whitelist Status. Possible Values: 01 - 3DS/ Server/ 02 – DS/03 - ACS  | [optional] 
**xid** | **String** | Transaction identifier generated by CyberSource for successful enrollment or validation checks. Use this value, which is in base64, to match an outgoing PAReq with an incoming PARes. CyberSource forwards the XID with the card authorization service to these payment processors in these cases: - Barclays - Streamline (when the **ecommerceIndicator**`=spa`)  | [optional] 
**directoryServerTransactionId** | **String** | The Directory Server Transaction ID is generated by the Mastercard Directory Server during the authentication transaction and passed back to the merchant with the authentication results. For Cybersource Through Visanet Gateway: The value for this field corresponds to the following data in the TC 33 capture file3: Record: CP01 TCR7, Position: 114-149, Field: MC AVV Verification—Directory Server Transaction ID  | [optional] 
**acsOperatorID** | **String** | Directory Server assigned ACS identifier. | [optional] 
**acsReferenceNumber** | **String** | Unique identifier assigned by the EMVCo Secretariat upon Testing and Approval. | [optional] 
**idciDecision** | **String** | Decision on the Risk Assessment from Mastercard. | [optional] 
**idciReasonCode1** | **String** | ReasonCode from Mastercard | [optional] 
**idciReasonCode2** | **String** | ReasonCode from Mastercard | [optional] 
**idciScore** | **Number** | Risk Assessment from Mastercard | [optional] 


