# CyberSource.TokenizedcardRequest

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**links** | [**Tmsv2TokenizedCardLinks**](Tmsv2TokenizedCardLinks.md) |  | [optional] 
**id** | **String** | The Id of the Tokenized Card.  | [optional] 
**_object** | **String** | The type. Possible Values: - tokenizedCard  | [optional] 
**accountReferenceId** | **String** | An identifier provided by the issuer for the account.  | [optional] 
**consumerId** | **String** | Identifier of the consumer within the wallet. Maximum 24 characters for VTS. | [optional] 
**createInstrumentIdentifier** | **Boolean** | Specifies whether the InstrumentId should be created (true) or not (false). Possible Values: - `true`: The InstrumentId should be created. - `false`: The InstrumentId should be created.  | [optional] 
**source** | **String** | Source of the payment instrument. Possible Values: - ONFILE - TOKEN - ISSUER  | [optional] 
**state** | **String** | State of the network token or network token provision. Possible Values:   ACTIVE : Network token is active.   SUSPENDED : Network token is suspended. This state can change back to ACTIVE.   DELETED : This is a final state for a network token instance.   UNPROVISIONED : A previous network token.  | [optional] 
**reason** | **String** | Issuers state for the network token Possible Values: - INVALID_REQUEST : The network token provision request contained invalid data. - CARD_VERIFICATION_FAILED : The network token provision request contained data that could not be verified. - CARD_NOT_ELIGIBLE : Card can currently not be used with issuer for tokenization. - CARD_NOT_ALLOWED : Card can currently not be used with card association for tokenization. - DECLINED : Card can currently not be used with issuer for tokenization. - SERVICE_UNAVAILABLE : The network token service was unavailable or timed out. - SYSTEM_ERROR : An unexpected error occurred with network token service, check configuration.  | [optional] 
**_number** | **String** | The token requestor's network token for the provided PAN and consumer Id, if available.  | [optional] 
**expirationMonth** | **String** | Two-digit month in which the network token expires. Format: `MM`. Possible Values: `01` through `12`.  | [optional] 
**expirationYear** | **String** | Four-digit year in which the network token expires. Format: `YYYY`.  | [optional] 
**type** | **String** | The type of card (Card Network). Possible Values: - visa - mastercard - americanexpress  | [optional] 
**cryptogram** | **String** | Value generated by the card association to be used alongside the network token for processing a payment.  | [optional] 
**securityCode** | **String** | 4-digit number generated by the card association to be used alogside the network token for processing a payment. Only supported for Amex and SCOF.  | [optional] 
**eci** | **String** | Raw Electronic Commerce Indicator provided by the card association with the result of the cardholder authentication.  | [optional] 
**requestorId** | **String** | 11-digit identifier that uniquely identifies the Token Requestor.  | [optional] 
**enrollmentId** | **String** | Unique id to identify this PAN/ enrollment.  | [optional] 
**tokenReferenceId** | **String** | Unique ID for netwrok token.  | [optional] 
**paymentAccountReference** | **String** | Payment account reference.  | [optional] 
**card** | [**Tmsv2TokenizedCardCard**](Tmsv2TokenizedCardCard.md) |  | [optional] 
**passcode** | [**Tmsv2TokenizedCardPasscode**](Tmsv2TokenizedCardPasscode.md) |  | [optional] 
**metadata** | [**Tmsv2TokenizedCardMetadata**](Tmsv2TokenizedCardMetadata.md) |  | [optional] 


