/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Binv1binlookupProcessingInformationPayoutOptions = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Binv1binlookupProcessingInformationPayoutOptions model module.
   * @module model/Binv1binlookupProcessingInformationPayoutOptions
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Binv1binlookupProcessingInformationPayoutOptions</code>.
   * Payout fields request parameters 
   * @alias module:model/Binv1binlookupProcessingInformationPayoutOptions
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>Binv1binlookupProcessingInformationPayoutOptions</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Binv1binlookupProcessingInformationPayoutOptions} obj Optional instance to populate.
   * @return {module:model/Binv1binlookupProcessingInformationPayoutOptions} The populated <code>Binv1binlookupProcessingInformationPayoutOptions</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('payoutInquiry')) {
        obj['payoutInquiry'] = ApiClient.convertToType(data['payoutInquiry'], 'Boolean');
      }
      if (data.hasOwnProperty('networkId')) {
        obj['networkId'] = ApiClient.convertToType(data['networkId'], 'String');
      }
      if (data.hasOwnProperty('acquirerBin')) {
        obj['acquirerBin'] = ApiClient.convertToType(data['acquirerBin'], 'String');
      }
    }
    return obj;
  }

  /**
   * If `true` then provide attributes related to fund transfer/payouts. If payout information not found then response will have standard account lookup.  Possible values: - true - false 
   * @member {Boolean} payoutInquiry
   */
  exports.prototype['payoutInquiry'] = undefined;
  /**
   * The networks specified in this field must be a subset of the information provided during program enrollment    Possible values: - 0020 : Accel/Exchange - 0024 : CU24 - 0003 : Interlink - 0016 : Maestro - 0018 : NYCE - 0027 : NYCE - 0009 : Pulse - 0017 : Pulse - 0019 : Pulse - 0008 : Star - 0010 : Star - 0011 : Star - 0012 : Star - 0015 : Star - 0002 : Visa/PLUS 
   * @member {String} networkId
   */
  exports.prototype['networkId'] = undefined;
  /**
   * BIN under which the Funds Transfer application is registered. This must match the information provided during enrollment. 
   * @member {String} acquirerBin
   */
  exports.prototype['acquirerBin'] = undefined;



  return exports;
}));


