/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Boardingv1registrationsOrganizationInformationBusinessInformationAddress = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Boardingv1registrationsOrganizationInformationBusinessInformationAddress model module.
   * @module model/Boardingv1registrationsOrganizationInformationBusinessInformationAddress
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Boardingv1registrationsOrganizationInformationBusinessInformationAddress</code>.
   * @alias module:model/Boardingv1registrationsOrganizationInformationBusinessInformationAddress
   * @class
   * @param country {String} 
   * @param address1 {String} 
   * @param locality {String} City of the billing address.
   */
  var exports = function(country, address1, locality) {
    var _this = this;

    _this['country'] = country;
    _this['address1'] = address1;

    _this['locality'] = locality;


  };

  /**
   * Constructs a <code>Boardingv1registrationsOrganizationInformationBusinessInformationAddress</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Boardingv1registrationsOrganizationInformationBusinessInformationAddress} obj Optional instance to populate.
   * @return {module:model/Boardingv1registrationsOrganizationInformationBusinessInformationAddress} The populated <code>Boardingv1registrationsOrganizationInformationBusinessInformationAddress</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('country')) {
        obj['country'] = ApiClient.convertToType(data['country'], 'String');
      }
      if (data.hasOwnProperty('address1')) {
        obj['address1'] = ApiClient.convertToType(data['address1'], 'String');
      }
      if (data.hasOwnProperty('address2')) {
        obj['address2'] = ApiClient.convertToType(data['address2'], 'String');
      }
      if (data.hasOwnProperty('locality')) {
        obj['locality'] = ApiClient.convertToType(data['locality'], 'String');
      }
      if (data.hasOwnProperty('administrativeArea')) {
        obj['administrativeArea'] = ApiClient.convertToType(data['administrativeArea'], 'String');
      }
      if (data.hasOwnProperty('postalCode')) {
        obj['postalCode'] = ApiClient.convertToType(data['postalCode'], 'String');
      }
    }
    return obj;
  }

  /**
   * @member {String} country
   */
  exports.prototype['country'] = undefined;
  /**
   * @member {String} address1
   */
  exports.prototype['address1'] = undefined;
  /**
   * @member {String} address2
   */
  exports.prototype['address2'] = undefined;
  /**
   * City of the billing address.
   * @member {String} locality
   */
  exports.prototype['locality'] = undefined;
  /**
   * State or province of the billing address. Required for United States and Canada.
   * @member {String} administrativeArea
   */
  exports.prototype['administrativeArea'] = undefined;
  /**
   * Postal code for the billing address. The postal code must consist of 5 to 9 digits. Required for United States and Canada.
   * @member {String} postalCode
   */
  exports.prototype['postalCode'] = undefined;



  return exports;
}));


