/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Boardingv1registrationsRegistrationInformation = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Boardingv1registrationsRegistrationInformation model module.
   * @module model/Boardingv1registrationsRegistrationInformation
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Boardingv1registrationsRegistrationInformation</code>.
   * @alias module:model/Boardingv1registrationsRegistrationInformation
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>Boardingv1registrationsRegistrationInformation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Boardingv1registrationsRegistrationInformation} obj Optional instance to populate.
   * @return {module:model/Boardingv1registrationsRegistrationInformation} The populated <code>Boardingv1registrationsRegistrationInformation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('boardingRegistrationId')) {
        obj['boardingRegistrationId'] = ApiClient.convertToType(data['boardingRegistrationId'], 'String');
      }
      if (data.hasOwnProperty('submitTimeUtc')) {
        obj['submitTimeUtc'] = ApiClient.convertToType(data['submitTimeUtc'], 'Date');
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'String');
      }
      if (data.hasOwnProperty('boardingPackageId')) {
        obj['boardingPackageId'] = ApiClient.convertToType(data['boardingPackageId'], 'String');
      }
      if (data.hasOwnProperty('boardingFlow')) {
        obj['boardingFlow'] = ApiClient.convertToType(data['boardingFlow'], 'String');
      }
      if (data.hasOwnProperty('mode')) {
        obj['mode'] = ApiClient.convertToType(data['mode'], 'String');
      }
      if (data.hasOwnProperty('salesRepId')) {
        obj['salesRepId'] = ApiClient.convertToType(data['salesRepId'], 'String');
      }
    }
    return obj;
  }

  /**
   * @member {String} boardingRegistrationId
   */
  exports.prototype['boardingRegistrationId'] = undefined;
  /**
   * Time of request in UTC. `Format: YYYY-MM-DDThh:mm:ssZ`  Example 2016-08-11T22:47:57Z equals August 11, 2016, at 22:47:57 (10:47:57 p.m.). The T separates the date and the time. The Z indicates UTC. 
   * @member {Date} submitTimeUtc
   */
  exports.prototype['submitTimeUtc'] = undefined;
  /**
   * The status of Registration request Possible Values:   - 'PROCESSING': This status is for Registrations that are still in Progress, you can get the latest status by calling the GET endpoint using the Registration Id   - 'SUCCESS': This status is for Registrations that were successfull on every step of the on boarding process.   - 'FAILURE': This status is for Registrations that fail before the Organization was created; please refer to the details section in the reponse for more information.   - 'PARTIAL': This status is for Registrations that created the Organization successfully but fail in at least on step while configuring it; please refer to the details section in the response for more information. 
   * @member {String} status
   */
  exports.prototype['status'] = undefined;
  /**
   * @member {String} boardingPackageId
   */
  exports.prototype['boardingPackageId'] = undefined;
  /**
   * Determines the boarding flow for this registration. Possible Values:   - 'ENTERPRISE'   - 'SMB'   - 'ADDPRODUCT' 
   * @member {String} boardingFlow
   */
  exports.prototype['boardingFlow'] = undefined;
  /**
   * In case mode is not provided the API will use COMPLETE as default Possible Values:   - 'COMPLETE'   - 'PARTIAL' 
   * @member {String} mode
   */
  exports.prototype['mode'] = undefined;
  /**
   * @member {String} salesRepId
   */
  exports.prototype['salesRepId'] = undefined;



  return exports;
}));


