/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CardProcessingConfigCommonAcquirer', 'model/CardProcessingConfigCommonCurrencies1', 'model/CardProcessingConfigCommonPaymentTypes'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CardProcessingConfigCommonAcquirer'), require('./CardProcessingConfigCommonCurrencies1'), require('./CardProcessingConfigCommonPaymentTypes'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.CardProcessingConfigCommonProcessors = factory(root.CyberSource.ApiClient, root.CyberSource.CardProcessingConfigCommonAcquirer, root.CyberSource.CardProcessingConfigCommonCurrencies1, root.CyberSource.CardProcessingConfigCommonPaymentTypes);
  }
}(this, function(ApiClient, CardProcessingConfigCommonAcquirer, CardProcessingConfigCommonCurrencies1, CardProcessingConfigCommonPaymentTypes) {
  'use strict';




  /**
   * The CardProcessingConfigCommonProcessors model module.
   * @module model/CardProcessingConfigCommonProcessors
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>CardProcessingConfigCommonProcessors</code>.
   * @alias module:model/CardProcessingConfigCommonProcessors
   * @class
   * @param merchantId {String} Merchant ID assigned by an acquirer or a processor. Should not be overriden by any other party.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Min. Length</th><th>Max. Length</th><th>Regex</th></tr></thead> <tr><td>Barclays HISO</td><td>cp, cnp, hybrid</td><td>Yes</td><td>1</td><td>15</td><td>^[0-9a-zA-Z]+$</td></tr> <tr><td>Barclays</td><td>cp, cnp, hybrid</td><td>Yes</td><td>1</td><td>11</td><td>^[0-9a-zA-Z]+$</td></tr> </table> 
   */
  var exports = function(merchantId) {
    var _this = this;






    _this['merchantId'] = merchantId;









































  };

  /**
   * Constructs a <code>CardProcessingConfigCommonProcessors</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CardProcessingConfigCommonProcessors} obj Optional instance to populate.
   * @return {module:model/CardProcessingConfigCommonProcessors} The populated <code>CardProcessingConfigCommonProcessors</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('batchGroup')) {
        obj['batchGroup'] = ApiClient.convertToType(data['batchGroup'], 'String');
      }
      if (data.hasOwnProperty('businessApplicationId')) {
        obj['businessApplicationId'] = ApiClient.convertToType(data['businessApplicationId'], 'String');
      }
      if (data.hasOwnProperty('merchantVerificationValue')) {
        obj['merchantVerificationValue'] = ApiClient.convertToType(data['merchantVerificationValue'], 'String');
      }
      if (data.hasOwnProperty('abaNumber')) {
        obj['abaNumber'] = ApiClient.convertToType(data['abaNumber'], 'String');
      }
      if (data.hasOwnProperty('acquirer')) {
        obj['acquirer'] = CardProcessingConfigCommonAcquirer.constructFromObject(data['acquirer']);
      }
      if (data.hasOwnProperty('merchantId')) {
        obj['merchantId'] = ApiClient.convertToType(data['merchantId'], 'String');
      }
      if (data.hasOwnProperty('terminalId')) {
        obj['terminalId'] = ApiClient.convertToType(data['terminalId'], 'String');
      }
      if (data.hasOwnProperty('paymentTypes')) {
        obj['paymentTypes'] = ApiClient.convertToType(data['paymentTypes'], {'String': CardProcessingConfigCommonPaymentTypes});
      }
      if (data.hasOwnProperty('currencies')) {
        obj['currencies'] = ApiClient.convertToType(data['currencies'], {'String': CardProcessingConfigCommonCurrencies1});
      }
      if (data.hasOwnProperty('visaAggregatorId')) {
        obj['visaAggregatorId'] = ApiClient.convertToType(data['visaAggregatorId'], 'String');
      }
      if (data.hasOwnProperty('amexAggregatorId')) {
        obj['amexAggregatorId'] = ApiClient.convertToType(data['amexAggregatorId'], 'String');
      }
      if (data.hasOwnProperty('masterCardAggregatorId')) {
        obj['masterCardAggregatorId'] = ApiClient.convertToType(data['masterCardAggregatorId'], 'String');
      }
      if (data.hasOwnProperty('sicCode')) {
        obj['sicCode'] = ApiClient.convertToType(data['sicCode'], 'String');
      }
      if (data.hasOwnProperty('allowMultipleBills')) {
        obj['allowMultipleBills'] = ApiClient.convertToType(data['allowMultipleBills'], 'Boolean');
      }
      if (data.hasOwnProperty('allowMerchantDescriptorOverride')) {
        obj['allowMerchantDescriptorOverride'] = ApiClient.convertToType(data['allowMerchantDescriptorOverride'], 'Boolean');
      }
      if (data.hasOwnProperty('enhancedData')) {
        obj['enhancedData'] = ApiClient.convertToType(data['enhancedData'], 'String');
      }
      if (data.hasOwnProperty('fireSafetyIndicator')) {
        obj['fireSafetyIndicator'] = ApiClient.convertToType(data['fireSafetyIndicator'], 'Boolean');
      }
      if (data.hasOwnProperty('quasiCash')) {
        obj['quasiCash'] = ApiClient.convertToType(data['quasiCash'], 'Boolean');
      }
      if (data.hasOwnProperty('acquirerMerchantId')) {
        obj['acquirerMerchantId'] = ApiClient.convertToType(data['acquirerMerchantId'], 'String');
      }
      if (data.hasOwnProperty('avsFormat')) {
        obj['avsFormat'] = ApiClient.convertToType(data['avsFormat'], 'String');
      }
      if (data.hasOwnProperty('enableLongTransRefNo')) {
        obj['enableLongTransRefNo'] = ApiClient.convertToType(data['enableLongTransRefNo'], 'Boolean');
      }
      if (data.hasOwnProperty('enableLevel2')) {
        obj['enableLevel2'] = ApiClient.convertToType(data['enableLevel2'], 'Boolean');
      }
      if (data.hasOwnProperty('enableMultipleTransactionAdviceAddendum')) {
        obj['enableMultipleTransactionAdviceAddendum'] = ApiClient.convertToType(data['enableMultipleTransactionAdviceAddendum'], 'Boolean');
      }
      if (data.hasOwnProperty('amexTransactionAdviceAddendum1')) {
        obj['amexTransactionAdviceAddendum1'] = ApiClient.convertToType(data['amexTransactionAdviceAddendum1'], 'String');
      }
      if (data.hasOwnProperty('enableMultiLineItems')) {
        obj['enableMultiLineItems'] = ApiClient.convertToType(data['enableMultiLineItems'], 'Boolean');
      }
      if (data.hasOwnProperty('enableTransactionReferenceNumber')) {
        obj['enableTransactionReferenceNumber'] = ApiClient.convertToType(data['enableTransactionReferenceNumber'], 'Boolean');
      }
      if (data.hasOwnProperty('enableAutoAuthReversalAfterVoid')) {
        obj['enableAutoAuthReversalAfterVoid'] = ApiClient.convertToType(data['enableAutoAuthReversalAfterVoid'], 'Boolean');
      }
      if (data.hasOwnProperty('enableExpresspayPanTranslation')) {
        obj['enableExpresspayPanTranslation'] = ApiClient.convertToType(data['enableExpresspayPanTranslation'], 'Boolean');
      }
      if (data.hasOwnProperty('enableCreditAuth')) {
        obj['enableCreditAuth'] = ApiClient.convertToType(data['enableCreditAuth'], 'Boolean');
      }
      if (data.hasOwnProperty('industryCode')) {
        obj['industryCode'] = ApiClient.convertToType(data['industryCode'], 'String');
      }
      if (data.hasOwnProperty('sendAmexLevel2Data')) {
        obj['sendAmexLevel2Data'] = ApiClient.convertToType(data['sendAmexLevel2Data'], 'Boolean');
      }
      if (data.hasOwnProperty('softDescriptorType')) {
        obj['softDescriptorType'] = ApiClient.convertToType(data['softDescriptorType'], 'String');
      }
      if (data.hasOwnProperty('vitalNumber')) {
        obj['vitalNumber'] = ApiClient.convertToType(data['vitalNumber'], 'String');
      }
      if (data.hasOwnProperty('bankNumber')) {
        obj['bankNumber'] = ApiClient.convertToType(data['bankNumber'], 'String');
      }
      if (data.hasOwnProperty('chainNumber')) {
        obj['chainNumber'] = ApiClient.convertToType(data['chainNumber'], 'String');
      }
      if (data.hasOwnProperty('merchantBinNumber')) {
        obj['merchantBinNumber'] = ApiClient.convertToType(data['merchantBinNumber'], 'String');
      }
      if (data.hasOwnProperty('merchantLocationNumber')) {
        obj['merchantLocationNumber'] = ApiClient.convertToType(data['merchantLocationNumber'], 'String');
      }
      if (data.hasOwnProperty('storeID')) {
        obj['storeID'] = ApiClient.convertToType(data['storeID'], 'String');
      }
      if (data.hasOwnProperty('travelAgencyCode')) {
        obj['travelAgencyCode'] = ApiClient.convertToType(data['travelAgencyCode'], 'String');
      }
      if (data.hasOwnProperty('travelAgencyName')) {
        obj['travelAgencyName'] = ApiClient.convertToType(data['travelAgencyName'], 'String');
      }
      if (data.hasOwnProperty('settlementCurrency')) {
        obj['settlementCurrency'] = ApiClient.convertToType(data['settlementCurrency'], 'String');
      }
      if (data.hasOwnProperty('enableLeastCostRouting')) {
        obj['enableLeastCostRouting'] = ApiClient.convertToType(data['enableLeastCostRouting'], 'Boolean');
      }
      if (data.hasOwnProperty('enableCVVResponseIndicator')) {
        obj['enableCVVResponseIndicator'] = ApiClient.convertToType(data['enableCVVResponseIndicator'], 'Boolean');
      }
      if (data.hasOwnProperty('enableMultiCurrencyProcessing')) {
        obj['enableMultiCurrencyProcessing'] = ApiClient.convertToType(data['enableMultiCurrencyProcessing'], 'String');
      }
      if (data.hasOwnProperty('enablePosNetworkSwitching')) {
        obj['enablePosNetworkSwitching'] = ApiClient.convertToType(data['enablePosNetworkSwitching'], 'Boolean');
      }
      if (data.hasOwnProperty('enableDynamicCurrencyConversion')) {
        obj['enableDynamicCurrencyConversion'] = ApiClient.convertToType(data['enableDynamicCurrencyConversion'], 'Boolean');
      }
      if (data.hasOwnProperty('merchantTier')) {
        obj['merchantTier'] = ApiClient.convertToType(data['merchantTier'], 'String');
      }
    }
    return obj;
  }

  /**
   * Determines the batching group that separates merchants for special batching times. Batching groups can separate merchant batches by the following criteria:  * Timezone * Merchant deadlines * Large merchants (top 10) * Merchants with Service-Level Agreements  Applicable for Chase Paymentech Salem (chasepaymentechsalem), Streamline (streamline2), Six (six), Barclays (barclays2), Paymentech Tampa (paymentechtampa), CMCIC (cmcic), FDC Nashville (smartfdc), RUPAY, American Express Direct (amexdirect), GPN (gpn), VPC, GPX (gpx), CB2A, Barclays HISO (barclayshiso), TSYS (tsys) and FDI Global (fdiglobal) processors.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th></tr></thead> <tr><td>Barclays</td><td>cnp, cp, hybrid</td><td>Yes</td></tr> <tr><td>Barclays HISO</td><td>cnp, cp, hybrid</td><td>Yes</td></tr> <tr><td>American Express Direct</td><td>cnp, cp, hybrid</td><td>No</td></tr> </table> 
   * @member {String} batchGroup
   */
  exports.prototype['batchGroup'] = undefined;
  /**
   * Indicates the type of money transfer used in the transaction. Applicable for VPC and GPX (gpx) processors.
   * @member {String} businessApplicationId
   */
  exports.prototype['businessApplicationId'] = undefined;
  /**
   * Identify merchants that participate in Select Merchant Fee (SMF) programs. Unique to the merchant. Applicable for GPX (gpx) and VPC processors.
   * @member {String} merchantVerificationValue
   */
  exports.prototype['merchantVerificationValue'] = undefined;
  /**
   * Routing Number to identify banks within the United States. Applicable for GPX (gpx) processors.
   * @member {String} abaNumber
   */
  exports.prototype['abaNumber'] = undefined;
  /**
   * @member {module:model/CardProcessingConfigCommonAcquirer} acquirer
   */
  exports.prototype['acquirer'] = undefined;
  /**
   * Merchant ID assigned by an acquirer or a processor. Should not be overriden by any other party.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Min. Length</th><th>Max. Length</th><th>Regex</th></tr></thead> <tr><td>Barclays HISO</td><td>cp, cnp, hybrid</td><td>Yes</td><td>1</td><td>15</td><td>^[0-9a-zA-Z]+$</td></tr> <tr><td>Barclays</td><td>cp, cnp, hybrid</td><td>Yes</td><td>1</td><td>11</td><td>^[0-9a-zA-Z]+$</td></tr> </table> 
   * @member {String} merchantId
   */
  exports.prototype['merchantId'] = undefined;
  /**
   * The 'Terminal Id' aka TID, is an identifier used for with your payments processor. Depending on the processor and payment acceptance type this may also be the default Terminal ID used for Card Present and Virtual Terminal transactions.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Min. Length</th><th>Max. Length</th><th>Regex</th></tr></thead> <tr><td>Barclays HISO</td><td>cnp, hybrid</td><td>Yes</td><td>1</td><td>16</td><td>^[0-9a-zA-Z]+$</td></tr> <tr><td>Barclays HISO</td><td>cp</td><td>No</td><td>1</td><td>16</td><td>^[0-9a-zA-Z]+$</td></tr> </table> 
   * @member {String} terminalId
   */
  exports.prototype['terminalId'] = undefined;
  /**
   * Valid values are: * VISA * MASTERCARD * AMERICAN_EXPRESS * CUP * EFTPOS * DINERS_CLUB * DISCOVER * JCB 
   * @member {Object.<String, module:model/CardProcessingConfigCommonPaymentTypes>} paymentTypes
   */
  exports.prototype['paymentTypes'] = undefined;
  /**
   * Three-character [ISO 4217 ALPHA-3 Standard Currency Codes.](http://apps.cybersource.com/library/documentation/sbc/quickref/currencies.pdf)
   * @member {Object.<String, module:model/CardProcessingConfigCommonCurrencies1>} currencies
   */
  exports.prototype['currencies'] = undefined;
  /**
   * This field is used as aggregator Id when Visa payment type is selected
   * @member {String} visaAggregatorId
   */
  exports.prototype['visaAggregatorId'] = undefined;
  /**
   * This field is used as aggregator Id when Amex payment type is selected
   * @member {String} amexAggregatorId
   */
  exports.prototype['amexAggregatorId'] = undefined;
  /**
   * This field is used as aggregator Id when Master Card payment type is selected
   * @member {String} masterCardAggregatorId
   */
  exports.prototype['masterCardAggregatorId'] = undefined;
  /**
   * The Standard Industrial Classification (SIC) are four-digit codes that categorize the industries that companies belong to based on their business activities. Standard Industrial Classification codes were mostly replaced by the six-digit North American Industry Classification System (NAICS). Applicable for VPC and GPX (gpx) processors.
   * @member {String} sicCode
   */
  exports.prototype['sicCode'] = undefined;
  /**
   * Allows multiple captures for a single authorization transaction. Applicable for Paymentech Tampa (paymentechtampa), VPC, American Express Direct (amexdirect) and GPX (gpx) processors.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Default Value</th></tr></thead> <tr><td>American Express Direct</td><td>cp, hybrid</td><td>Yes</td><td>No</td></tr> <tr><td>American Express Direct</td><td>cnp</td><td>No</td><td>No</td></tr> </table> 
   * @member {Boolean} allowMultipleBills
   */
  exports.prototype['allowMultipleBills'] = undefined;
  /**
   * Enables partner to enable/disable merchant descriptors values. Applicable for VPC, EFTPOS and CUP processors.
   * @member {Boolean} allowMerchantDescriptorOverride
   */
  exports.prototype['allowMerchantDescriptorOverride'] = undefined;
  /**
   * To enable airline transactions. Applicable for TSYS (tsys), VPC, Elavon Americas (elavonamericas), FDI Global (fdiglobal), GPX (gpx), Barclays (barclays2) and American Express Direct (amexdirect) processors.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th></tr></thead> <tr><td>Barclays</td><td>cnp, cp, hybrid</td><td>No</td></tr> <tr><td>American Express Direct</td><td>cp, cnp, hybrid</td><td>No</td></tr> </table> 
   * @member {String} enhancedData
   */
  exports.prototype['enhancedData'] = undefined;
  /**
   * Indicates whether the merchant is compliant with Hotel and Motel Fire Safety Act of 1990. Applicable for GPX (gpx) and VPC processors.
   * @member {Boolean} fireSafetyIndicator
   */
  exports.prototype['fireSafetyIndicator'] = undefined;
  /**
   * To enable quasi-cash transactions. A quasi-cash transaction is a cash-like transaction for the sale of items that are directly convertible to cash, such as:- Casino gaming chips, Money orders, Wire transfers.  Applicable for GPX (gpx), TSYS (tsys), Barclays (barclays2) and VPC processors.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Default Value</th></tr></thead> <tr><td>Barclays</td><td>cnp, cp, hybrid</td><td>No</td><td>No</td></tr> </table> 
   * @member {Boolean} quasiCash
   */
  exports.prototype['quasiCash'] = undefined;
  /**
   * Identifier assigned by the acquirer. Applicable for RUPAY, VPC and Six (six) processors.
   * @member {String} acquirerMerchantId
   */
  exports.prototype['acquirerMerchantId'] = undefined;
  /**
   * Enables Enhanced AVS/Automated Address Verification Plus (AAV+).  Valid values: \"basic\" - Standard address verification system.   When a processor supports AVS for a transaction's card type, the issuing bank uses AVS to confirm that the customer has provided the correct billing address.   When a customer provides incorrect information, the transaction might be fraudulent. \"basic + name\" - Enhanced address verification system.   Consists of the standard AVS functionality plus verification of some additional fields.   The additional fields that are verified for Enhanced AVS are:   - customer_firstname   - customer_lastname \"basic + name + shipto\" - Automated address verification plus.   Consists of the Enhanced AVS functionality plus verification of some additional fields.   AAV+ intended for merchants who deliver physical goods to a different address than the billing address.   AAV+ verifies the additional fields only when the standard and Enhanced AVS tests pass first.   For information about Enhanced AVS - The additional fields that are verified for AAV+ are:   - ship_to_firstname   - ship_to_lastname   - ship_to_address1   - ship_to_country   - ship_to_zip   - ship_to_phone   - customer_phone(American Express Direct only)  Applicable for American Express Direct (amexdirect) processor.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Default Value</th></tr></thead> <tr><td>American Express Direct</td><td>cnp, cp, hybrid</td><td>Yes</td><td>basic</td></tr> </table> 
   * @member {String} avsFormat
   */
  exports.prototype['avsFormat'] = undefined;
  /**
   * Amex Direct specific merchant config value which determines what length (either 9 or Unique 12-char reference number) of reference number will be CYBS generated if the merchant does not pass in a trans_ref_no. Can be any combination of alpha, numeric and special characters, and/or binary data in hexadecimal.  Applicable for American Express Direct (amexdirect) processor.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Default Value</th></tr></thead> <tr><td>American Express Direct</td><td>cp, cnp, hybrid</td><td>No</td><td>No</td></tr> </table> 
   * @member {Boolean} enableLongTransRefNo
   */
  exports.prototype['enableLongTransRefNo'] = undefined;
  /**
   * Field that indicates whether merchant will send level 2 data for Amex cards. Applicable for American Express Direct (amexdirect) processor.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Default Value</th></tr></thead> <tr><td>American Express Direct</td><td>cp, cnp, hybrid</td><td>No</td><td>No</td></tr> </table> 
   * @member {Boolean} enableLevel2
   */
  exports.prototype['enableLevel2'] = undefined;
  /**
   * This flag related to multiple transaction advice addendum field. It is used to display descriptive information about a transaction on customer's American Express card statement. Applicable for American Express Direct (amexdirect) processor.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Default Value</th></tr></thead> <tr><td>American Express Direct</td><td>cp, cnp, hybrid</td><td>No</td><td>No</td></tr> </table> 
   * @member {Boolean} enableMultipleTransactionAdviceAddendum
   */
  exports.prototype['enableMultipleTransactionAdviceAddendum'] = undefined;
  /**
   * Advice addendum field. It is used to display descriptive information about a transaction on customer's American Express card statement. Applicable for TSYS (tsys), FDI Global (fdiglobal) and American Express Direct (amexdirect) processors.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Min. Length</th><th>Max. Length</th><th>Regex</th></tr></thead> <tr><td>American Express Direct</td><td>cnp, cp, hybrid</td><td>No</td><td>1</td><td>40</td><td>^[0-9a-zA-Z&#92;-\\s.]+$</td></tr> </table> 
   * @member {String} amexTransactionAdviceAddendum1
   */
  exports.prototype['amexTransactionAdviceAddendum1'] = undefined;
  /**
   * This flag is related to offer/line item details to be included instead of sending one line item, and a grand total. Example, offer0, offer 1...offer n. Applicable for American Express Direct (amexdirect) and Elavon Americas (elavonamericas) processors.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Default Value</th></tr></thead> <tr><td>American Express Direct</td><td>cp, cnp, hybrid</td><td>No</td><td>No</td></tr> </table> 
   * @member {Boolean} enableMultiLineItems
   */
  exports.prototype['enableMultiLineItems'] = undefined;
  /**
   * To enable merchant to send in transaction reference number (unique reconciliation ID). Applicable for VPC, Vero (vero), FDI Global (fdiglobal), Six (six), CB2A, CUP, VPC, Chase Paymentech Salem (chasepaymentechsalem), Fiserv (fiserv), Elavon Americas (elavonamericas) and EFTPOS processors.
   * @member {Boolean} enableTransactionReferenceNumber
   */
  exports.prototype['enableTransactionReferenceNumber'] = undefined;
  /**
   * Enables to meet the Visa mandate requirements to reverse unused authorizations, benefitting the customer by releasing the hold on unused credit card funds. Applicable for CB2A, Elavon Americas (elavonamericas), Six (six), VPC and American Express Direct (amexdirect) processors.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Default Value</th></tr></thead> <tr><td>American Express Direct</td><td>cp, cnp, hybrid</td><td>No</td><td>No</td></tr> </table> 
   * @member {Boolean} enableAutoAuthReversalAfterVoid
   */
  exports.prototype['enableAutoAuthReversalAfterVoid'] = undefined;
  /**
   * When this is enabled, authorization responses from American Express expresspay transactions include the Primary Account Number (PAN) and expiration date of the card. Applicable for American Express Direct (amexdirect) processor.
   * @member {Boolean} enableExpresspayPanTranslation
   */
  exports.prototype['enableExpresspayPanTranslation'] = undefined;
  /**
   * Authorizes a credit. Reduces refund chargebacks and prevents customers from seeing the online update for credits which are otherwise offline settlements.
   * @member {Boolean} enableCreditAuth
   */
  exports.prototype['enableCreditAuth'] = undefined;
  /**
   * Field used to identify the industry type of the merchant submitting the authorization request.  Valid values: `0` – unknown or unsure `A` – auto rental (EMV supported) `B` – bank/financial institution (EMV supported) `D` – direct marketing `F` – food/restaurant (EMV supported) `G` – grocery store/super market (EMV supported) `H` – hotel (EMV supported) `L` – limited amount terminal (EMV supported) `O` – oil company/automated fueling system (EMV supported) `P` – passenger transport (EMV supported) `R` – retail (EMV supported) Applicable for TSYS (tsys), RUPAY and Elavon Americas (elavonamericas) processors.   Possible values: - 0 - A - B - D - F - G - H - L - O - P - R
   * @member {String} industryCode
   */
  exports.prototype['industryCode'] = undefined;
  /**
   * Field that indicates whether merchant will send level 2 data for Amex cards. Applicable for TSYS (tsys) processor.
   * @member {Boolean} sendAmexLevel2Data
   */
  exports.prototype['sendAmexLevel2Data'] = undefined;
  /**
   * A soft descriptor is a text, rendered on a cardholder's statement, describing a particular product or service, purchased by the cardholder. Descriptors are intended to help the cardholder identify the products or services purchased. Valid values: `1` - trans_ref_no `2` - merchant_descriptor `3` - trans_ref_no and merchant_descriptor Applicable for TSYS (tsys) processor. 
   * @member {String} softDescriptorType
   */
  exports.prototype['softDescriptorType'] = undefined;
  /**
   * V-number provided by TSYS info. The leading `V` must be replaced by a `7`. For example, replace `V1234567` with `71234567`. Applicable for TSYS (tsys) processor.
   * @member {String} vitalNumber
   */
  exports.prototype['vitalNumber'] = undefined;
  /**
   * 6 digit agent bank number provided by acquirer. Applicable for TSYS (tsys) processor.
   * @member {String} bankNumber
   */
  exports.prototype['bankNumber'] = undefined;
  /**
   * 6 digit chain number provided by acquirer. Applicable for TSYS (tsys) processor.
   * @member {String} chainNumber
   */
  exports.prototype['chainNumber'] = undefined;
  /**
   * 6 digits acquirer bank identification number. Applicable for TSYS (tsys) processor.
   * @member {String} merchantBinNumber
   */
  exports.prototype['merchantBinNumber'] = undefined;
  /**
   * 5 digit merchant location number. Unless otherwise specified by merchant's bank or processor, this field should default to 00001. Applicable for TSYS (tsys) processor.
   * @member {String} merchantLocationNumber
   */
  exports.prototype['merchantLocationNumber'] = undefined;
  /**
   * 4 digits number used to identify a specific merchant store location within the member systems. Applicable for TSYS (tsys) processor.
   * @member {String} storeID
   */
  exports.prototype['storeID'] = undefined;
  /**
   * Contains travel agency code if airline ticket was issued by a travel agency. Applicable for TSYS (tsys) processor.
   * @member {String} travelAgencyCode
   */
  exports.prototype['travelAgencyCode'] = undefined;
  /**
   * Contains travel agency name if airline ticket was issued by travel agency. Applicable for TSYS (tsys) processor.
   * @member {String} travelAgencyName
   */
  exports.prototype['travelAgencyName'] = undefined;
  /**
   * This field is used to indicate Merchant's settlement currency. [ISO 4217 ALPHA-3 Standard Currency Codes] Applicable for TSYS (tsys) and Streamline (streamline2) processors.
   * @member {String} settlementCurrency
   */
  exports.prototype['settlementCurrency'] = undefined;
  /**
   * Indicates whether Least Cost Routing is enabled. Applicable for EFTPOS and CUP processors.
   * @member {Boolean} enableLeastCostRouting
   */
  exports.prototype['enableLeastCostRouting'] = undefined;
  /**
   * This field denotes EFTPOS Merchant's choice of receiving CVV Processing Response in return. Applicable for EFTPOS processors.
   * @member {Boolean} enableCVVResponseIndicator
   */
  exports.prototype['enableCVVResponseIndicator'] = undefined;
  /**
   * Applicable for Barclays (barclays2) processor.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Default Value</th></tr></thead> <tr><td>Barclays</td><td>cnp, cp, hybrid</td><td>No</td><td>Yes</td></tr> </table> 
   * @member {String} enableMultiCurrencyProcessing
   */
  exports.prototype['enableMultiCurrencyProcessing'] = undefined;
  /**
   * 'POS Network Switching' or 'Alternate Routing' means merchant can process PIN Debit transactions without a PIN. Set the value to 'Yes' if it is supported. Applicable for FDI Global (fdiglobal) processor.
   * @member {Boolean} enablePosNetworkSwitching
   */
  exports.prototype['enablePosNetworkSwitching'] = undefined;
  /**
   * Enable dynamic currency conversion for a merchant.
   * @member {Boolean} enableDynamicCurrencyConversion
   */
  exports.prototype['enableDynamicCurrencyConversion'] = undefined;
  /**
   * Merchant Tier defines the type of merchant, the numeric Merchant Tier value is allocated by EFTPOS. Applicable for EFTPOS processors.
   * @member {String} merchantTier
   */
  exports.prototype['merchantTier'] = undefined;



  return exports;
}));


