/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.CardProcessingConfigFeaturesCardNotPresentInstallment = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The CardProcessingConfigFeaturesCardNotPresentInstallment model module.
   * @module model/CardProcessingConfigFeaturesCardNotPresentInstallment
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>CardProcessingConfigFeaturesCardNotPresentInstallment</code>.
   * @alias module:model/CardProcessingConfigFeaturesCardNotPresentInstallment
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>CardProcessingConfigFeaturesCardNotPresentInstallment</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CardProcessingConfigFeaturesCardNotPresentInstallment} obj Optional instance to populate.
   * @return {module:model/CardProcessingConfigFeaturesCardNotPresentInstallment} The populated <code>CardProcessingConfigFeaturesCardNotPresentInstallment</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('enableInstallment')) {
        obj['enableInstallment'] = ApiClient.convertToType(data['enableInstallment'], 'Boolean');
      }
      if (data.hasOwnProperty('installmentPlan')) {
        obj['installmentPlan'] = ApiClient.convertToType(data['installmentPlan'], 'String');
      }
    }
    return obj;
  }

  /**
   * This flag is to enable for installment plan programs. Applicable for Fiserv (fiserv), Vero (vero) and American Express Direct (amexdirect) processors.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Default Value</th></tr></thead> <tr><td>American Express Direct</td><td>cnp</td><td>No</td><td>No</td></tr> </table> 
   * @member {Boolean} enableInstallment
   */
  exports.prototype['enableInstallment'] = undefined;
  /**
   * This indicates the type of funding for the installment plan associated with the payment.  Valid values: \"merchant\" - Merchant-funded installment plan \"issuer\" - Issuer-funded installment plan  Applicable for Fiserv (fiserv), American Express Direct (amexdirect) and Vero (vero) processors.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th></tr></thead> <tr><td>American Express Direct</td><td>cnp</td><td>No</td></tr> </table> 
   * @member {String} installmentPlan
   */
  exports.prototype['installmentPlan'] = undefined;



  return exports;
}));


