/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CardProcessingConfigFeaturesCardNotPresentPayoutsCurrencies'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CardProcessingConfigFeaturesCardNotPresentPayoutsCurrencies'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.CardProcessingConfigFeaturesCardNotPresentPayouts = factory(root.CyberSource.ApiClient, root.CyberSource.CardProcessingConfigFeaturesCardNotPresentPayoutsCurrencies);
  }
}(this, function(ApiClient, CardProcessingConfigFeaturesCardNotPresentPayoutsCurrencies) {
  'use strict';




  /**
   * The CardProcessingConfigFeaturesCardNotPresentPayouts model module.
   * @module model/CardProcessingConfigFeaturesCardNotPresentPayouts
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>CardProcessingConfigFeaturesCardNotPresentPayouts</code>.
   * @alias module:model/CardProcessingConfigFeaturesCardNotPresentPayouts
   * @class
   */
  var exports = function() {
    var _this = this;










  };

  /**
   * Constructs a <code>CardProcessingConfigFeaturesCardNotPresentPayouts</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CardProcessingConfigFeaturesCardNotPresentPayouts} obj Optional instance to populate.
   * @return {module:model/CardProcessingConfigFeaturesCardNotPresentPayouts} The populated <code>CardProcessingConfigFeaturesCardNotPresentPayouts</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('reimbursementCode')) {
        obj['reimbursementCode'] = ApiClient.convertToType(data['reimbursementCode'], 'String');
      }
      if (data.hasOwnProperty('acquiringInstitutionId')) {
        obj['acquiringInstitutionId'] = ApiClient.convertToType(data['acquiringInstitutionId'], 'String');
      }
      if (data.hasOwnProperty('businessApplicationId')) {
        obj['businessApplicationId'] = ApiClient.convertToType(data['businessApplicationId'], 'String');
      }
      if (data.hasOwnProperty('financialInstitutionId')) {
        obj['financialInstitutionId'] = ApiClient.convertToType(data['financialInstitutionId'], 'String');
      }
      if (data.hasOwnProperty('merchantAbaNumber')) {
        obj['merchantAbaNumber'] = ApiClient.convertToType(data['merchantAbaNumber'], 'String');
      }
      if (data.hasOwnProperty('networkOrder')) {
        obj['networkOrder'] = ApiClient.convertToType(data['networkOrder'], 'String');
      }
      if (data.hasOwnProperty('currencies')) {
        obj['currencies'] = ApiClient.convertToType(data['currencies'], {'String': CardProcessingConfigFeaturesCardNotPresentPayoutsCurrencies});
      }
      if (data.hasOwnProperty('merchantId')) {
        obj['merchantId'] = ApiClient.convertToType(data['merchantId'], 'String');
      }
      if (data.hasOwnProperty('terminalId')) {
        obj['terminalId'] = ApiClient.convertToType(data['terminalId'], 'String');
      }
    }
    return obj;
  }

  /**
   * Applicable for VPC processors.
   * @member {String} reimbursementCode
   */
  exports.prototype['reimbursementCode'] = undefined;
  /**
   * This code identifies the financial institution acting as the acquirer of this customer transaction. The acquirer is the member or system user that signed the merchant. This number is usually a Visa-assigned. Applicable for VPC processors.
   * @member {String} acquiringInstitutionId
   */
  exports.prototype['acquiringInstitutionId'] = undefined;
  /**
   * Transaction type. List of supported identifiers documented in the Developer Guide. Applicable for GPX (gpx) and VPC processors.
   * @member {String} businessApplicationId
   */
  exports.prototype['businessApplicationId'] = undefined;
  /**
   * Applicable for GPX (gpx) and VPC processors.
   * @member {String} financialInstitutionId
   */
  exports.prototype['financialInstitutionId'] = undefined;
  /**
   * Routing Number to identify banks within the United States. Applicable for VPC processors.
   * @member {String} merchantAbaNumber
   */
  exports.prototype['merchantAbaNumber'] = undefined;
  /**
   * Order of the networks in which Visa should make routing decisions. Applicable for VPC processors.
   * @member {String} networkOrder
   */
  exports.prototype['networkOrder'] = undefined;
  /**
   * Three-character [ISO 4217 ALPHA-3 Standard Currency Codes.](http://apps.cybersource.com/library/documentation/sbc/quickref/currencies.pdf)
   * @member {Object.<String, module:model/CardProcessingConfigFeaturesCardNotPresentPayoutsCurrencies>} currencies
   */
  exports.prototype['currencies'] = undefined;
  /**
   * Merchant ID assigned by an acquirer or a processor. Should not be overridden by any other party.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Min. Length</th><th>Max. Length</th><th>Regex</th></tr></thead> <tr><td>Barclays</td><td>cnp, hybrid</td><td>No</td><td>1</td><td>11</td><td>^[0-9]+$</td></tr> </table> 
   * @member {String} merchantId
   */
  exports.prototype['merchantId'] = undefined;
  /**
   * The 'Terminal Id' aka TID, is an identifier used for with your payments processor. Depending on the processor and payment acceptance type this may also be the default Terminal ID used for Card Present and Virtual Terminal transactions.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Min. Length</th><th>Max. Length</th><th>Regex</th></tr></thead> <tr><td>Barclays</td><td>cnp, hybrid</td><td>No</td><td>1</td><td>255</td><td>^[0-9:&#92;-]+$</td></tr> </table> 
   * @member {String} terminalId
   */
  exports.prototype['terminalId'] = undefined;



  return exports;
}));


