/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.CardProcessingConfigFeaturesCardNotPresentPayoutsCurrencies = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The CardProcessingConfigFeaturesCardNotPresentPayoutsCurrencies model module.
   * @module model/CardProcessingConfigFeaturesCardNotPresentPayoutsCurrencies
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>CardProcessingConfigFeaturesCardNotPresentPayoutsCurrencies</code>.
   * @alias module:model/CardProcessingConfigFeaturesCardNotPresentPayoutsCurrencies
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>CardProcessingConfigFeaturesCardNotPresentPayoutsCurrencies</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CardProcessingConfigFeaturesCardNotPresentPayoutsCurrencies} obj Optional instance to populate.
   * @return {module:model/CardProcessingConfigFeaturesCardNotPresentPayoutsCurrencies} The populated <code>CardProcessingConfigFeaturesCardNotPresentPayoutsCurrencies</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('enabled')) {
        obj['enabled'] = ApiClient.convertToType(data['enabled'], 'Boolean');
      }
      if (data.hasOwnProperty('enabledCardPresent')) {
        obj['enabledCardPresent'] = ApiClient.convertToType(data['enabledCardPresent'], 'Boolean');
      }
      if (data.hasOwnProperty('enabledCardNotPresent')) {
        obj['enabledCardNotPresent'] = ApiClient.convertToType(data['enabledCardNotPresent'], 'Boolean');
      }
      if (data.hasOwnProperty('merchantId')) {
        obj['merchantId'] = ApiClient.convertToType(data['merchantId'], 'String');
      }
      if (data.hasOwnProperty('terminalId')) {
        obj['terminalId'] = ApiClient.convertToType(data['terminalId'], 'String');
      }
      if (data.hasOwnProperty('terminalIds')) {
        obj['terminalIds'] = ApiClient.convertToType(data['terminalIds'], ['String']);
      }
      if (data.hasOwnProperty('serviceEnablementNumber')) {
        obj['serviceEnablementNumber'] = ApiClient.convertToType(data['serviceEnablementNumber'], 'String');
      }
    }
    return obj;
  }

  /**
   * @member {Boolean} enabled
   */
  exports.prototype['enabled'] = undefined;
  /**
   * Indicates whether the card-present transaction is activated for the selected currency. If both enabledCardPresent and enabledCardNotPresent are set to null, then enabledCardPresent will have the value of enabled. 
   * @member {Boolean} enabledCardPresent
   */
  exports.prototype['enabledCardPresent'] = undefined;
  /**
   * Indicates whether the card-present transaction is activated for the selected currency. If both enabledCardPresent and enabledCardNotPresent are set to null, then enabledCardNotPresent will have the value of enabled. 
   * @member {Boolean} enabledCardNotPresent
   */
  exports.prototype['enabledCardNotPresent'] = undefined;
  /**
   * Merchant ID assigned by an acquirer or a processor. Should not be overriden by any other party.
   * @member {String} merchantId
   */
  exports.prototype['merchantId'] = undefined;
  /**
   * The 'Terminal Id' aka TID, is an identifier used for with your payments processor. Depending on the processor and payment acceptance type this may also be the default Terminal ID used for Card Present and Virtual Terminal transactions. 
   * @member {String} terminalId
   */
  exports.prototype['terminalId'] = undefined;
  /**
   * Applicable for Prisma (prisma) processor.
   * @member {Array.<String>} terminalIds
   */
  exports.prototype['terminalIds'] = undefined;
  /**
   * Service Establishment Number (a.k.a. SE Number) is a unique ten-digit number assigned by American Express to a merchant that accepts American Express cards. 10 digit number provided by acquirer currency. This may be unique for each currency, however it depends on the way the processor is set up for the merchant. 
   * @member {String} serviceEnablementNumber
   */
  exports.prototype['serviceEnablementNumber'] = undefined;



  return exports;
}));


