/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CardProcessingConfigFeaturesCardNotPresentPayouts'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CardProcessingConfigFeaturesCardNotPresentPayouts'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.CardProcessingConfigFeaturesCardNotPresentProcessors = factory(root.CyberSource.ApiClient, root.CyberSource.CardProcessingConfigFeaturesCardNotPresentPayouts);
  }
}(this, function(ApiClient, CardProcessingConfigFeaturesCardNotPresentPayouts) {
  'use strict';




  /**
   * The CardProcessingConfigFeaturesCardNotPresentProcessors model module.
   * @module model/CardProcessingConfigFeaturesCardNotPresentProcessors
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>CardProcessingConfigFeaturesCardNotPresentProcessors</code>.
   * @alias module:model/CardProcessingConfigFeaturesCardNotPresentProcessors
   * @class
   */
  var exports = function() {
    var _this = this;







  };

  /**
   * Constructs a <code>CardProcessingConfigFeaturesCardNotPresentProcessors</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CardProcessingConfigFeaturesCardNotPresentProcessors} obj Optional instance to populate.
   * @return {module:model/CardProcessingConfigFeaturesCardNotPresentProcessors} The populated <code>CardProcessingConfigFeaturesCardNotPresentProcessors</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('relaxAddressVerificationSystem')) {
        obj['relaxAddressVerificationSystem'] = ApiClient.convertToType(data['relaxAddressVerificationSystem'], 'Boolean');
      }
      if (data.hasOwnProperty('relaxAddressVerificationSystemAllowZipWithoutCountry')) {
        obj['relaxAddressVerificationSystemAllowZipWithoutCountry'] = ApiClient.convertToType(data['relaxAddressVerificationSystemAllowZipWithoutCountry'], 'Boolean');
      }
      if (data.hasOwnProperty('relaxAddressVerificationSystemAllowExpiredCard')) {
        obj['relaxAddressVerificationSystemAllowExpiredCard'] = ApiClient.convertToType(data['relaxAddressVerificationSystemAllowExpiredCard'], 'Boolean');
      }
      if (data.hasOwnProperty('enableEmsTransactionRiskScore')) {
        obj['enableEmsTransactionRiskScore'] = ApiClient.convertToType(data['enableEmsTransactionRiskScore'], 'Boolean');
      }
      if (data.hasOwnProperty('prestigiousPropertyIndicator')) {
        obj['prestigiousPropertyIndicator'] = ApiClient.convertToType(data['prestigiousPropertyIndicator'], 'String');
      }
      if (data.hasOwnProperty('payouts')) {
        obj['payouts'] = CardProcessingConfigFeaturesCardNotPresentPayouts.constructFromObject(data['payouts']);
      }
    }
    return obj;
  }

  /**
   * Enables you to submit the payment transaction without one or more of the fields for the billTo or card_expiration. Applicable for Elavon Americas (elavonamericas), CB2A, Six (six), CMCIC (cmcic), GPX (gpx), GPN (gpn), VPC, Vero (vero), Fiserv (fiserv), American Express Direct (amexdirect), Chase Paymentech Salem (chasepaymentechsalem), RUPAY, FDI Global (fdiglobal) and Barclays HISO (barclayshiso) processors.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Default Value</th></tr></thead> <tr><td>Barclays HISO</td><td>cp, cnp, hybrid</td><td>No</td><td>Yes</td></tr> <tr><td>American Express Direct</td><td>cnp</td><td>No</td><td>No</td></tr> <tr><td>American Express Direct</td><td>cp</td><td>No</td><td>Yes</td></tr> <tr><td>American Express Direct</td><td>hybrid</td><td>Yes</td><td>Yes</td></tr> </table> 
   * @member {Boolean} relaxAddressVerificationSystem
   */
  exports.prototype['relaxAddressVerificationSystem'] = undefined;
  /**
   * Allows Zip code without country. Applicable for American Express Direct (amexdirect), GPX (gpx), VPC, FDI Global (fdiglobal), Elavon Americas (elavonamericas), Chase Paymentech Salem (chasepaymentechsalem), RUPAY, GPN (gpn) and Barclays HISO (barclayshiso) processors.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Default Value</th></tr></thead> <tr><td>Barclays HISO</td><td>cp, cnp, both</td><td>No</td><td>Yes</td></tr> <tr><td>American Express Direct</td><td>cp, hybrid</td><td>No</td><td>Yes</td></tr> <tr><td>American Express Direct</td><td>cnp</td><td>No</td><td>No</td></tr> </table> 
   * @member {Boolean} relaxAddressVerificationSystemAllowZipWithoutCountry
   */
  exports.prototype['relaxAddressVerificationSystemAllowZipWithoutCountry'] = undefined;
  /**
   * Allows transactions that use an expired card. Applicable for American Express Direct (amexdirect), GPN (gpn), Barclays HISO (barclayshiso), Elavon Americas (elavonamericas), VPC, FDI Global (fdiglobal), GPX (gpx), RUPAY, Six (six), Chase Paymentech Salem (chasepaymentechsalem) and CB2A processors.  Validation details (for selected processors)...  <table> <thead><tr><th>Processor</th><th>Acceptance Type</th><th>Required</th><th>Default Value</th></tr></thead> <tr><td>Barclays HISO</td><td>cp, cnp, hybrid</td><td>No</td><td>Yes</td></tr> <tr><td>American Express Direct</td><td>cp, hybrid</td><td>No</td><td>Yes</td></tr> <tr><td>American Express Direct</td><td>cnp</td><td>No</td><td>No</td></tr> </table> 
   * @member {Boolean} relaxAddressVerificationSystemAllowExpiredCard
   */
  exports.prototype['relaxAddressVerificationSystemAllowExpiredCard'] = undefined;
  /**
   * MasterCard Expert Monitoring Solutions (EMS) provides a predictive, behavior-based fraud score in real time during authorizations for card-not-present (CNP) transactions on cards issued in the U.S. Applicable for GPX (gpx) and VPC processors.
   * @member {Boolean} enableEmsTransactionRiskScore
   */
  exports.prototype['enableEmsTransactionRiskScore'] = undefined;
  /**
   * Applicable for VPC processors.
   * @member {String} prestigiousPropertyIndicator
   */
  exports.prototype['prestigiousPropertyIndicator'] = undefined;
  /**
   * @member {module:model/CardProcessingConfigFeaturesCardNotPresentPayouts} payouts
   */
  exports.prototype['payouts'] = undefined;



  return exports;
}));


