/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Reportingv3reportsReportFilters', 'model/Reportingv3reportsReportPreferences'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Reportingv3reportsReportFilters'), require('./Reportingv3reportsReportPreferences'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.CreateAdhocReportRequest = factory(root.CyberSource.ApiClient, root.CyberSource.Reportingv3reportsReportFilters, root.CyberSource.Reportingv3reportsReportPreferences);
  }
}(this, function(ApiClient, Reportingv3reportsReportFilters, Reportingv3reportsReportPreferences) {
  'use strict';




  /**
   * The CreateAdhocReportRequest model module.
   * @module model/CreateAdhocReportRequest
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>CreateAdhocReportRequest</code>.
   * @alias module:model/CreateAdhocReportRequest
   * @class
   */
  var exports = function() {
    var _this = this;












  };

  /**
   * Constructs a <code>CreateAdhocReportRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CreateAdhocReportRequest} obj Optional instance to populate.
   * @return {module:model/CreateAdhocReportRequest} The populated <code>CreateAdhocReportRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('organizationId')) {
        obj['organizationId'] = ApiClient.convertToType(data['organizationId'], 'String');
      }
      if (data.hasOwnProperty('reportDefinitionName')) {
        obj['reportDefinitionName'] = ApiClient.convertToType(data['reportDefinitionName'], 'String');
      }
      if (data.hasOwnProperty('reportFields')) {
        obj['reportFields'] = ApiClient.convertToType(data['reportFields'], ['String']);
      }
      if (data.hasOwnProperty('reportMimeType')) {
        obj['reportMimeType'] = ApiClient.convertToType(data['reportMimeType'], 'String');
      }
      if (data.hasOwnProperty('reportName')) {
        obj['reportName'] = ApiClient.convertToType(data['reportName'], 'String');
      }
      if (data.hasOwnProperty('timezone')) {
        obj['timezone'] = ApiClient.convertToType(data['timezone'], 'String');
      }
      if (data.hasOwnProperty('reportStartTime')) {
        obj['reportStartTime'] = ApiClient.convertToType(data['reportStartTime'], 'Date');
      }
      if (data.hasOwnProperty('reportEndTime')) {
        obj['reportEndTime'] = ApiClient.convertToType(data['reportEndTime'], 'Date');
      }
      if (data.hasOwnProperty('reportFilters')) {
        obj['reportFilters'] = Reportingv3reportsReportFilters.constructFromObject(data['reportFilters']);
      }
      if (data.hasOwnProperty('reportPreferences')) {
        obj['reportPreferences'] = Reportingv3reportsReportPreferences.constructFromObject(data['reportPreferences']);
      }
      if (data.hasOwnProperty('groupName')) {
        obj['groupName'] = ApiClient.convertToType(data['groupName'], 'String');
      }
    }
    return obj;
  }

  /**
   * Valid CyberSource Organization Id
   * @member {String} organizationId
   */
  exports.prototype['organizationId'] = undefined;
  /**
   * @member {String} reportDefinitionName
   */
  exports.prototype['reportDefinitionName'] = undefined;
  /**
   * List of fields which needs to get included in a report
   * @member {Array.<String>} reportFields
   */
  exports.prototype['reportFields'] = undefined;
  /**
   * 'Format of the report'                  Valid values: - application/xml - text/csv 
   * @member {String} reportMimeType
   */
  exports.prototype['reportMimeType'] = undefined;
  /**
   * Name of the report
   * @member {String} reportName
   */
  exports.prototype['reportName'] = undefined;
  /**
   * Timezone of the report
   * @member {String} timezone
   */
  exports.prototype['timezone'] = undefined;
  /**
   * Start time of the report
   * @member {Date} reportStartTime
   */
  exports.prototype['reportStartTime'] = undefined;
  /**
   * End time of the report
   * @member {Date} reportEndTime
   */
  exports.prototype['reportEndTime'] = undefined;
  /**
   * @member {module:model/Reportingv3reportsReportFilters} reportFilters
   */
  exports.prototype['reportFilters'] = undefined;
  /**
   * @member {module:model/Reportingv3reportsReportPreferences} reportPreferences
   */
  exports.prototype['reportPreferences'] = undefined;
  /**
   * Specifies the group name
   * @member {String} groupName
   */
  exports.prototype['groupName'] = undefined;



  return exports;
}));


