/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.DeviceDeAssociateV3Request = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The DeviceDeAssociateV3Request model module.
   * @module model/DeviceDeAssociateV3Request
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>DeviceDeAssociateV3Request</code>.
   * @alias module:model/DeviceDeAssociateV3Request
   * @class
   * @param deviceId {String} ID of the device to be de-associated.
   */
  var exports = function(deviceId) {
    var _this = this;

    _this['deviceId'] = deviceId;

  };

  /**
   * Constructs a <code>DeviceDeAssociateV3Request</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/DeviceDeAssociateV3Request} obj Optional instance to populate.
   * @return {module:model/DeviceDeAssociateV3Request} The populated <code>DeviceDeAssociateV3Request</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('deviceId')) {
        obj['deviceId'] = ApiClient.convertToType(data['deviceId'], 'String');
      }
      if (data.hasOwnProperty('organizationId')) {
        obj['organizationId'] = ApiClient.convertToType(data['organizationId'], 'String');
      }
    }
    return obj;
  }

  /**
   * ID of the device to be de-associated.
   * @member {String} deviceId
   */
  exports.prototype['deviceId'] = undefined;
  /**
   * A field representing value of either account id or portfolio id.
   * @member {String} organizationId
   */
  exports.prototype['organizationId'] = undefined;



  return exports;
}));


