/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/DmConfigOrganization', 'model/DmConfigPortfolioControls', 'model/DmConfigProcessingOptions', 'model/DmConfigThirdparty'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./DmConfigOrganization'), require('./DmConfigPortfolioControls'), require('./DmConfigProcessingOptions'), require('./DmConfigThirdparty'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.DmConfig = factory(root.CyberSource.ApiClient, root.CyberSource.DmConfigOrganization, root.CyberSource.DmConfigPortfolioControls, root.CyberSource.DmConfigProcessingOptions, root.CyberSource.DmConfigThirdparty);
  }
}(this, function(ApiClient, DmConfigOrganization, DmConfigPortfolioControls, DmConfigProcessingOptions, DmConfigThirdparty) {
  'use strict';




  /**
   * The DmConfig model module.
   * @module model/DmConfig
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>DmConfig</code>.
   * @alias module:model/DmConfig
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>DmConfig</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/DmConfig} obj Optional instance to populate.
   * @return {module:model/DmConfig} The populated <code>DmConfig</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('processingOptions')) {
        obj['processingOptions'] = DmConfigProcessingOptions.constructFromObject(data['processingOptions']);
      }
      if (data.hasOwnProperty('organization')) {
        obj['organization'] = DmConfigOrganization.constructFromObject(data['organization']);
      }
      if (data.hasOwnProperty('portfolioControls')) {
        obj['portfolioControls'] = DmConfigPortfolioControls.constructFromObject(data['portfolioControls']);
      }
      if (data.hasOwnProperty('thirdparty')) {
        obj['thirdparty'] = DmConfigThirdparty.constructFromObject(data['thirdparty']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/DmConfigProcessingOptions} processingOptions
   */
  exports.prototype['processingOptions'] = undefined;
  /**
   * @member {module:model/DmConfigOrganization} organization
   */
  exports.prototype['organization'] = undefined;
  /**
   * @member {module:model/DmConfigPortfolioControls} portfolioControls
   */
  exports.prototype['portfolioControls'] = undefined;
  /**
   * @member {module:model/DmConfigThirdparty} thirdparty
   */
  exports.prototype['thirdparty'] = undefined;



  return exports;
}));


