/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/InlineResponse2015Payloads'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./InlineResponse2015Payloads'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.InlineResponse2015 = factory(root.CyberSource.ApiClient, root.CyberSource.InlineResponse2015Payloads);
  }
}(this, function(ApiClient, InlineResponse2015Payloads) {
  'use strict';




  /**
   * The InlineResponse2015 model module.
   * @module model/InlineResponse2015
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>InlineResponse2015</code>.
   * @alias module:model/InlineResponse2015
   * @class
   */
  var exports = function() {
    var _this = this;










  };

  /**
   * Constructs a <code>InlineResponse2015</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/InlineResponse2015} obj Optional instance to populate.
   * @return {module:model/InlineResponse2015} The populated <code>InlineResponse2015</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('eventDate')) {
        obj['eventDate'] = ApiClient.convertToType(data['eventDate'], 'String');
      }
      if (data.hasOwnProperty('eventType')) {
        obj['eventType'] = ApiClient.convertToType(data['eventType'], 'String');
      }
      if (data.hasOwnProperty('organizationId')) {
        obj['organizationId'] = ApiClient.convertToType(data['organizationId'], 'String');
      }
      if (data.hasOwnProperty('payloads')) {
        obj['payloads'] = InlineResponse2015Payloads.constructFromObject(data['payloads']);
      }
      if (data.hasOwnProperty('productId')) {
        obj['productId'] = ApiClient.convertToType(data['productId'], 'String');
      }
      if (data.hasOwnProperty('requestType')) {
        obj['requestType'] = ApiClient.convertToType(data['requestType'], 'String');
      }
      if (data.hasOwnProperty('retryNumber')) {
        obj['retryNumber'] = ApiClient.convertToType(data['retryNumber'], 'Number');
      }
      if (data.hasOwnProperty('transactionTraceId')) {
        obj['transactionTraceId'] = ApiClient.convertToType(data['transactionTraceId'], 'String');
      }
      if (data.hasOwnProperty('webhookId')) {
        obj['webhookId'] = ApiClient.convertToType(data['webhookId'], 'String');
      }
    }
    return obj;
  }

  /**
   * Date that the webhook was delivered
   * @member {String} eventDate
   */
  exports.prototype['eventDate'] = undefined;
  /**
   * The event name the webhook was delivered for
   * @member {String} eventType
   */
  exports.prototype['eventType'] = undefined;
  /**
   * The Organization Identifier.
   * @member {String} organizationId
   */
  exports.prototype['organizationId'] = undefined;
  /**
   * @member {module:model/InlineResponse2015Payloads} payloads
   */
  exports.prototype['payloads'] = undefined;
  /**
   * The product the webhook was delivered for
   * @member {String} productId
   */
  exports.prototype['productId'] = undefined;
  /**
   * Identifies the the type of request
   * @member {String} requestType
   */
  exports.prototype['requestType'] = undefined;
  /**
   * The number of retry attempts for a given webhook
   * @member {Number} retryNumber
   */
  exports.prototype['retryNumber'] = undefined;
  /**
   * The identifier for the webhook
   * @member {String} transactionTraceId
   */
  exports.prototype['transactionTraceId'] = undefined;
  /**
   * The identifier of the subscription
   * @member {String} webhookId
   */
  exports.prototype['webhookId'] = undefined;



  return exports;
}));


