/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Iplv2paymentlinksProcessingInformation = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Iplv2paymentlinksProcessingInformation model module.
   * @module model/Iplv2paymentlinksProcessingInformation
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Iplv2paymentlinksProcessingInformation</code>.
   * Contains processing information, such as the type and collection details.
   * @alias module:model/Iplv2paymentlinksProcessingInformation
   * @class
   * @param linkType {String} linkType defines what type of link you want to create.  Possible Values:   - `PURCHASE`   - `DONATION` 
   */
  var exports = function(linkType) {
    var _this = this;

    _this['linkType'] = linkType;


  };

  /**
   * Constructs a <code>Iplv2paymentlinksProcessingInformation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Iplv2paymentlinksProcessingInformation} obj Optional instance to populate.
   * @return {module:model/Iplv2paymentlinksProcessingInformation} The populated <code>Iplv2paymentlinksProcessingInformation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('linkType')) {
        obj['linkType'] = ApiClient.convertToType(data['linkType'], 'String');
      }
      if (data.hasOwnProperty('requestPhone')) {
        obj['requestPhone'] = ApiClient.convertToType(data['requestPhone'], 'Boolean');
      }
      if (data.hasOwnProperty('requestShipping')) {
        obj['requestShipping'] = ApiClient.convertToType(data['requestShipping'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * linkType defines what type of link you want to create.  Possible Values:   - `PURCHASE`   - `DONATION` 
   * @member {String} linkType
   */
  exports.prototype['linkType'] = undefined;
  /**
   * Collect the payers phone number during the payment.
   * @member {Boolean} requestPhone
   * @default false
   */
  exports.prototype['requestPhone'] = false;
  /**
   * Collect the payers shipping address during the payment.
   * @member {Boolean} requestShipping
   * @default false
   */
  exports.prototype['requestShipping'] = false;



  return exports;
}));


