/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Kmsegressv2keysasymKeyInformation = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Kmsegressv2keysasymKeyInformation model module.
   * @module model/Kmsegressv2keysasymKeyInformation
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Kmsegressv2keysasymKeyInformation</code>.
   * Egress Asymmetric  Key Information Request 
   * @alias module:model/Kmsegressv2keysasymKeyInformation
   * @class
   */
  var exports = function() {
    var _this = this;










  };

  /**
   * Constructs a <code>Kmsegressv2keysasymKeyInformation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Kmsegressv2keysasymKeyInformation} obj Optional instance to populate.
   * @return {module:model/Kmsegressv2keysasymKeyInformation} The populated <code>Kmsegressv2keysasymKeyInformation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('provider')) {
        obj['provider'] = ApiClient.convertToType(data['provider'], 'String');
      }
      if (data.hasOwnProperty('tenant')) {
        obj['tenant'] = ApiClient.convertToType(data['tenant'], 'String');
      }
      if (data.hasOwnProperty('keyType')) {
        obj['keyType'] = ApiClient.convertToType(data['keyType'], 'String');
      }
      if (data.hasOwnProperty('organizationId')) {
        obj['organizationId'] = ApiClient.convertToType(data['organizationId'], 'String');
      }
      if (data.hasOwnProperty('pub')) {
        obj['pub'] = ApiClient.convertToType(data['pub'], 'String');
      }
      if (data.hasOwnProperty('keyId')) {
        obj['keyId'] = ApiClient.convertToType(data['keyId'], 'String');
      }
      if (data.hasOwnProperty('pvt')) {
        obj['pvt'] = ApiClient.convertToType(data['pvt'], 'String');
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'String');
      }
      if (data.hasOwnProperty('expiryDuration')) {
        obj['expiryDuration'] = ApiClient.convertToType(data['expiryDuration'], 'String');
      }
    }
    return obj;
  }

  /**
   * Provider name 
   * @member {String} provider
   */
  exports.prototype['provider'] = undefined;
  /**
   * Tenant name 
   * @member {String} tenant
   */
  exports.prototype['tenant'] = undefined;
  /**
   * Type of the key 
   * @member {String} keyType
   */
  exports.prototype['keyType'] = undefined;
  /**
   * Organization Id 
   * @member {String} organizationId
   */
  exports.prototype['organizationId'] = undefined;
  /**
   * Public certificate with only base64 encoded payload and not the header (BEGIN CERTIFICATE) and footer (END CERTIFICATE) 
   * @member {String} pub
   */
  exports.prototype['pub'] = undefined;
  /**
   * Key Serial Number 
   * @member {String} keyId
   */
  exports.prototype['keyId'] = undefined;
  /**
   * Private certificate with only base64 encoded payload and not header (BEGIN CERTIFICATE) and footer (END CERTIFICATE) 
   * @member {String} pvt
   */
  exports.prototype['pvt'] = undefined;
  /**
   * The status of the key 
   * @member {String} status
   */
  exports.prototype['status'] = undefined;
  /**
   * Key expiry duration in days 
   * @member {String} expiryDuration
   */
  exports.prototype['expiryDuration'] = undefined;



  return exports;
}));


