/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.PaymentsProductsECheckSubscriptionInformation = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The PaymentsProductsECheckSubscriptionInformation model module.
   * @module model/PaymentsProductsECheckSubscriptionInformation
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>PaymentsProductsECheckSubscriptionInformation</code>.
   * @alias module:model/PaymentsProductsECheckSubscriptionInformation
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>PaymentsProductsECheckSubscriptionInformation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PaymentsProductsECheckSubscriptionInformation} obj Optional instance to populate.
   * @return {module:model/PaymentsProductsECheckSubscriptionInformation} The populated <code>PaymentsProductsECheckSubscriptionInformation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('enabled')) {
        obj['enabled'] = ApiClient.convertToType(data['enabled'], 'Boolean');
      }
      if (data.hasOwnProperty('selfServiceability')) {
        obj['selfServiceability'] = ApiClient.convertToType(data['selfServiceability'], 'String');
      }
      if (data.hasOwnProperty('mode')) {
        obj['mode'] = ApiClient.convertToType(data['mode'], ['String']);
      }
    }
    return obj;
  }

  /**
   * @member {Boolean} enabled
   */
  exports.prototype['enabled'] = undefined;
  /**
   * Indicates if the organization can enable this product using self service.  Possible values: - SELF_SERVICEABLE - NOT_SELF_SERVICEABLE - SELF_SERVICE_ONLY
   * @member {String} selfServiceability
   * @default 'NOT_SELF_SERVICEABLE'
   */
  exports.prototype['selfServiceability'] = 'NOT_SELF_SERVICEABLE';
  /**
   * Indicates what mode the product is expected to behave at boarding and transaction flows. Ex, Acquirer/Gateway/Other.
   * @member {Array.<String>} mode
   */
  exports.prototype['mode'] = undefined;



  return exports;
}));


