/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.PaymentsProductsPayoutsConfigurationInformationConfigurationsProcessorAccount = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The PaymentsProductsPayoutsConfigurationInformationConfigurationsProcessorAccount model module.
   * @module model/PaymentsProductsPayoutsConfigurationInformationConfigurationsProcessorAccount
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>PaymentsProductsPayoutsConfigurationInformationConfigurationsProcessorAccount</code>.
   * @alias module:model/PaymentsProductsPayoutsConfigurationInformationConfigurationsProcessorAccount
   * @class
   * @param originatorMerchantId {String} TBD
   * @param originatorTerminalId {Array.<String>} TBD
   */
  var exports = function(originatorMerchantId, originatorTerminalId) {
    var _this = this;

    _this['originatorMerchantId'] = originatorMerchantId;
    _this['originatorTerminalId'] = originatorTerminalId;

  };

  /**
   * Constructs a <code>PaymentsProductsPayoutsConfigurationInformationConfigurationsProcessorAccount</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PaymentsProductsPayoutsConfigurationInformationConfigurationsProcessorAccount} obj Optional instance to populate.
   * @return {module:model/PaymentsProductsPayoutsConfigurationInformationConfigurationsProcessorAccount} The populated <code>PaymentsProductsPayoutsConfigurationInformationConfigurationsProcessorAccount</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('originatorMerchantId')) {
        obj['originatorMerchantId'] = ApiClient.convertToType(data['originatorMerchantId'], 'String');
      }
      if (data.hasOwnProperty('originatorTerminalId')) {
        obj['originatorTerminalId'] = ApiClient.convertToType(data['originatorTerminalId'], ['String']);
      }
      if (data.hasOwnProperty('supportedCurrencies')) {
        obj['supportedCurrencies'] = ApiClient.convertToType(data['supportedCurrencies'], ['String']);
      }
    }
    return obj;
  }

  /**
   * TBD
   * @member {String} originatorMerchantId
   */
  exports.prototype['originatorMerchantId'] = undefined;
  /**
   * TBD
   * @member {Array.<String>} originatorTerminalId
   */
  exports.prototype['originatorTerminalId'] = undefined;
  /**
   * Three-character [ISO Standard Currency Codes.](http://apps.cybersource.com/library/documentation/sbc/quickref/currencies.pdf)
   * @member {Array.<String>} supportedCurrencies
   */
  exports.prototype['supportedCurrencies'] = undefined;



  return exports;
}));


