/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.PaymentsProductsServiceFeeConfigurationInformationConfigurationsPaymentInformation = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The PaymentsProductsServiceFeeConfigurationInformationConfigurationsPaymentInformation model module.
   * @module model/PaymentsProductsServiceFeeConfigurationInformationConfigurationsPaymentInformation
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>PaymentsProductsServiceFeeConfigurationInformationConfigurationsPaymentInformation</code>.
   * @alias module:model/PaymentsProductsServiceFeeConfigurationInformationConfigurationsPaymentInformation
   * @class
   */
  var exports = function() {
    var _this = this;






  };

  /**
   * Constructs a <code>PaymentsProductsServiceFeeConfigurationInformationConfigurationsPaymentInformation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PaymentsProductsServiceFeeConfigurationInformationConfigurationsPaymentInformation} obj Optional instance to populate.
   * @return {module:model/PaymentsProductsServiceFeeConfigurationInformationConfigurationsPaymentInformation} The populated <code>PaymentsProductsServiceFeeConfigurationInformationConfigurationsPaymentInformation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('paymentType')) {
        obj['paymentType'] = ApiClient.convertToType(data['paymentType'], 'String');
      }
      if (data.hasOwnProperty('feeType')) {
        obj['feeType'] = ApiClient.convertToType(data['feeType'], 'String');
      }
      if (data.hasOwnProperty('feeAmount')) {
        obj['feeAmount'] = ApiClient.convertToType(data['feeAmount'], 'Number');
      }
      if (data.hasOwnProperty('percentage')) {
        obj['percentage'] = ApiClient.convertToType(data['percentage'], 'Number');
      }
      if (data.hasOwnProperty('feeCap')) {
        obj['feeCap'] = ApiClient.convertToType(data['feeCap'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Payment types accepted by this merchant. The supported values are: MASTERDEBIT, MASTERCREDIT, VISACREDIT, VISADEBIT, DISCOVERCREDIT, AMEXCREDIT, ECHECK  Possible values: - MASTERDEBIT - MASTERCREDIT - VISACREDIT - VISADEBIT - DISCOVERCREDIT - AMEXCREDIT - ECHECK
   * @member {String} paymentType
   */
  exports.prototype['paymentType'] = undefined;
  /**
   * Fee type for the selected payment type. Supported values are: Flat or Percentage.   Possible values: - FLAT - PERCENTAGE
   * @member {String} feeType
   */
  exports.prototype['feeType'] = undefined;
  /**
   * Fee Amount of the selected payment type if you chose Flat fee type. 
   * @member {Number} feeAmount
   */
  exports.prototype['feeAmount'] = undefined;
  /**
   * Percentage of the selected payment type if you chose Percentage Fee type. Supported values use numbers with decimals. For example, 1.0 
   * @member {Number} percentage
   */
  exports.prototype['percentage'] = undefined;
  /**
   * Fee cap for the selected payment type. Supported values use numbers with decimals. For example, 1.0 
   * @member {Number} feeCap
   */
  exports.prototype['feeCap'] = undefined;



  return exports;
}));


