/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.PaymentsStrongAuthIssuerInformation = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The PaymentsStrongAuthIssuerInformation model module.
   * @module model/PaymentsStrongAuthIssuerInformation
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>PaymentsStrongAuthIssuerInformation</code>.
   * @alias module:model/PaymentsStrongAuthIssuerInformation
   * @class
   */
  var exports = function() {
    var _this = this;







  };

  /**
   * Constructs a <code>PaymentsStrongAuthIssuerInformation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PaymentsStrongAuthIssuerInformation} obj Optional instance to populate.
   * @return {module:model/PaymentsStrongAuthIssuerInformation} The populated <code>PaymentsStrongAuthIssuerInformation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('riskAnalysisExemptionResult')) {
        obj['riskAnalysisExemptionResult'] = ApiClient.convertToType(data['riskAnalysisExemptionResult'], 'String');
      }
      if (data.hasOwnProperty('trustedMerchantExemptionResult')) {
        obj['trustedMerchantExemptionResult'] = ApiClient.convertToType(data['trustedMerchantExemptionResult'], 'String');
      }
      if (data.hasOwnProperty('lowValueExemptionResult')) {
        obj['lowValueExemptionResult'] = ApiClient.convertToType(data['lowValueExemptionResult'], 'String');
      }
      if (data.hasOwnProperty('secureCorporatePaymentResult')) {
        obj['secureCorporatePaymentResult'] = ApiClient.convertToType(data['secureCorporatePaymentResult'], 'String');
      }
      if (data.hasOwnProperty('transactionRiskAnalysisExemptionResult')) {
        obj['transactionRiskAnalysisExemptionResult'] = ApiClient.convertToType(data['transactionRiskAnalysisExemptionResult'], 'String');
      }
      if (data.hasOwnProperty('delegatedAuthenticationResult')) {
        obj['delegatedAuthenticationResult'] = ApiClient.convertToType(data['delegatedAuthenticationResult'], 'String');
      }
    }
    return obj;
  }

  /**
   * Possible values: Visa Platform Connect - `8401` Merchant not participating in Visa Trusted Listing Program. - `8402` Issuer not participating in Visa Trusted Listing Program. - `8403` Cardholder has not trusted the merchant (supplied by Visa Net). - `8404` Indeterminate or invalid issuer response. - `8473` Cardholder has not trusted the merchant (issuer-supplied). - `8474` Did not meet the exemption criteria (issuer-supplied).  Upto 20 Values may be received in a transaction. 
   * @member {String} riskAnalysisExemptionResult
   */
  exports.prototype['riskAnalysisExemptionResult'] = undefined;
  /**
   * Possible values: Visa Platform Connect - `2` Trusted merchant exemption validated/honored. - `3` Trusted merchant exemption failed validation/not honored. 
   * @member {String} trustedMerchantExemptionResult
   */
  exports.prototype['trustedMerchantExemptionResult'] = undefined;
  /**
   * This will be the value returned by Visanet when low value exemption has been requested.  Valid values: Visa Platform Connect - `2` Low value exemption validated/honored - `3` Low value exemption failed validation/not honored 
   * @member {String} lowValueExemptionResult
   */
  exports.prototype['lowValueExemptionResult'] = undefined;
  /**
   * This will be the value returned by Visanet when secure corporate payment (scp) exemption has been requested.  Valid values: Visa Platform Connect - `2` Secure corporate payment exemption validated/honored - `3` Secure corporate payment exemption failed validation/not honored 
   * @member {String} secureCorporatePaymentResult
   */
  exports.prototype['secureCorporatePaymentResult'] = undefined;
  /**
   * This will be the value returned by Visanet when transaction risk analysis (TRA) exemption has been requested.    Valid values: Visa Platform Connect   - `2` transaction risk analysis (TRA) exemption validated/honored   - `3` transaction risk analysis (TRA) exemption failed validation/not honored 
   * @member {String} transactionRiskAnalysisExemptionResult
   */
  exports.prototype['transactionRiskAnalysisExemptionResult'] = undefined;
  /**
   * This will be the value returned by Visanet when delegated authentication has been requested. 
   * @member {String} delegatedAuthenticationResult
   */
  exports.prototype['delegatedAuthenticationResult'] = undefined;



  return exports;
}));


