/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/GetAllPlansResponseLinks', 'model/PblPaymentLinksAllGet200ResponseOrderInformation', 'model/PblPaymentLinksAllGet200ResponseProcessingInformation', 'model/PblPaymentLinksAllGet200ResponsePurchaseInformation'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./GetAllPlansResponseLinks'), require('./PblPaymentLinksAllGet200ResponseOrderInformation'), require('./PblPaymentLinksAllGet200ResponseProcessingInformation'), require('./PblPaymentLinksAllGet200ResponsePurchaseInformation'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.PblPaymentLinksAllGet200ResponseLinks = factory(root.CyberSource.ApiClient, root.CyberSource.GetAllPlansResponseLinks, root.CyberSource.PblPaymentLinksAllGet200ResponseOrderInformation, root.CyberSource.PblPaymentLinksAllGet200ResponseProcessingInformation, root.CyberSource.PblPaymentLinksAllGet200ResponsePurchaseInformation);
  }
}(this, function(ApiClient, GetAllPlansResponseLinks, PblPaymentLinksAllGet200ResponseOrderInformation, PblPaymentLinksAllGet200ResponseProcessingInformation, PblPaymentLinksAllGet200ResponsePurchaseInformation) {
  'use strict';




  /**
   * The PblPaymentLinksAllGet200ResponseLinks model module.
   * @module model/PblPaymentLinksAllGet200ResponseLinks
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>PblPaymentLinksAllGet200ResponseLinks</code>.
   * A list of purchase or donation links.
   * @alias module:model/PblPaymentLinksAllGet200ResponseLinks
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>PblPaymentLinksAllGet200ResponseLinks</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PblPaymentLinksAllGet200ResponseLinks} obj Optional instance to populate.
   * @return {module:model/PblPaymentLinksAllGet200ResponseLinks} The populated <code>PblPaymentLinksAllGet200ResponseLinks</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('_links')) {
        obj['_links'] = GetAllPlansResponseLinks.constructFromObject(data['_links']);
      }
      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'String');
      }
      if (data.hasOwnProperty('createdDate')) {
        obj['createdDate'] = ApiClient.convertToType(data['createdDate'], 'String');
      }
      if (data.hasOwnProperty('processingInformation')) {
        obj['processingInformation'] = PblPaymentLinksAllGet200ResponseProcessingInformation.constructFromObject(data['processingInformation']);
      }
      if (data.hasOwnProperty('purchaseInformation')) {
        obj['purchaseInformation'] = PblPaymentLinksAllGet200ResponsePurchaseInformation.constructFromObject(data['purchaseInformation']);
      }
      if (data.hasOwnProperty('orderInformation')) {
        obj['orderInformation'] = PblPaymentLinksAllGet200ResponseOrderInformation.constructFromObject(data['orderInformation']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/GetAllPlansResponseLinks} _links
   */
  exports.prototype['_links'] = undefined;
  /**
   * An unique identification number generated by Cybersource to identify the submitted request. Returned by all services. It is also appended to the endpoint of the resource. On incremental authorizations, this value with be the same as the identification number returned in the original authorization response. 
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * The status of the purchase or donation link.  Possible values: - ACTIVE - INACTIVE 
   * @member {String} status
   */
  exports.prototype['status'] = undefined;
  /**
   * Date and time (UTC) the invoice was created.  Format: YYYY-MM-DDThh:mm:ssZ Example 2016-08-11T22:47:57Z equals August 11, 2016, at 22:47:57 (10:47:57 p.m.). The T separates the date and the time. The Z indicates UTC. 
   * @member {String} createdDate
   */
  exports.prototype['createdDate'] = undefined;
  /**
   * @member {module:model/PblPaymentLinksAllGet200ResponseProcessingInformation} processingInformation
   */
  exports.prototype['processingInformation'] = undefined;
  /**
   * @member {module:model/PblPaymentLinksAllGet200ResponsePurchaseInformation} purchaseInformation
   */
  exports.prototype['purchaseInformation'] = undefined;
  /**
   * @member {module:model/PblPaymentLinksAllGet200ResponseOrderInformation} orderInformation
   */
  exports.prototype['orderInformation'] = undefined;



  return exports;
}));


