/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.PtsV2ModifyBillingAgreementPost201ResponseOrderInformationBillTo = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The PtsV2ModifyBillingAgreementPost201ResponseOrderInformationBillTo model module.
   * @module model/PtsV2ModifyBillingAgreementPost201ResponseOrderInformationBillTo
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>PtsV2ModifyBillingAgreementPost201ResponseOrderInformationBillTo</code>.
   * @alias module:model/PtsV2ModifyBillingAgreementPost201ResponseOrderInformationBillTo
   * @class
   */
  var exports = function() {
    var _this = this;










  };

  /**
   * Constructs a <code>PtsV2ModifyBillingAgreementPost201ResponseOrderInformationBillTo</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PtsV2ModifyBillingAgreementPost201ResponseOrderInformationBillTo} obj Optional instance to populate.
   * @return {module:model/PtsV2ModifyBillingAgreementPost201ResponseOrderInformationBillTo} The populated <code>PtsV2ModifyBillingAgreementPost201ResponseOrderInformationBillTo</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('firstName')) {
        obj['firstName'] = ApiClient.convertToType(data['firstName'], 'String');
      }
      if (data.hasOwnProperty('lastName')) {
        obj['lastName'] = ApiClient.convertToType(data['lastName'], 'String');
      }
      if (data.hasOwnProperty('address1')) {
        obj['address1'] = ApiClient.convertToType(data['address1'], 'String');
      }
      if (data.hasOwnProperty('address2')) {
        obj['address2'] = ApiClient.convertToType(data['address2'], 'String');
      }
      if (data.hasOwnProperty('locality')) {
        obj['locality'] = ApiClient.convertToType(data['locality'], 'String');
      }
      if (data.hasOwnProperty('administrativeArea')) {
        obj['administrativeArea'] = ApiClient.convertToType(data['administrativeArea'], 'String');
      }
      if (data.hasOwnProperty('postalCode')) {
        obj['postalCode'] = ApiClient.convertToType(data['postalCode'], 'String');
      }
      if (data.hasOwnProperty('country')) {
        obj['country'] = ApiClient.convertToType(data['country'], 'String');
      }
      if (data.hasOwnProperty('email')) {
        obj['email'] = ApiClient.convertToType(data['email'], 'String');
      }
    }
    return obj;
  }

  /**
   * Customer's first name. 
   * @member {String} firstName
   */
  exports.prototype['firstName'] = undefined;
  /**
   * Customer's last name. 
   * @member {String} lastName
   */
  exports.prototype['lastName'] = undefined;
  /**
   * First line of the billing street address. 
   * @member {String} address1
   */
  exports.prototype['address1'] = undefined;
  /**
   * Additional address information. Example: Attention - Accounts Payable 
   * @member {String} address2
   */
  exports.prototype['address2'] = undefined;
  /**
   * City of the billing address. 
   * @member {String} locality
   */
  exports.prototype['locality'] = undefined;
  /**
   * State of the billing address in the U.S. 
   * @member {String} administrativeArea
   */
  exports.prototype['administrativeArea'] = undefined;
  /**
   * Postal code for the billing address. The postal code must consist of 5 to 9 digits. A 9-digit postal code must follow this format: [5 digits][dash][4 digits]  Example: 12345-6789\" 
   * @member {String} postalCode
   */
  exports.prototype['postalCode'] = undefined;
  /**
   * Billing country. Use the two character ISO Standard Country Codes. 
   * @member {String} country
   */
  exports.prototype['country'] = undefined;
  /**
   * Customer's email address, including the full domain name. 
   * @member {String} email
   */
  exports.prototype['email'] = undefined;



  return exports;
}));


