/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.PtsV2PaymentsPost201ResponseConsumerAuthenticationInformationIvr = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The PtsV2PaymentsPost201ResponseConsumerAuthenticationInformationIvr model module.
   * @module model/PtsV2PaymentsPost201ResponseConsumerAuthenticationInformationIvr
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>PtsV2PaymentsPost201ResponseConsumerAuthenticationInformationIvr</code>.
   * @alias module:model/PtsV2PaymentsPost201ResponseConsumerAuthenticationInformationIvr
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>PtsV2PaymentsPost201ResponseConsumerAuthenticationInformationIvr</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PtsV2PaymentsPost201ResponseConsumerAuthenticationInformationIvr} obj Optional instance to populate.
   * @return {module:model/PtsV2PaymentsPost201ResponseConsumerAuthenticationInformationIvr} The populated <code>PtsV2PaymentsPost201ResponseConsumerAuthenticationInformationIvr</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('enabledMessage')) {
        obj['enabledMessage'] = ApiClient.convertToType(data['enabledMessage'], 'Boolean');
      }
      if (data.hasOwnProperty('encryptionKey')) {
        obj['encryptionKey'] = ApiClient.convertToType(data['encryptionKey'], 'String');
      }
      if (data.hasOwnProperty('encryptionMandatory')) {
        obj['encryptionMandatory'] = ApiClient.convertToType(data['encryptionMandatory'], 'Boolean');
      }
      if (data.hasOwnProperty('encryptionType')) {
        obj['encryptionType'] = ApiClient.convertToType(data['encryptionType'], 'String');
      }
      if (data.hasOwnProperty('label')) {
        obj['label'] = ApiClient.convertToType(data['label'], 'String');
      }
      if (data.hasOwnProperty('prompt')) {
        obj['prompt'] = ApiClient.convertToType(data['prompt'], 'String');
      }
      if (data.hasOwnProperty('statusMessage')) {
        obj['statusMessage'] = ApiClient.convertToType(data['statusMessage'], 'String');
      }
    }
    return obj;
  }

  /**
   * Flag to indicate if a valid IVR transaction was detected. 
   * @member {Boolean} enabledMessage
   */
  exports.prototype['enabledMessage'] = undefined;
  /**
   * Encryption key to be used in the event the ACS requires encryption of the credential field. 
   * @member {String} encryptionKey
   */
  exports.prototype['encryptionKey'] = undefined;
  /**
   * Flag to indicate if the ACS requires the credential to be encrypted. 
   * @member {Boolean} encryptionMandatory
   */
  exports.prototype['encryptionMandatory'] = undefined;
  /**
   * An indicator from the ACS to inform the type of encryption that should be used in the event the ACS requires encryption of the credential field. 
   * @member {String} encryptionType
   */
  exports.prototype['encryptionType'] = undefined;
  /**
   * An ACS Provided label that can be presented to the Consumer. Recommended use with an application. 
   * @member {String} label
   */
  exports.prototype['label'] = undefined;
  /**
   * An ACS provided string that can be presented to the Consumer. Recommended use with an application. 
   * @member {String} prompt
   */
  exports.prototype['prompt'] = undefined;
  /**
   * An ACS provided message that can provide additional information or details. 
   * @member {String} statusMessage
   */
  exports.prototype['statusMessage'] = undefined;



  return exports;
}));


