/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.PtsV2PaymentsPost201ResponseOrderInformationRewardPointsDetails = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The PtsV2PaymentsPost201ResponseOrderInformationRewardPointsDetails model module.
   * @module model/PtsV2PaymentsPost201ResponseOrderInformationRewardPointsDetails
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>PtsV2PaymentsPost201ResponseOrderInformationRewardPointsDetails</code>.
   * @alias module:model/PtsV2PaymentsPost201ResponseOrderInformationRewardPointsDetails
   * @class
   */
  var exports = function() {
    var _this = this;







  };

  /**
   * Constructs a <code>PtsV2PaymentsPost201ResponseOrderInformationRewardPointsDetails</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PtsV2PaymentsPost201ResponseOrderInformationRewardPointsDetails} obj Optional instance to populate.
   * @return {module:model/PtsV2PaymentsPost201ResponseOrderInformationRewardPointsDetails} The populated <code>PtsV2PaymentsPost201ResponseOrderInformationRewardPointsDetails</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('pointsBeforeRedemption')) {
        obj['pointsBeforeRedemption'] = ApiClient.convertToType(data['pointsBeforeRedemption'], 'String');
      }
      if (data.hasOwnProperty('pointsValueBeforeRedemption')) {
        obj['pointsValueBeforeRedemption'] = ApiClient.convertToType(data['pointsValueBeforeRedemption'], 'String');
      }
      if (data.hasOwnProperty('pointsRedeemed')) {
        obj['pointsRedeemed'] = ApiClient.convertToType(data['pointsRedeemed'], 'String');
      }
      if (data.hasOwnProperty('pointsValueRedeemed')) {
        obj['pointsValueRedeemed'] = ApiClient.convertToType(data['pointsValueRedeemed'], 'String');
      }
      if (data.hasOwnProperty('pointsAfterRedemption')) {
        obj['pointsAfterRedemption'] = ApiClient.convertToType(data['pointsAfterRedemption'], 'String');
      }
      if (data.hasOwnProperty('pointsValueAfterRedemption')) {
        obj['pointsValueAfterRedemption'] = ApiClient.convertToType(data['pointsValueAfterRedemption'], 'String');
      }
    }
    return obj;
  }

  /**
   * Loyalty points total balance before redemption. For Example: Points, such as 100 
   * @member {String} pointsBeforeRedemption
   */
  exports.prototype['pointsBeforeRedemption'] = undefined;
  /**
   * The total value of loyalty points before redemption in the default currency. Max characters is 12 excluding the \".\" symbol For Example: Points, such as 20.00 
   * @member {String} pointsValueBeforeRedemption
   */
  exports.prototype['pointsValueBeforeRedemption'] = undefined;
  /**
   * Number of loyalty points that were redeemed. For Example: Points, such as 100 
   * @member {String} pointsRedeemed
   */
  exports.prototype['pointsRedeemed'] = undefined;
  /**
   * The value of the loyalty points that were redeemed in the default currency. Max characters is 12 excluding the \".\" symbol For Example: Points, such as 100.00 
   * @member {String} pointsValueRedeemed
   */
  exports.prototype['pointsValueRedeemed'] = undefined;
  /**
   * Loyalty Points remaining total balance after redemption. For Example: Points, such as 20.00 
   * @member {String} pointsAfterRedemption
   */
  exports.prototype['pointsAfterRedemption'] = undefined;
  /**
   * The value of the remaining loyalty points after redumption in the default currency. Max characters is 12 excluding the \".\" symbol For Example: Points, such as 20.00 
   * @member {String} pointsValueAfterRedemption
   */
  exports.prototype['pointsValueAfterRedemption'] = undefined;



  return exports;
}));


