/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.PtsV2PaymentsPost201ResponseRiskInformationInfoCodes = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The PtsV2PaymentsPost201ResponseRiskInformationInfoCodes model module.
   * @module model/PtsV2PaymentsPost201ResponseRiskInformationInfoCodes
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>PtsV2PaymentsPost201ResponseRiskInformationInfoCodes</code>.
   * @alias module:model/PtsV2PaymentsPost201ResponseRiskInformationInfoCodes
   * @class
   */
  var exports = function() {
    var _this = this;










  };

  /**
   * Constructs a <code>PtsV2PaymentsPost201ResponseRiskInformationInfoCodes</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PtsV2PaymentsPost201ResponseRiskInformationInfoCodes} obj Optional instance to populate.
   * @return {module:model/PtsV2PaymentsPost201ResponseRiskInformationInfoCodes} The populated <code>PtsV2PaymentsPost201ResponseRiskInformationInfoCodes</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('velocity')) {
        obj['velocity'] = ApiClient.convertToType(data['velocity'], ['String']);
      }
      if (data.hasOwnProperty('address')) {
        obj['address'] = ApiClient.convertToType(data['address'], ['String']);
      }
      if (data.hasOwnProperty('customerList')) {
        obj['customerList'] = ApiClient.convertToType(data['customerList'], ['String']);
      }
      if (data.hasOwnProperty('deviceBehavior')) {
        obj['deviceBehavior'] = ApiClient.convertToType(data['deviceBehavior'], ['String']);
      }
      if (data.hasOwnProperty('identityChange')) {
        obj['identityChange'] = ApiClient.convertToType(data['identityChange'], ['String']);
      }
      if (data.hasOwnProperty('internet')) {
        obj['internet'] = ApiClient.convertToType(data['internet'], ['String']);
      }
      if (data.hasOwnProperty('phone')) {
        obj['phone'] = ApiClient.convertToType(data['phone'], ['String']);
      }
      if (data.hasOwnProperty('suspicious')) {
        obj['suspicious'] = ApiClient.convertToType(data['suspicious'], ['String']);
      }
      if (data.hasOwnProperty('globalVelocity')) {
        obj['globalVelocity'] = ApiClient.convertToType(data['globalVelocity'], ['String']);
      }
    }
    return obj;
  }

  /**
   * List of information codes triggered by the order. These information codes were generated when you created the order and product velocity rules and are returned so that you can associate them with the rules. 
   * @member {Array.<String>} velocity
   */
  exports.prototype['velocity'] = undefined;
  /**
   * Indicates a mismatch between the customer's billing and shipping addresses. 
   * @member {Array.<String>} address
   */
  exports.prototype['address'] = undefined;
  /**
   * Indicates that customer information is associated with transactions that are either on the negative or the positive list. 
   * @member {Array.<String>} customerList
   */
  exports.prototype['customerList'] = undefined;
  /**
   * Indicates the device behavior information code(s) returned from device fingerprinting. 
   * @member {Array.<String>} deviceBehavior
   */
  exports.prototype['deviceBehavior'] = undefined;
  /**
   * Indicates excessive identity changes. The threshold is variable depending on the identity elements being compared. 
   * @member {Array.<String>} identityChange
   */
  exports.prototype['identityChange'] = undefined;
  /**
   * Indicates a problem with the customer's email address, IP address, or billing address. 
   * @member {Array.<String>} internet
   */
  exports.prototype['internet'] = undefined;
  /**
   * Indicates a problem with the customer's phone number. 
   * @member {Array.<String>} phone
   */
  exports.prototype['phone'] = undefined;
  /**
   * Indicates that the customer provided potentially suspicious information. 
   * @member {Array.<String>} suspicious
   */
  exports.prototype['suspicious'] = undefined;
  /**
   * Indicates that the customer has a high purchase frequency. 
   * @member {Array.<String>} globalVelocity
   */
  exports.prototype['globalVelocity'] = undefined;



  return exports;
}));


