/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Ptsv1pushfundstransferRecipientInformationPersonalIdentification = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Ptsv1pushfundstransferRecipientInformationPersonalIdentification model module.
   * @module model/Ptsv1pushfundstransferRecipientInformationPersonalIdentification
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Ptsv1pushfundstransferRecipientInformationPersonalIdentification</code>.
   * @alias module:model/Ptsv1pushfundstransferRecipientInformationPersonalIdentification
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>Ptsv1pushfundstransferRecipientInformationPersonalIdentification</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Ptsv1pushfundstransferRecipientInformationPersonalIdentification} obj Optional instance to populate.
   * @return {module:model/Ptsv1pushfundstransferRecipientInformationPersonalIdentification} The populated <code>Ptsv1pushfundstransferRecipientInformationPersonalIdentification</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('issuingCountry')) {
        obj['issuingCountry'] = ApiClient.convertToType(data['issuingCountry'], 'String');
      }
      if (data.hasOwnProperty('personalIdType')) {
        obj['personalIdType'] = ApiClient.convertToType(data['personalIdType'], 'String');
      }
    }
    return obj;
  }

  /**
   * The ID number/value. Processor(35) 
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * This tag will contain the type of sender identification. The valid values are: - `BTHD`: (Date of birth) - `CUID`: (Customer identification (unspecified)) - `NTID`: (National identification) - `PASN`: (Passport number) - `DRLN`: (Driver license) - `TXIN`: (Tax identification) - `CPNY`: (Company registration number) - `PRXY`: (Proxy identification) - `SSNB`: (Social security number) - `ARNB`: (Alien registration number) - `LAWE`: (Law enforcement identification) - `MILI`: (Military identification) - `TRVL`: (Travel identification (non-passport)) - `EMAL`: (Email) - `PHON`: (Phone number) 
   * @member {String} type
   */
  exports.prototype['type'] = undefined;
  /**
   * Issuing country of the identification. The field format should be a 2 character ISO 3166-1 alpha-2 country code. 
   * @member {String} issuingCountry
   */
  exports.prototype['issuingCountry'] = undefined;
  /**
   * This tag will denote whether the tax ID is a business or individual tax ID when personal ID Type contains the value of TXIN (Tax identification).  The valid values are:  - `B` (Business) - `I` (Individual) 
   * @member {String} personalIdType
   */
  exports.prototype['personalIdType'] = undefined;



  return exports;
}));


