/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Ptsv2intentsProcessingInformationAuthorizationOptions'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Ptsv2intentsProcessingInformationAuthorizationOptions'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Ptsv2intentsProcessingInformation = factory(root.CyberSource.ApiClient, root.CyberSource.Ptsv2intentsProcessingInformationAuthorizationOptions);
  }
}(this, function(ApiClient, Ptsv2intentsProcessingInformationAuthorizationOptions) {
  'use strict';




  /**
   * The Ptsv2intentsProcessingInformation model module.
   * @module model/Ptsv2intentsProcessingInformation
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Ptsv2intentsProcessingInformation</code>.
   * @alias module:model/Ptsv2intentsProcessingInformation
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>Ptsv2intentsProcessingInformation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Ptsv2intentsProcessingInformation} obj Optional instance to populate.
   * @return {module:model/Ptsv2intentsProcessingInformation} The populated <code>Ptsv2intentsProcessingInformation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('processingInstruction')) {
        obj['processingInstruction'] = ApiClient.convertToType(data['processingInstruction'], 'String');
      }
      if (data.hasOwnProperty('authorizationOptions')) {
        obj['authorizationOptions'] = Ptsv2intentsProcessingInformationAuthorizationOptions.constructFromObject(data['authorizationOptions']);
      }
      if (data.hasOwnProperty('actionList')) {
        obj['actionList'] = ApiClient.convertToType(data['actionList'], ['String']);
      }
    }
    return obj;
  }

  /**
   * The instruction to process an order. - default value: 'NO_INSTRUCTION' - 'ORDER_SAVED_EXPLICITLY' 
   * @member {String} processingInstruction
   */
  exports.prototype['processingInstruction'] = undefined;
  /**
   * @member {module:model/Ptsv2intentsProcessingInformationAuthorizationOptions} authorizationOptions
   */
  exports.prototype['authorizationOptions'] = undefined;
  /**
   * Array of actions (one or more) to be included in the order to invoke bundled services along with order. Possible values: - `AP_ORDER`: Use this when Alternative Payment Order service is requested. 
   * @member {Array.<String>} actionList
   */
  exports.prototype['actionList'] = undefined;



  return exports;
}));


