/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Ptsv2paymentsProcessingInformationPurchaseOptions = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Ptsv2paymentsProcessingInformationPurchaseOptions model module.
   * @module model/Ptsv2paymentsProcessingInformationPurchaseOptions
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Ptsv2paymentsProcessingInformationPurchaseOptions</code>.
   * @alias module:model/Ptsv2paymentsProcessingInformationPurchaseOptions
   * @class
   */
  var exports = function() {
    var _this = this;






  };

  /**
   * Constructs a <code>Ptsv2paymentsProcessingInformationPurchaseOptions</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Ptsv2paymentsProcessingInformationPurchaseOptions} obj Optional instance to populate.
   * @return {module:model/Ptsv2paymentsProcessingInformationPurchaseOptions} The populated <code>Ptsv2paymentsProcessingInformationPurchaseOptions</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('isElectronicBenefitsTransfer')) {
        obj['isElectronicBenefitsTransfer'] = ApiClient.convertToType(data['isElectronicBenefitsTransfer'], 'Boolean');
      }
      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('eligibilityIndicator')) {
        obj['eligibilityIndicator'] = ApiClient.convertToType(data['eligibilityIndicator'], 'String');
      }
      if (data.hasOwnProperty('benefitAmount')) {
        obj['benefitAmount'] = ApiClient.convertToType(data['benefitAmount'], 'String');
      }
      if (data.hasOwnProperty('benefitType')) {
        obj['benefitType'] = ApiClient.convertToType(data['benefitType'], 'String');
      }
    }
    return obj;
  }

  /**
   * Flag that indicates whether this transaction is an EBT transaction. Possible values: - `true` - `false`  #### PIN debit Required field for EBT and EBT voucher transactions that use PIN debit credit or PIN debit purchase; otherwise, not used. 
   * @member {Boolean} isElectronicBenefitsTransfer
   */
  exports.prototype['isElectronicBenefitsTransfer'] = undefined;
  /**
   * Flag that indicates an EBT voucher transaction. Possible value: - `EBT_VOUCHER`: Indicates the PIN debit transaction is an EBT voucher. - `BUY` - `RENT` - `BOOK` - `SUBSCRIBE` - `DOWNLOAD` - `ORDER` - `CONTINUE`  #### PIN debit Required field for EBT voucher transactions that use PIN debit purchase; otherwise, not used. 
   * @member {String} type
   */
  exports.prototype['type'] = undefined;
  /**
   * This field contains installment data defined by MasterCard. Possible values:   - Y = eligible   - N = not eligile 
   * @member {String} eligibilityIndicator
   */
  exports.prototype['eligibilityIndicator'] = undefined;
  /**
   * Workplace benefit amount.
   * @member {String} benefitAmount
   */
  exports.prototype['benefitAmount'] = undefined;
  /**
   * Workplace benefit type. Possible values: - 70 = employee benefit - 4T = transportation / transit - 52 = general benefit - 53 = meal voucher - 54 = fuel - 55 = ecological / sustainability - 58 = philanthropy / patronage / consumption - 59 = gift - 5S = sport / culture - 5T = book / education 
   * @member {String} benefitType
   */
  exports.prototype['benefitType'] = undefined;



  return exports;
}));


