/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Ptsv2paymentsSenderInformationAccount = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Ptsv2paymentsSenderInformationAccount model module.
   * @module model/Ptsv2paymentsSenderInformationAccount
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Ptsv2paymentsSenderInformationAccount</code>.
   * @alias module:model/Ptsv2paymentsSenderInformationAccount
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>Ptsv2paymentsSenderInformationAccount</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Ptsv2paymentsSenderInformationAccount} obj Optional instance to populate.
   * @return {module:model/Ptsv2paymentsSenderInformationAccount} The populated <code>Ptsv2paymentsSenderInformationAccount</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('number')) {
        obj['number'] = ApiClient.convertToType(data['number'], 'String');
      }
      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('fundsSource')) {
        obj['fundsSource'] = ApiClient.convertToType(data['fundsSource'], 'String');
      }
    }
    return obj;
  }

  /**
   * The account number of the entity funding the transaction. The value for this field can be a payment card account number or bank account number. 
   * @member {String} number
   */
  exports.prototype['number'] = undefined;
  /**
   * Identifies the sender's account type. This field is applicable for AFT transactions.  Valid values are:   - `00` for Other   - `01` for Routing Transit Number (RTN) + Bank Account Number (BAN)   - `02` for International Bank Account Number (IBAN)   - `03` for Card Account   - `04` for Email   - `05` for Phone Number   - `06` for Bank Account Number (BAN) + Bank Identification Code (BIC), also known as a SWIFT code   - `07` for Wallet ID   - `08` for Social Network ID 
   * @member {String} type
   */
  exports.prototype['type'] = undefined;
  /**
   * Source of funds. Possible Values:  - `01`: Credit.  - `02`: Debit.  - `03`: Prepaid.  - `04`: Deposit Account.  - `05`: Mobile Money Account.  - `06`: Cash.  - `07`: Other.  - `V5`: Debits / deposit access other than those linked to the cardholders' scheme.  - `V6`: Credit accounts other than those linked to the cardholder's scheme. 
   * @member {String} fundsSource
   */
  exports.prototype['fundsSource'] = undefined;



  return exports;
}));


