/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Ptsv2paymentsTokenInformationTokenProvisioningInformation = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Ptsv2paymentsTokenInformationTokenProvisioningInformation model module.
   * @module model/Ptsv2paymentsTokenInformationTokenProvisioningInformation
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Ptsv2paymentsTokenInformationTokenProvisioningInformation</code>.
   * @alias module:model/Ptsv2paymentsTokenInformationTokenProvisioningInformation
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>Ptsv2paymentsTokenInformationTokenProvisioningInformation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Ptsv2paymentsTokenInformationTokenProvisioningInformation} obj Optional instance to populate.
   * @return {module:model/Ptsv2paymentsTokenInformationTokenProvisioningInformation} The populated <code>Ptsv2paymentsTokenInformationTokenProvisioningInformation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('consumerConsentObtained')) {
        obj['consumerConsentObtained'] = ApiClient.convertToType(data['consumerConsentObtained'], 'Boolean');
      }
      if (data.hasOwnProperty('multiFactorAuthenticated')) {
        obj['multiFactorAuthenticated'] = ApiClient.convertToType(data['multiFactorAuthenticated'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * Flag that indicates whether the user consented to the tokenization of their credentials. Required for card network tokenization in certain markets, such as India. Possible Values: - `true`: Consumer has consented to tokenization of their credentials. - `false`: Consumer has not consented to tokenization of their credentials. 
   * @member {Boolean} consumerConsentObtained
   */
  exports.prototype['consumerConsentObtained'] = undefined;
  /**
   * Flag that indicates whether AFA (Additional Factor of Authentication) for the PAN was completed. Required for card network tokenization in certain markets, such as India. Possible Values: - `true`: Consumer has been authenticated by the issuer. - `false`: Consumer has not been authenticated by the issuer. 
   * @member {Boolean} multiFactorAuthenticated
   */
  exports.prototype['multiFactorAuthenticated'] = undefined;



  return exports;
}));


