/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Ptsv2paymentsWatchlistScreeningInformationWeights'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Ptsv2paymentsWatchlistScreeningInformationWeights'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Ptsv2paymentsWatchlistScreeningInformation = factory(root.CyberSource.ApiClient, root.CyberSource.Ptsv2paymentsWatchlistScreeningInformationWeights);
  }
}(this, function(ApiClient, Ptsv2paymentsWatchlistScreeningInformationWeights) {
  'use strict';




  /**
   * The Ptsv2paymentsWatchlistScreeningInformation model module.
   * @module model/Ptsv2paymentsWatchlistScreeningInformation
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Ptsv2paymentsWatchlistScreeningInformation</code>.
   * @alias module:model/Ptsv2paymentsWatchlistScreeningInformation
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>Ptsv2paymentsWatchlistScreeningInformation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Ptsv2paymentsWatchlistScreeningInformation} obj Optional instance to populate.
   * @return {module:model/Ptsv2paymentsWatchlistScreeningInformation} The populated <code>Ptsv2paymentsWatchlistScreeningInformation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('addressOperator')) {
        obj['addressOperator'] = ApiClient.convertToType(data['addressOperator'], 'String');
      }
      if (data.hasOwnProperty('weights')) {
        obj['weights'] = Ptsv2paymentsWatchlistScreeningInformationWeights.constructFromObject(data['weights']);
      }
      if (data.hasOwnProperty('sanctionLists')) {
        obj['sanctionLists'] = ApiClient.convertToType(data['sanctionLists'], ['String']);
      }
      if (data.hasOwnProperty('proceedOnMatch')) {
        obj['proceedOnMatch'] = ApiClient.convertToType(data['proceedOnMatch'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * Parts of the customer's information that must match with an entry in the DPL (denied parties list) before a match occurs. This field can contain one of the following values: - AND: (default) The customer's name or company and the customer's address must appear in the database. - OR: The customer's name must appear in the database. - IGNORE: You want the service to detect a match only of the customer's name or company but not of the address. 
   * @member {String} addressOperator
   */
  exports.prototype['addressOperator'] = undefined;
  /**
   * @member {module:model/Ptsv2paymentsWatchlistScreeningInformationWeights} weights
   */
  exports.prototype['weights'] = undefined;
  /**
   * Use this field to specify which list(s) you want checked with the request. The reply will include the list name as well as the response data. To check against multiple lists, enter multiple list codes separated by a caret (^). For more information, see \"Restricted and Denied Parties List,\" page 68. 
   * @member {Array.<String>} sanctionLists
   */
  exports.prototype['sanctionLists'] = undefined;
  /**
   * Indicates whether the transaction should proceed if there is a match. Possible values: - `true`: Transaction proceeds even when match is found in the Denied Parties List. The match is noted in the response. - `false`: Normal watchlist screening behavior occurs. (Transaction stops if a match to DPL occurs. Transaction proceeds if no match.) 
   * @member {Boolean} proceedOnMatch
   */
  exports.prototype['proceedOnMatch'] = undefined;



  return exports;
}));


