/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Ptsv2paymentsidcapturesProcessingInformationCaptureOptions = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Ptsv2paymentsidcapturesProcessingInformationCaptureOptions model module.
   * @module model/Ptsv2paymentsidcapturesProcessingInformationCaptureOptions
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Ptsv2paymentsidcapturesProcessingInformationCaptureOptions</code>.
   * @alias module:model/Ptsv2paymentsidcapturesProcessingInformationCaptureOptions
   * @class
   */
  var exports = function() {
    var _this = this;






  };

  /**
   * Constructs a <code>Ptsv2paymentsidcapturesProcessingInformationCaptureOptions</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Ptsv2paymentsidcapturesProcessingInformationCaptureOptions} obj Optional instance to populate.
   * @return {module:model/Ptsv2paymentsidcapturesProcessingInformationCaptureOptions} The populated <code>Ptsv2paymentsidcapturesProcessingInformationCaptureOptions</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('captureSequenceNumber')) {
        obj['captureSequenceNumber'] = ApiClient.convertToType(data['captureSequenceNumber'], 'Number');
      }
      if (data.hasOwnProperty('totalCaptureCount')) {
        obj['totalCaptureCount'] = ApiClient.convertToType(data['totalCaptureCount'], 'Number');
      }
      if (data.hasOwnProperty('isFinal')) {
        obj['isFinal'] = ApiClient.convertToType(data['isFinal'], 'String');
      }
      if (data.hasOwnProperty('notes')) {
        obj['notes'] = ApiClient.convertToType(data['notes'], 'String');
      }
      if (data.hasOwnProperty('reconciliationIdAlternate')) {
        obj['reconciliationIdAlternate'] = ApiClient.convertToType(data['reconciliationIdAlternate'], 'String');
      }
    }
    return obj;
  }

  /**
   * Capture number when requesting multiple partial captures for one authorization. Used along with `totalCaptureCount` to track which capture is being processed.  For example, the second of five captures would be passed to CyberSource as:   - `captureSequenceNumber_ = 2`, and   - `totalCaptureCount = 5` 
   * @member {Number} captureSequenceNumber
   */
  exports.prototype['captureSequenceNumber'] = undefined;
  /**
   * Total number of captures when requesting multiple partial captures for one payment. Used along with `captureSequenceNumber` field to track which capture is being processed.  For example, the second of five captures would be passed to CyberSource as:   - `captureSequenceNumber = 2`, and   - `totalCaptureCount = 5` 
   * @member {Number} totalCaptureCount
   */
  exports.prototype['totalCaptureCount'] = undefined;
  /**
   * Indicates whether to release the authorization hold on the remaining funds.   Possible Values: - `true` - `false` 
   * @member {String} isFinal
   */
  exports.prototype['isFinal'] = undefined;
  /**
   * An informational note about this settlement. Appears in both the payer's transaction history and the emails that the payer receives. 
   * @member {String} notes
   */
  exports.prototype['notes'] = undefined;
  /**
   * Used by Nike merchant to send 12 digit order number
   * @member {String} reconciliationIdAlternate
   */
  exports.prototype['reconciliationIdAlternate'] = undefined;



  return exports;
}));


