/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Ptsv2payoutsAggregatorInformationSubMerchant'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Ptsv2payoutsAggregatorInformationSubMerchant'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Ptsv2payoutsAggregatorInformation = factory(root.CyberSource.ApiClient, root.CyberSource.Ptsv2payoutsAggregatorInformationSubMerchant);
  }
}(this, function(ApiClient, Ptsv2payoutsAggregatorInformationSubMerchant) {
  'use strict';




  /**
   * The Ptsv2payoutsAggregatorInformation model module.
   * @module model/Ptsv2payoutsAggregatorInformation
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Ptsv2payoutsAggregatorInformation</code>.
   * @alias module:model/Ptsv2payoutsAggregatorInformation
   * @class
   */
  var exports = function() {
    var _this = this;










  };

  /**
   * Constructs a <code>Ptsv2payoutsAggregatorInformation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Ptsv2payoutsAggregatorInformation} obj Optional instance to populate.
   * @return {module:model/Ptsv2payoutsAggregatorInformation} The populated <code>Ptsv2payoutsAggregatorInformation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('aggregatorId')) {
        obj['aggregatorId'] = ApiClient.convertToType(data['aggregatorId'], 'String');
      }
      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('independentSalesOrganizationID')) {
        obj['independentSalesOrganizationID'] = ApiClient.convertToType(data['independentSalesOrganizationID'], 'String');
      }
      if (data.hasOwnProperty('subMerchant')) {
        obj['subMerchant'] = Ptsv2payoutsAggregatorInformationSubMerchant.constructFromObject(data['subMerchant']);
      }
      if (data.hasOwnProperty('streetAddress')) {
        obj['streetAddress'] = ApiClient.convertToType(data['streetAddress'], 'String');
      }
      if (data.hasOwnProperty('city')) {
        obj['city'] = ApiClient.convertToType(data['city'], 'String');
      }
      if (data.hasOwnProperty('state')) {
        obj['state'] = ApiClient.convertToType(data['state'], 'String');
      }
      if (data.hasOwnProperty('postalCode')) {
        obj['postalCode'] = ApiClient.convertToType(data['postalCode'], 'String');
      }
      if (data.hasOwnProperty('country')) {
        obj['country'] = ApiClient.convertToType(data['country'], 'String');
      }
    }
    return obj;
  }

  /**
   * Value that identifies you as a payment aggregator. Get this value from the processor. 
   * @member {String} aggregatorId
   */
  exports.prototype['aggregatorId'] = undefined;
  /**
   * Your payment aggregator business name. This field is conditionally required when aggregator id is present. 
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Independent sales organization ID. This field is only used for Mastercard transactions submitted through PPGS. 
   * @member {String} independentSalesOrganizationID
   */
  exports.prototype['independentSalesOrganizationID'] = undefined;
  /**
   * @member {module:model/Ptsv2payoutsAggregatorInformationSubMerchant} subMerchant
   */
  exports.prototype['subMerchant'] = undefined;
  /**
   * Acquirer street name.
   * @member {String} streetAddress
   */
  exports.prototype['streetAddress'] = undefined;
  /**
   * Acquirer city.
   * @member {String} city
   */
  exports.prototype['city'] = undefined;
  /**
   * Acquirer state.
   * @member {String} state
   */
  exports.prototype['state'] = undefined;
  /**
   * Acquirer postal code.
   * @member {String} postalCode
   */
  exports.prototype['postalCode'] = undefined;
  /**
   * Acquirer country.
   * @member {String} country
   */
  exports.prototype['country'] = undefined;



  return exports;
}));


