/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Ptsv2payoutsProcessingInformationFundingOptions', 'model/Ptsv2payoutsProcessingInformationPayoutsOptions', 'model/Ptsv2payoutsProcessingInformationPurchaseOptions'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Ptsv2payoutsProcessingInformationFundingOptions'), require('./Ptsv2payoutsProcessingInformationPayoutsOptions'), require('./Ptsv2payoutsProcessingInformationPurchaseOptions'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Ptsv2payoutsProcessingInformation = factory(root.CyberSource.ApiClient, root.CyberSource.Ptsv2payoutsProcessingInformationFundingOptions, root.CyberSource.Ptsv2payoutsProcessingInformationPayoutsOptions, root.CyberSource.Ptsv2payoutsProcessingInformationPurchaseOptions);
  }
}(this, function(ApiClient, Ptsv2payoutsProcessingInformationFundingOptions, Ptsv2payoutsProcessingInformationPayoutsOptions, Ptsv2payoutsProcessingInformationPurchaseOptions) {
  'use strict';




  /**
   * The Ptsv2payoutsProcessingInformation model module.
   * @module model/Ptsv2payoutsProcessingInformation
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Ptsv2payoutsProcessingInformation</code>.
   * @alias module:model/Ptsv2payoutsProcessingInformation
   * @class
   */
  var exports = function() {
    var _this = this;











  };

  /**
   * Constructs a <code>Ptsv2payoutsProcessingInformation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Ptsv2payoutsProcessingInformation} obj Optional instance to populate.
   * @return {module:model/Ptsv2payoutsProcessingInformation} The populated <code>Ptsv2payoutsProcessingInformation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('businessApplicationId')) {
        obj['businessApplicationId'] = ApiClient.convertToType(data['businessApplicationId'], 'String');
      }
      if (data.hasOwnProperty('networkRoutingOrder')) {
        obj['networkRoutingOrder'] = ApiClient.convertToType(data['networkRoutingOrder'], 'String');
      }
      if (data.hasOwnProperty('commerceIndicator')) {
        obj['commerceIndicator'] = ApiClient.convertToType(data['commerceIndicator'], 'String');
      }
      if (data.hasOwnProperty('reconciliationId')) {
        obj['reconciliationId'] = ApiClient.convertToType(data['reconciliationId'], 'String');
      }
      if (data.hasOwnProperty('payoutsOptions')) {
        obj['payoutsOptions'] = Ptsv2payoutsProcessingInformationPayoutsOptions.constructFromObject(data['payoutsOptions']);
      }
      if (data.hasOwnProperty('transactionReason')) {
        obj['transactionReason'] = ApiClient.convertToType(data['transactionReason'], 'String');
      }
      if (data.hasOwnProperty('purposeOfPayment')) {
        obj['purposeOfPayment'] = ApiClient.convertToType(data['purposeOfPayment'], 'String');
      }
      if (data.hasOwnProperty('fundingOptions')) {
        obj['fundingOptions'] = Ptsv2payoutsProcessingInformationFundingOptions.constructFromObject(data['fundingOptions']);
      }
      if (data.hasOwnProperty('languageCode')) {
        obj['languageCode'] = ApiClient.convertToType(data['languageCode'], 'String');
      }
      if (data.hasOwnProperty('purchaseOptions')) {
        obj['purchaseOptions'] = Ptsv2payoutsProcessingInformationPurchaseOptions.constructFromObject(data['purchaseOptions']);
      }
    }
    return obj;
  }

  /**
   * Payouts transaction type.  Applicable Processors: FDC Compass, Paymentech, CtV  Possible values:  **Credit Card Bill Payment**   - **CP**: credit card bill payment  **Funds Disbursement**   - **FD**: funds disbursement  - **GD**: government disbursement  - **MD**: merchant disbursement  **Money Transfer**   - **AA**: account to account. Sender and receiver are same person.  - **PP**: person to person. Sender and receiver are different.  **Prepaid Load**   - **TU**: top up 
   * @member {String} businessApplicationId
   */
  exports.prototype['businessApplicationId'] = undefined;
  /**
   * This field is optionally used by Push Payments Gateway participants (merchants and acquirers) to get the attributes for specified networks only. The networks specified in this field must be a subset of the information provided during program enrollment. Refer to Sharing Group Code/Network Routing Order. Note: Supported only in US for domestic transactions involving Push Payments Gateway Service.  VisaNet checks to determine if there are issuer routing preferences for any of the networks specified by the network routing order. If an issuer preference exists for one of the specified debit networks, VisaNet makes a routing selection based on the issuer's preference.  If an issuer preference exists for more than one of the specified debit networks, or if no issuer preference exists, VisaNet makes a selection based on the acquirer's routing priorities.  
   * @member {String} networkRoutingOrder
   */
  exports.prototype['networkRoutingOrder'] = undefined;
  /**
   * Type of transaction.  Value for an OCT transaction: - `internet` 
   * @member {String} commerceIndicator
   */
  exports.prototype['commerceIndicator'] = undefined;
  /**
   * Please check with Cybersource customer support to see if your merchant account is configured correctly so you can include this field in your request. * For Payouts: max length for FDCCompass is String (22). 
   * @member {String} reconciliationId
   */
  exports.prototype['reconciliationId'] = undefined;
  /**
   * @member {module:model/Ptsv2payoutsProcessingInformationPayoutsOptions} payoutsOptions
   */
  exports.prototype['payoutsOptions'] = undefined;
  /**
   * Transaction reason code. 
   * @member {String} transactionReason
   */
  exports.prototype['transactionReason'] = undefined;
  /**
   * This field is applicable for AFT and OCT transactions. For list of supported values, please refer to Developer Guide. 
   * @member {String} purposeOfPayment
   */
  exports.prototype['purposeOfPayment'] = undefined;
  /**
   * @member {module:model/Ptsv2payoutsProcessingInformationFundingOptions} fundingOptions
   */
  exports.prototype['fundingOptions'] = undefined;
  /**
   * Contains the ISO 639-2 defined language Code 
   * @member {String} languageCode
   */
  exports.prototype['languageCode'] = undefined;
  /**
   * @member {module:model/Ptsv2payoutsProcessingInformationPurchaseOptions} purchaseOptions
   */
  exports.prototype['purchaseOptions'] = undefined;



  return exports;
}));


