/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Ptsv2payoutsRecipientInformation = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Ptsv2payoutsRecipientInformation model module.
   * @module model/Ptsv2payoutsRecipientInformation
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Ptsv2payoutsRecipientInformation</code>.
   * @alias module:model/Ptsv2payoutsRecipientInformation
   * @class
   */
  var exports = function() {
    var _this = this;















  };

  /**
   * Constructs a <code>Ptsv2payoutsRecipientInformation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Ptsv2payoutsRecipientInformation} obj Optional instance to populate.
   * @return {module:model/Ptsv2payoutsRecipientInformation} The populated <code>Ptsv2payoutsRecipientInformation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('firstName')) {
        obj['firstName'] = ApiClient.convertToType(data['firstName'], 'String');
      }
      if (data.hasOwnProperty('middleName')) {
        obj['middleName'] = ApiClient.convertToType(data['middleName'], 'String');
      }
      if (data.hasOwnProperty('lastName')) {
        obj['lastName'] = ApiClient.convertToType(data['lastName'], 'String');
      }
      if (data.hasOwnProperty('address1')) {
        obj['address1'] = ApiClient.convertToType(data['address1'], 'String');
      }
      if (data.hasOwnProperty('locality')) {
        obj['locality'] = ApiClient.convertToType(data['locality'], 'String');
      }
      if (data.hasOwnProperty('administrativeArea')) {
        obj['administrativeArea'] = ApiClient.convertToType(data['administrativeArea'], 'String');
      }
      if (data.hasOwnProperty('country')) {
        obj['country'] = ApiClient.convertToType(data['country'], 'String');
      }
      if (data.hasOwnProperty('postalCode')) {
        obj['postalCode'] = ApiClient.convertToType(data['postalCode'], 'String');
      }
      if (data.hasOwnProperty('phoneNumber')) {
        obj['phoneNumber'] = ApiClient.convertToType(data['phoneNumber'], 'String');
      }
      if (data.hasOwnProperty('aliasName')) {
        obj['aliasName'] = ApiClient.convertToType(data['aliasName'], 'String');
      }
      if (data.hasOwnProperty('nationality')) {
        obj['nationality'] = ApiClient.convertToType(data['nationality'], 'String');
      }
      if (data.hasOwnProperty('countryOfBirth')) {
        obj['countryOfBirth'] = ApiClient.convertToType(data['countryOfBirth'], 'String');
      }
      if (data.hasOwnProperty('occupation')) {
        obj['occupation'] = ApiClient.convertToType(data['occupation'], 'String');
      }
      if (data.hasOwnProperty('email')) {
        obj['email'] = ApiClient.convertToType(data['email'], 'String');
      }
    }
    return obj;
  }

  /**
   * First name of the recipient.    This field is applicable for AFT & OCT transactions.  Only alpha numeric values are supported. Special characters not in the standard ASCII character set, are not supported and will be stripped before being sent to sent to the processor. 
   * @member {String} firstName
   */
  exports.prototype['firstName'] = undefined;
  /**
   * Middle name of the recipient.    This field is applicable for AFT & OCT transactions.  Only alpha numeric values are supported. Special characters not in the standard ASCII character set, are not supported and will be stripped before being sent to sent to the processor. 
   * @member {String} middleName
   */
  exports.prototype['middleName'] = undefined;
  /**
   * Last name of the recipient.  This field is applicable for AFT & OCT transactions.  Only alpha numeric values are supported. Special characters not in the standard ASCII character set, are not supported and will be stripped before being sent to sent to the processor. 
   * @member {String} lastName
   */
  exports.prototype['lastName'] = undefined;
  /**
   * The street address of the recipient This field is applicable for AFT and OCT transactions.  Only alpha numeric values are supported. Special characters not in the standard ASCII character set are not supported and will be stripped before being sent to sent to the processor. 
   * @member {String} address1
   */
  exports.prototype['address1'] = undefined;
  /**
   * The city of the recipient. This field is applicable for AFT and OCT transactions.  Only alpha numeric values are supported. Special characters not in the standard ASCII character set are not supported and will be stripped before being sent to sent to the processor. 
   * @member {String} locality
   */
  exports.prototype['locality'] = undefined;
  /**
   * The state or province of the recipient. This field is applicable for AFT and OCT transactions when the recipient country is US or CA. Else it is optional.  Must be a two character value 
   * @member {String} administrativeArea
   */
  exports.prototype['administrativeArea'] = undefined;
  /**
   * The country associated with the address of the recipient. This field is applicable for AFT and OCT transactions.  Must be a two character ISO country code.  For example, see [ISO Country Code](https://developer.cybersource.com/docs/cybs/en-us/country-codes/reference/all/na/country-codes/country-codes.html) 
   * @member {String} country
   */
  exports.prototype['country'] = undefined;
  /**
   * Recipient postal code. Required only for FDCCompass.
   * @member {String} postalCode
   */
  exports.prototype['postalCode'] = undefined;
  /**
   * Recipient phone number. Required only for FDCCompass.
   * @member {String} phoneNumber
   */
  exports.prototype['phoneNumber'] = undefined;
  /**
   * Account owner alias name. 
   * @member {String} aliasName
   */
  exports.prototype['aliasName'] = undefined;
  /**
   * Account Owner Nationality
   * @member {String} nationality
   */
  exports.prototype['nationality'] = undefined;
  /**
   * Account Owner Country of Birth
   * @member {String} countryOfBirth
   */
  exports.prototype['countryOfBirth'] = undefined;
  /**
   * Account Owner Occupation
   * @member {String} occupation
   */
  exports.prototype['occupation'] = undefined;
  /**
   * Account Owner email address
   * @member {String} email
   */
  exports.prototype['email'] = undefined;



  return exports;
}));


