/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.PushFunds201ResponseProcessingInformationDomesticNationalNet = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The PushFunds201ResponseProcessingInformationDomesticNationalNet model module.
   * @module model/PushFunds201ResponseProcessingInformationDomesticNationalNet
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>PushFunds201ResponseProcessingInformationDomesticNationalNet</code>.
   * Settlement Service Data object for additional transaction requirements when the transaction indicates domestic national settlement. 
   * @alias module:model/PushFunds201ResponseProcessingInformationDomesticNationalNet
   * @class
   */
  var exports = function() {
    var _this = this;


  };

  /**
   * Constructs a <code>PushFunds201ResponseProcessingInformationDomesticNationalNet</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PushFunds201ResponseProcessingInformationDomesticNationalNet} obj Optional instance to populate.
   * @return {module:model/PushFunds201ResponseProcessingInformationDomesticNationalNet} The populated <code>PushFunds201ResponseProcessingInformationDomesticNationalNet</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('reimbursementFeeBaseAmount')) {
        obj['reimbursementFeeBaseAmount'] = ApiClient.convertToType(data['reimbursementFeeBaseAmount'], 'String');
      }
    }
    return obj;
  }

  /**
   * National Net Interchange Reimbursement Fee (IRF) calculation base amount. This must be less than the transaction amount.  Format:  Minimum Value: 0  Maximum value: 999999999.99  Allowed fractional digits: 3.  Note: If a currency has three decimal places, the last digit of this field must be zero.  Required for Columbia National Net Settlement Service (NNSS) transactions. 
   * @member {String} reimbursementFeeBaseAmount
   */
  exports.prototype['reimbursementFeeBaseAmount'] = undefined;



  return exports;
}));


