/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Ptsv1pushfundstransferClientReferenceInformation', 'model/Ptsv1pushfundstransferMerchantInformation', 'model/Ptsv1pushfundstransferOrderInformation', 'model/Ptsv1pushfundstransferPointOfServiceInformation', 'model/Ptsv1pushfundstransferProcessingInformation', 'model/Ptsv1pushfundstransferRecipientInformation', 'model/Ptsv1pushfundstransferSenderInformation', 'model/Ptsv2payoutsAggregatorInformation'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Ptsv1pushfundstransferClientReferenceInformation'), require('./Ptsv1pushfundstransferMerchantInformation'), require('./Ptsv1pushfundstransferOrderInformation'), require('./Ptsv1pushfundstransferPointOfServiceInformation'), require('./Ptsv1pushfundstransferProcessingInformation'), require('./Ptsv1pushfundstransferRecipientInformation'), require('./Ptsv1pushfundstransferSenderInformation'), require('./Ptsv2payoutsAggregatorInformation'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.PushFundsRequest = factory(root.CyberSource.ApiClient, root.CyberSource.Ptsv1pushfundstransferClientReferenceInformation, root.CyberSource.Ptsv1pushfundstransferMerchantInformation, root.CyberSource.Ptsv1pushfundstransferOrderInformation, root.CyberSource.Ptsv1pushfundstransferPointOfServiceInformation, root.CyberSource.Ptsv1pushfundstransferProcessingInformation, root.CyberSource.Ptsv1pushfundstransferRecipientInformation, root.CyberSource.Ptsv1pushfundstransferSenderInformation, root.CyberSource.Ptsv2payoutsAggregatorInformation);
  }
}(this, function(ApiClient, Ptsv1pushfundstransferClientReferenceInformation, Ptsv1pushfundstransferMerchantInformation, Ptsv1pushfundstransferOrderInformation, Ptsv1pushfundstransferPointOfServiceInformation, Ptsv1pushfundstransferProcessingInformation, Ptsv1pushfundstransferRecipientInformation, Ptsv1pushfundstransferSenderInformation, Ptsv2payoutsAggregatorInformation) {
  'use strict';




  /**
   * The PushFundsRequest model module.
   * @module model/PushFundsRequest
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>PushFundsRequest</code>.
   * @alias module:model/PushFundsRequest
   * @class
   * @param orderInformation {module:model/Ptsv1pushfundstransferOrderInformation} 
   */
  var exports = function(orderInformation) {
    var _this = this;



    _this['orderInformation'] = orderInformation;





  };

  /**
   * Constructs a <code>PushFundsRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PushFundsRequest} obj Optional instance to populate.
   * @return {module:model/PushFundsRequest} The populated <code>PushFundsRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('aggregatorInformation')) {
        obj['aggregatorInformation'] = Ptsv2payoutsAggregatorInformation.constructFromObject(data['aggregatorInformation']);
      }
      if (data.hasOwnProperty('clientReferenceInformation')) {
        obj['clientReferenceInformation'] = Ptsv1pushfundstransferClientReferenceInformation.constructFromObject(data['clientReferenceInformation']);
      }
      if (data.hasOwnProperty('orderInformation')) {
        obj['orderInformation'] = Ptsv1pushfundstransferOrderInformation.constructFromObject(data['orderInformation']);
      }
      if (data.hasOwnProperty('processingInformation')) {
        obj['processingInformation'] = Ptsv1pushfundstransferProcessingInformation.constructFromObject(data['processingInformation']);
      }
      if (data.hasOwnProperty('recipientInformation')) {
        obj['recipientInformation'] = Ptsv1pushfundstransferRecipientInformation.constructFromObject(data['recipientInformation']);
      }
      if (data.hasOwnProperty('senderInformation')) {
        obj['senderInformation'] = Ptsv1pushfundstransferSenderInformation.constructFromObject(data['senderInformation']);
      }
      if (data.hasOwnProperty('merchantInformation')) {
        obj['merchantInformation'] = Ptsv1pushfundstransferMerchantInformation.constructFromObject(data['merchantInformation']);
      }
      if (data.hasOwnProperty('pointOfServiceInformation')) {
        obj['pointOfServiceInformation'] = Ptsv1pushfundstransferPointOfServiceInformation.constructFromObject(data['pointOfServiceInformation']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/Ptsv2payoutsAggregatorInformation} aggregatorInformation
   */
  exports.prototype['aggregatorInformation'] = undefined;
  /**
   * @member {module:model/Ptsv1pushfundstransferClientReferenceInformation} clientReferenceInformation
   */
  exports.prototype['clientReferenceInformation'] = undefined;
  /**
   * @member {module:model/Ptsv1pushfundstransferOrderInformation} orderInformation
   */
  exports.prototype['orderInformation'] = undefined;
  /**
   * @member {module:model/Ptsv1pushfundstransferProcessingInformation} processingInformation
   */
  exports.prototype['processingInformation'] = undefined;
  /**
   * @member {module:model/Ptsv1pushfundstransferRecipientInformation} recipientInformation
   */
  exports.prototype['recipientInformation'] = undefined;
  /**
   * @member {module:model/Ptsv1pushfundstransferSenderInformation} senderInformation
   */
  exports.prototype['senderInformation'] = undefined;
  /**
   * @member {module:model/Ptsv1pushfundstransferMerchantInformation} merchantInformation
   */
  exports.prototype['merchantInformation'] = undefined;
  /**
   * @member {module:model/Ptsv1pushfundstransferPointOfServiceInformation} pointOfServiceInformation
   */
  exports.prototype['pointOfServiceInformation'] = undefined;



  return exports;
}));


