/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ReportingV3ReportsGet200ResponseLink'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ReportingV3ReportsGet200ResponseLink'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.ReportingV3ReportsGet200ResponseReportSearchResults = factory(root.CyberSource.ApiClient, root.CyberSource.ReportingV3ReportsGet200ResponseLink);
  }
}(this, function(ApiClient, ReportingV3ReportsGet200ResponseLink) {
  'use strict';




  /**
   * The ReportingV3ReportsGet200ResponseReportSearchResults model module.
   * @module model/ReportingV3ReportsGet200ResponseReportSearchResults
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>ReportingV3ReportsGet200ResponseReportSearchResults</code>.
   * Report Search Result Bean
   * @alias module:model/ReportingV3ReportsGet200ResponseReportSearchResults
   * @class
   */
  var exports = function() {
    var _this = this;

















  };

  /**
   * Constructs a <code>ReportingV3ReportsGet200ResponseReportSearchResults</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ReportingV3ReportsGet200ResponseReportSearchResults} obj Optional instance to populate.
   * @return {module:model/ReportingV3ReportsGet200ResponseReportSearchResults} The populated <code>ReportingV3ReportsGet200ResponseReportSearchResults</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('_link')) {
        obj['_link'] = ReportingV3ReportsGet200ResponseLink.constructFromObject(data['_link']);
      }
      if (data.hasOwnProperty('reportDefinitionId')) {
        obj['reportDefinitionId'] = ApiClient.convertToType(data['reportDefinitionId'], 'String');
      }
      if (data.hasOwnProperty('reportName')) {
        obj['reportName'] = ApiClient.convertToType(data['reportName'], 'String');
      }
      if (data.hasOwnProperty('reportMimeType')) {
        obj['reportMimeType'] = ApiClient.convertToType(data['reportMimeType'], 'String');
      }
      if (data.hasOwnProperty('reportFrequency')) {
        obj['reportFrequency'] = ApiClient.convertToType(data['reportFrequency'], 'String');
      }
      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'String');
      }
      if (data.hasOwnProperty('reportStartTime')) {
        obj['reportStartTime'] = ApiClient.convertToType(data['reportStartTime'], 'Date');
      }
      if (data.hasOwnProperty('reportEndTime')) {
        obj['reportEndTime'] = ApiClient.convertToType(data['reportEndTime'], 'Date');
      }
      if (data.hasOwnProperty('timezone')) {
        obj['timezone'] = ApiClient.convertToType(data['timezone'], 'String');
      }
      if (data.hasOwnProperty('reportId')) {
        obj['reportId'] = ApiClient.convertToType(data['reportId'], 'String');
      }
      if (data.hasOwnProperty('organizationId')) {
        obj['organizationId'] = ApiClient.convertToType(data['organizationId'], 'String');
      }
      if (data.hasOwnProperty('queuedTime')) {
        obj['queuedTime'] = ApiClient.convertToType(data['queuedTime'], 'Date');
      }
      if (data.hasOwnProperty('reportGeneratingTime')) {
        obj['reportGeneratingTime'] = ApiClient.convertToType(data['reportGeneratingTime'], 'Date');
      }
      if (data.hasOwnProperty('reportCompletedTime')) {
        obj['reportCompletedTime'] = ApiClient.convertToType(data['reportCompletedTime'], 'Date');
      }
      if (data.hasOwnProperty('subscriptionType')) {
        obj['subscriptionType'] = ApiClient.convertToType(data['subscriptionType'], 'String');
      }
      if (data.hasOwnProperty('groupId')) {
        obj['groupId'] = ApiClient.convertToType(data['groupId'], 'String');
      }
    }
    return obj;
  }

  /**
   * @member {module:model/ReportingV3ReportsGet200ResponseLink} _link
   */
  exports.prototype['_link'] = undefined;
  /**
   * Unique Report Identifier of each report type
   * @member {String} reportDefinitionId
   */
  exports.prototype['reportDefinitionId'] = undefined;
  /**
   * Name of the report specified by merchant while creating the report
   * @member {String} reportName
   */
  exports.prototype['reportName'] = undefined;
  /**
   * Format of the report to get generated Valid Values: - application/xml - text/csv 
   * @member {String} reportMimeType
   */
  exports.prototype['reportMimeType'] = undefined;
  /**
   * Frequency of the report to get generated Valid Values: - DAILY - WEEKLY - MONTHLY - ADHOC 
   * @member {String} reportFrequency
   */
  exports.prototype['reportFrequency'] = undefined;
  /**
   * Status of the report Valid Values: - COMPLETED - PENDING - QUEUED - RUNNING - ERROR - NO_DATA 
   * @member {String} status
   */
  exports.prototype['status'] = undefined;
  /**
   * Specifies the report start time in ISO 8601 format
   * @member {Date} reportStartTime
   */
  exports.prototype['reportStartTime'] = undefined;
  /**
   * Specifies the report end time in ISO 8601 format
   * @member {Date} reportEndTime
   */
  exports.prototype['reportEndTime'] = undefined;
  /**
   * Time Zone
   * @member {String} timezone
   */
  exports.prototype['timezone'] = undefined;
  /**
   * Unique identifier generated for every reports
   * @member {String} reportId
   */
  exports.prototype['reportId'] = undefined;
  /**
   * CyberSource Merchant Id
   * @member {String} organizationId
   */
  exports.prototype['organizationId'] = undefined;
  /**
   * Specifies the time of the report in queued  in ISO 8601 format
   * @member {Date} queuedTime
   */
  exports.prototype['queuedTime'] = undefined;
  /**
   * Specifies the time of the report started to generate  in ISO 8601 format
   * @member {Date} reportGeneratingTime
   */
  exports.prototype['reportGeneratingTime'] = undefined;
  /**
   * Specifies the time of the report completed the generation  in ISO 8601 format
   * @member {Date} reportCompletedTime
   */
  exports.prototype['reportCompletedTime'] = undefined;
  /**
   * Specifies whether the subscription created is either Custom, Standard or Classic 
   * @member {String} subscriptionType
   */
  exports.prototype['subscriptionType'] = undefined;
  /**
   * Id for selected group.
   * @member {String} groupId
   */
  exports.prototype['groupId'] = undefined;



  return exports;
}));


