/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Reportingv3reportsReportPreferences'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Reportingv3reportsReportPreferences'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.ReportingV3ReportsIdGet200Response = factory(root.CyberSource.ApiClient, root.CyberSource.Reportingv3reportsReportPreferences);
  }
}(this, function(ApiClient, Reportingv3reportsReportPreferences) {
  'use strict';




  /**
   * The ReportingV3ReportsIdGet200Response model module.
   * @module model/ReportingV3ReportsIdGet200Response
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>ReportingV3ReportsIdGet200Response</code>.
   * Report Log
   * @alias module:model/ReportingV3ReportsIdGet200Response
   * @class
   */
  var exports = function() {
    var _this = this;















  };

  /**
   * Constructs a <code>ReportingV3ReportsIdGet200Response</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ReportingV3ReportsIdGet200Response} obj Optional instance to populate.
   * @return {module:model/ReportingV3ReportsIdGet200Response} The populated <code>ReportingV3ReportsIdGet200Response</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('organizationId')) {
        obj['organizationId'] = ApiClient.convertToType(data['organizationId'], 'String');
      }
      if (data.hasOwnProperty('reportId')) {
        obj['reportId'] = ApiClient.convertToType(data['reportId'], 'String');
      }
      if (data.hasOwnProperty('reportDefinitionId')) {
        obj['reportDefinitionId'] = ApiClient.convertToType(data['reportDefinitionId'], 'String');
      }
      if (data.hasOwnProperty('reportName')) {
        obj['reportName'] = ApiClient.convertToType(data['reportName'], 'String');
      }
      if (data.hasOwnProperty('reportMimeType')) {
        obj['reportMimeType'] = ApiClient.convertToType(data['reportMimeType'], 'String');
      }
      if (data.hasOwnProperty('reportFrequency')) {
        obj['reportFrequency'] = ApiClient.convertToType(data['reportFrequency'], 'String');
      }
      if (data.hasOwnProperty('reportFields')) {
        obj['reportFields'] = ApiClient.convertToType(data['reportFields'], ['String']);
      }
      if (data.hasOwnProperty('reportStatus')) {
        obj['reportStatus'] = ApiClient.convertToType(data['reportStatus'], 'String');
      }
      if (data.hasOwnProperty('reportStartTime')) {
        obj['reportStartTime'] = ApiClient.convertToType(data['reportStartTime'], 'Date');
      }
      if (data.hasOwnProperty('reportEndTime')) {
        obj['reportEndTime'] = ApiClient.convertToType(data['reportEndTime'], 'Date');
      }
      if (data.hasOwnProperty('timezone')) {
        obj['timezone'] = ApiClient.convertToType(data['timezone'], 'String');
      }
      if (data.hasOwnProperty('reportFilters')) {
        obj['reportFilters'] = ApiClient.convertToType(data['reportFilters'], {'String': ['String']});
      }
      if (data.hasOwnProperty('reportPreferences')) {
        obj['reportPreferences'] = Reportingv3reportsReportPreferences.constructFromObject(data['reportPreferences']);
      }
      if (data.hasOwnProperty('groupId')) {
        obj['groupId'] = ApiClient.convertToType(data['groupId'], 'String');
      }
    }
    return obj;
  }

  /**
   * CyberSource merchant id
   * @member {String} organizationId
   */
  exports.prototype['organizationId'] = undefined;
  /**
   * Report ID Value
   * @member {String} reportId
   */
  exports.prototype['reportId'] = undefined;
  /**
   * Report definition Id
   * @member {String} reportDefinitionId
   */
  exports.prototype['reportDefinitionId'] = undefined;
  /**
   * Report Name
   * @member {String} reportName
   */
  exports.prototype['reportName'] = undefined;
  /**
   * Report Format  Valid values: - application/xml - text/csv 
   * @member {String} reportMimeType
   */
  exports.prototype['reportMimeType'] = undefined;
  /**
   * Report Frequency Value  Valid values: - DAILY - WEEKLY - MONTHLY - ADHOC 
   * @member {String} reportFrequency
   */
  exports.prototype['reportFrequency'] = undefined;
  /**
   * List of Integer Values
   * @member {Array.<String>} reportFields
   */
  exports.prototype['reportFields'] = undefined;
  /**
   * Report Status Value  Valid values: - COMPLETED - PENDING - QUEUED - RUNNING - ERROR - NO_DATA - RERUN 
   * @member {String} reportStatus
   */
  exports.prototype['reportStatus'] = undefined;
  /**
   * Report Start Time Value
   * @member {Date} reportStartTime
   */
  exports.prototype['reportStartTime'] = undefined;
  /**
   * Report End Time Value
   * @member {Date} reportEndTime
   */
  exports.prototype['reportEndTime'] = undefined;
  /**
   * Time Zone Value
   * @member {String} timezone
   */
  exports.prototype['timezone'] = undefined;
  /**
   * List of filters to apply
   * @member {Object.<String, Array.<String>>} reportFilters
   */
  exports.prototype['reportFilters'] = undefined;
  /**
   * @member {module:model/Reportingv3reportsReportPreferences} reportPreferences
   */
  exports.prototype['reportPreferences'] = undefined;
  /**
   * Id for selected group.
   * @member {String} groupId
   */
  exports.prototype['groupId'] = undefined;



  return exports;
}));


