/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/RiskProductsDecisionManager', 'model/RiskProductsFraudManagementEssentials', 'model/RiskProductsPortfolioRiskControls'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./RiskProductsDecisionManager'), require('./RiskProductsFraudManagementEssentials'), require('./RiskProductsPortfolioRiskControls'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.RiskProducts = factory(root.CyberSource.ApiClient, root.CyberSource.RiskProductsDecisionManager, root.CyberSource.RiskProductsFraudManagementEssentials, root.CyberSource.RiskProductsPortfolioRiskControls);
  }
}(this, function(ApiClient, RiskProductsDecisionManager, RiskProductsFraudManagementEssentials, RiskProductsPortfolioRiskControls) {
  'use strict';




  /**
   * The RiskProducts model module.
   * @module model/RiskProducts
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>RiskProducts</code>.
   * @alias module:model/RiskProducts
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>RiskProducts</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/RiskProducts} obj Optional instance to populate.
   * @return {module:model/RiskProducts} The populated <code>RiskProducts</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('fraudManagementEssentials')) {
        obj['fraudManagementEssentials'] = RiskProductsFraudManagementEssentials.constructFromObject(data['fraudManagementEssentials']);
      }
      if (data.hasOwnProperty('decisionManager')) {
        obj['decisionManager'] = RiskProductsDecisionManager.constructFromObject(data['decisionManager']);
      }
      if (data.hasOwnProperty('portfolioRiskControls')) {
        obj['portfolioRiskControls'] = RiskProductsPortfolioRiskControls.constructFromObject(data['portfolioRiskControls']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/RiskProductsFraudManagementEssentials} fraudManagementEssentials
   */
  exports.prototype['fraudManagementEssentials'] = undefined;
  /**
   * @member {module:model/RiskProductsDecisionManager} decisionManager
   */
  exports.prototype['decisionManager'] = undefined;
  /**
   * @member {module:model/RiskProductsPortfolioRiskControls} portfolioRiskControls
   */
  exports.prototype['portfolioRiskControls'] = undefined;



  return exports;
}));


