/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.RiskV1DecisionsPost201ResponsePaymentInformation = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The RiskV1DecisionsPost201ResponsePaymentInformation model module.
   * @module model/RiskV1DecisionsPost201ResponsePaymentInformation
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>RiskV1DecisionsPost201ResponsePaymentInformation</code>.
   * Contains response information about the payment.
   * @alias module:model/RiskV1DecisionsPost201ResponsePaymentInformation
   * @class
   */
  var exports = function() {
    var _this = this;






  };

  /**
   * Constructs a <code>RiskV1DecisionsPost201ResponsePaymentInformation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/RiskV1DecisionsPost201ResponsePaymentInformation} obj Optional instance to populate.
   * @return {module:model/RiskV1DecisionsPost201ResponsePaymentInformation} The populated <code>RiskV1DecisionsPost201ResponsePaymentInformation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('binCountry')) {
        obj['binCountry'] = ApiClient.convertToType(data['binCountry'], 'String');
      }
      if (data.hasOwnProperty('accountType')) {
        obj['accountType'] = ApiClient.convertToType(data['accountType'], 'String');
      }
      if (data.hasOwnProperty('issuer')) {
        obj['issuer'] = ApiClient.convertToType(data['issuer'], 'String');
      }
      if (data.hasOwnProperty('scheme')) {
        obj['scheme'] = ApiClient.convertToType(data['scheme'], 'String');
      }
      if (data.hasOwnProperty('bin')) {
        obj['bin'] = ApiClient.convertToType(data['bin'], 'String');
      }
    }
    return obj;
  }

  /**
   * Country (two-digit country code) associated with the BIN of the customer's card used for the payment. Returned if the information is available. Use this field for additional information when reviewing orders. This information is also displayed in the details page of the CyberSource Business Center. 
   * @member {String} binCountry
   */
  exports.prototype['binCountry'] = undefined;
  /**
   * Type of payment card account. This field can refer to a credit card, debit card, or prepaid card account type. 
   * @member {String} accountType
   */
  exports.prototype['accountType'] = undefined;
  /**
   * Name of the bank or entity that issued the card account. 
   * @member {String} issuer
   */
  exports.prototype['issuer'] = undefined;
  /**
   * Subtype of card account. This field can contain one of the following values: - Maestro International - Maestro UK Domestic - MasterCard Credit - MasterCard Debit - Visa Credit - Visa Debit - Visa Electron  **Note** Additional values may be present. 
   * @member {String} scheme
   */
  exports.prototype['scheme'] = undefined;
  /**
   * Credit card BIN (the first six digits of the credit card).Derived either from the `cc_bin` request field or from the first six characters of the `customer_cc_num` field. 
   * @member {String} bin
   */
  exports.prototype['bin'] = undefined;



  return exports;
}));


