/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Riskv1decisionsidmarkingRiskInformationMarkingDetails = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Riskv1decisionsidmarkingRiskInformationMarkingDetails model module.
   * @module model/Riskv1decisionsidmarkingRiskInformationMarkingDetails
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Riskv1decisionsidmarkingRiskInformationMarkingDetails</code>.
   * Details for marking the transaction.
   * @alias module:model/Riskv1decisionsidmarkingRiskInformationMarkingDetails
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>Riskv1decisionsidmarkingRiskInformationMarkingDetails</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Riskv1decisionsidmarkingRiskInformationMarkingDetails} obj Optional instance to populate.
   * @return {module:model/Riskv1decisionsidmarkingRiskInformationMarkingDetails} The populated <code>Riskv1decisionsidmarkingRiskInformationMarkingDetails</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('notes')) {
        obj['notes'] = ApiClient.convertToType(data['notes'], 'String');
      }
      if (data.hasOwnProperty('reason')) {
        obj['reason'] = ApiClient.convertToType(data['reason'], 'String');
      }
      if (data.hasOwnProperty('fieldsIncluded')) {
        obj['fieldsIncluded'] = ApiClient.convertToType(data['fieldsIncluded'], ['String']);
      }
      if (data.hasOwnProperty('action')) {
        obj['action'] = ApiClient.convertToType(data['action'], 'String');
      }
    }
    return obj;
  }

  /**
   * Notes or details that explain the reasons for marking the transaction as suspect or otherwise.
   * @member {String} notes
   */
  exports.prototype['notes'] = undefined;
  /**
   * Reason for marking the transaction as suspect or otherwise. This field can contain one of the following values: - `fraud_chargeback:` You have received a fraud-related chargeback for the transaction. - `non_fraud_chargeback:` You have received a non-fraudulent chargeback for the transaction. - `suspected:` You believe that you will probably receive a chargeback for the transaction. - `creditback:` You issued a refund to the customer to avoid a chargeback for the transaction. 
   * @member {String} reason
   */
  exports.prototype['reason'] = undefined;
  /**
   * This field can contain one or more of the following values. When you specify more than one value, separate them with commas (,). - `account_key_hash` - `customer_account_id` - `customer_email` - `customer_ipaddress` - `customer_phone` - `device_fingerprint` - `ship_address` If no value is specified, `account_key_hash`, `customer_email`, and `ship_address` are used by default. Note `account_key_hash` adds the field that contains the card number (`customer_cc_number`). 
   * @member {Array.<String>} fieldsIncluded
   */
  exports.prototype['fieldsIncluded'] = undefined;
  /**
   * This field can contain one of the following values: - add: Mark as Suspect. - clear: Clear Mark as Suspect. - hide: Remove from history. 
   * @member {String} action
   */
  exports.prototype['action'] = undefined;



  return exports;
}));


