/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/SAConfigCheckout', 'model/SAConfigContactInformation', 'model/SAConfigNotifications', 'model/SAConfigPaymentMethods', 'model/SAConfigPaymentTypes', 'model/SAConfigService'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./SAConfigCheckout'), require('./SAConfigContactInformation'), require('./SAConfigNotifications'), require('./SAConfigPaymentMethods'), require('./SAConfigPaymentTypes'), require('./SAConfigService'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.SAConfig = factory(root.CyberSource.ApiClient, root.CyberSource.SAConfigCheckout, root.CyberSource.SAConfigContactInformation, root.CyberSource.SAConfigNotifications, root.CyberSource.SAConfigPaymentMethods, root.CyberSource.SAConfigPaymentTypes, root.CyberSource.SAConfigService);
  }
}(this, function(ApiClient, SAConfigCheckout, SAConfigContactInformation, SAConfigNotifications, SAConfigPaymentMethods, SAConfigPaymentTypes, SAConfigService) {
  'use strict';




  /**
   * The SAConfig model module.
   * @module model/SAConfig
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>SAConfig</code>.
   * @alias module:model/SAConfig
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>SAConfig</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SAConfig} obj Optional instance to populate.
   * @return {module:model/SAConfig} The populated <code>SAConfig</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('parentProfileId')) {
        obj['parentProfileId'] = ApiClient.convertToType(data['parentProfileId'], 'String');
      }
      if (data.hasOwnProperty('contactInformation')) {
        obj['contactInformation'] = SAConfigContactInformation.constructFromObject(data['contactInformation']);
      }
      if (data.hasOwnProperty('notifications')) {
        obj['notifications'] = SAConfigNotifications.constructFromObject(data['notifications']);
      }
      if (data.hasOwnProperty('service')) {
        obj['service'] = SAConfigService.constructFromObject(data['service']);
      }
      if (data.hasOwnProperty('paymentMethods')) {
        obj['paymentMethods'] = SAConfigPaymentMethods.constructFromObject(data['paymentMethods']);
      }
      if (data.hasOwnProperty('checkout')) {
        obj['checkout'] = SAConfigCheckout.constructFromObject(data['checkout']);
      }
      if (data.hasOwnProperty('paymentTypes')) {
        obj['paymentTypes'] = SAConfigPaymentTypes.constructFromObject(data['paymentTypes']);
      }
    }
    return obj;
  }

  /**
   * You can group Secure Acceptance profiles under parent profiles. By changing the parent profile, you can update all profiles underneath that parent. Specify the Parent Profile ID here.
   * @member {String} parentProfileId
   */
  exports.prototype['parentProfileId'] = undefined;
  /**
   * @member {module:model/SAConfigContactInformation} contactInformation
   */
  exports.prototype['contactInformation'] = undefined;
  /**
   * @member {module:model/SAConfigNotifications} notifications
   */
  exports.prototype['notifications'] = undefined;
  /**
   * @member {module:model/SAConfigService} service
   */
  exports.prototype['service'] = undefined;
  /**
   * @member {module:model/SAConfigPaymentMethods} paymentMethods
   */
  exports.prototype['paymentMethods'] = undefined;
  /**
   * @member {module:model/SAConfigCheckout} checkout
   */
  exports.prototype['checkout'] = undefined;
  /**
   * @member {module:model/SAConfigPaymentTypes} paymentTypes
   */
  exports.prototype['paymentTypes'] = undefined;



  return exports;
}));


