/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.SAConfigCheckout = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The SAConfigCheckout model module.
   * @module model/SAConfigCheckout
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>SAConfigCheckout</code>.
   * @alias module:model/SAConfigCheckout
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>SAConfigCheckout</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SAConfigCheckout} obj Optional instance to populate.
   * @return {module:model/SAConfigCheckout} The populated <code>SAConfigCheckout</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('displayTaxAmount')) {
        obj['displayTaxAmount'] = ApiClient.convertToType(data['displayTaxAmount'], 'Boolean');
      }
      if (data.hasOwnProperty('templateType')) {
        obj['templateType'] = ApiClient.convertToType(data['templateType'], 'String');
      }
      if (data.hasOwnProperty('returnToMerchantSiteUrl')) {
        obj['returnToMerchantSiteUrl'] = ApiClient.convertToType(data['returnToMerchantSiteUrl'], 'String');
      }
    }
    return obj;
  }

  /**
   * Toggles whether or not the tax amount is displayed on the Hosted Checkout.
   * @member {Boolean} displayTaxAmount
   */
  exports.prototype['displayTaxAmount'] = undefined;
  /**
   * Specifies whether the Hosted Checkout is displayed as a single page form or multi page checkout.   Valid values:  `multi`  `single` 
   * @member {String} templateType
   */
  exports.prototype['templateType'] = undefined;
  /**
   * URL of the website linked to from the Secure Acceptance receipt page. Only used if the profile does not have custom receipt pages configured.
   * @member {String} returnToMerchantSiteUrl
   */
  exports.prototype['returnToMerchantSiteUrl'] = undefined;



  return exports;
}));


