/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.SAConfigService = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The SAConfigService model module.
   * @module model/SAConfigService
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>SAConfigService</code>.
   * @alias module:model/SAConfigService
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>SAConfigService</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SAConfigService} obj Optional instance to populate.
   * @return {module:model/SAConfigService} The populated <code>SAConfigService</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('decisionManagerVerboseEnabled')) {
        obj['decisionManagerVerboseEnabled'] = ApiClient.convertToType(data['decisionManagerVerboseEnabled'], 'Boolean');
      }
      if (data.hasOwnProperty('declinedRetryLimit')) {
        obj['declinedRetryLimit'] = ApiClient.convertToType(data['declinedRetryLimit'], 'Number');
      }
      if (data.hasOwnProperty('decisionManagerEnabled')) {
        obj['decisionManagerEnabled'] = ApiClient.convertToType(data['decisionManagerEnabled'], 'Boolean');
      }
      if (data.hasOwnProperty('tokenizationEnabled')) {
        obj['tokenizationEnabled'] = ApiClient.convertToType(data['tokenizationEnabled'], 'Boolean');
      }
      if (data.hasOwnProperty('reverseAuthOnAddressVerificationSystemFailure')) {
        obj['reverseAuthOnAddressVerificationSystemFailure'] = ApiClient.convertToType(data['reverseAuthOnAddressVerificationSystemFailure'], 'Boolean');
      }
      if (data.hasOwnProperty('deviceFingerprintEnabled')) {
        obj['deviceFingerprintEnabled'] = ApiClient.convertToType(data['deviceFingerprintEnabled'], 'Boolean');
      }
      if (data.hasOwnProperty('reverseAuthOnCardVerificationNumberFailure')) {
        obj['reverseAuthOnCardVerificationNumberFailure'] = ApiClient.convertToType(data['reverseAuthOnCardVerificationNumberFailure'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * Toggles whether verbose Decision Manager results should be present in the Secure Acceptance response. As this response passes through the browser, it is recommended to set this to \"false\" outside of debugging.
   * @member {Boolean} decisionManagerVerboseEnabled
   */
  exports.prototype['decisionManagerVerboseEnabled'] = undefined;
  /**
   * Defines the number of retries a payer is presented with on payment declines on Hosted Checkout. Valid values are between 0 and 5.
   * @member {Number} declinedRetryLimit
   */
  exports.prototype['declinedRetryLimit'] = undefined;
  /**
   * Toggles whether Decision Manager is enabled or not for Secure Acceptance transactions. Requires the transacting MID to be enabled and configured for Decicion Manager.
   * @member {Boolean} decisionManagerEnabled
   */
  exports.prototype['decisionManagerEnabled'] = undefined;
  /**
   * Toggles whether Tokenization is enabled or not for Secure Acceptance transactions. Requires the transacting MID to be enabled and configured for Tokenization.
   * @member {Boolean} tokenizationEnabled
   */
  exports.prototype['tokenizationEnabled'] = undefined;
  /**
   * Toggles whether or not an approved Authorization that fails AVS should be automatically reversed.
   * @member {Boolean} reverseAuthOnAddressVerificationSystemFailure
   */
  exports.prototype['reverseAuthOnAddressVerificationSystemFailure'] = undefined;
  /**
   * Toggles whether or not fraud Device Fingerprinting is enabled on the Hosted Checkout. This simplifies enablement for Decision Manager.
   * @member {Boolean} deviceFingerprintEnabled
   */
  exports.prototype['deviceFingerprintEnabled'] = undefined;
  /**
   * Toggles whether or not an approved Authorization that fails CVN check that should be automatically reversed.
   * @member {Boolean} reverseAuthOnCardVerificationNumberFailure
   */
  exports.prototype['reverseAuthOnCardVerificationNumberFailure'] = undefined;



  return exports;
}));


