/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/TmsBinLookupIssuerInformation', 'model/TmsBinLookupPaymentAccountInformation'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./TmsBinLookupIssuerInformation'), require('./TmsBinLookupPaymentAccountInformation'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.TmsBinLookup = factory(root.CyberSource.ApiClient, root.CyberSource.TmsBinLookupIssuerInformation, root.CyberSource.TmsBinLookupPaymentAccountInformation);
  }
}(this, function(ApiClient, TmsBinLookupIssuerInformation, TmsBinLookupPaymentAccountInformation) {
  'use strict';




  /**
   * The TmsBinLookup model module.
   * @module model/TmsBinLookup
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>TmsBinLookup</code>.
   * Bin Information of the PAN provided by BinLookUp Service. This is only retrieved when retrieveBinDetails=true is passed as a query parameter. 
   * @alias module:model/TmsBinLookup
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>TmsBinLookup</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/TmsBinLookup} obj Optional instance to populate.
   * @return {module:model/TmsBinLookup} The populated <code>TmsBinLookup</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('paymentAccountInformation')) {
        obj['paymentAccountInformation'] = TmsBinLookupPaymentAccountInformation.constructFromObject(data['paymentAccountInformation']);
      }
      if (data.hasOwnProperty('issuerInformation')) {
        obj['issuerInformation'] = TmsBinLookupIssuerInformation.constructFromObject(data['issuerInformation']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/TmsBinLookupPaymentAccountInformation} paymentAccountInformation
   */
  exports.prototype['paymentAccountInformation'] = undefined;
  /**
   * @member {module:model/TmsBinLookupIssuerInformation} issuerInformation
   */
  exports.prototype['issuerInformation'] = undefined;



  return exports;
}));


