/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.TmsBinLookupIssuerInformation = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The TmsBinLookupIssuerInformation model module.
   * @module model/TmsBinLookupIssuerInformation
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>TmsBinLookupIssuerInformation</code>.
   * @alias module:model/TmsBinLookupIssuerInformation
   * @class
   */
  var exports = function() {
    var _this = this;






  };

  /**
   * Constructs a <code>TmsBinLookupIssuerInformation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/TmsBinLookupIssuerInformation} obj Optional instance to populate.
   * @return {module:model/TmsBinLookupIssuerInformation} The populated <code>TmsBinLookupIssuerInformation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('country')) {
        obj['country'] = ApiClient.convertToType(data['country'], 'String');
      }
      if (data.hasOwnProperty('binLength')) {
        obj['binLength'] = ApiClient.convertToType(data['binLength'], 'String');
      }
      if (data.hasOwnProperty('accountPrefix')) {
        obj['accountPrefix'] = ApiClient.convertToType(data['accountPrefix'], 'String');
      }
      if (data.hasOwnProperty('phoneNumber')) {
        obj['phoneNumber'] = ApiClient.convertToType(data['phoneNumber'], 'String');
      }
    }
    return obj;
  }

  /**
   * This field contains the issuer name. 
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * This field contains [2-character ISO Country Codes](http://apps.cybersource.com/library/documentation/sbc/quickref/countries_alpha_list.pdf) for the issuer. 
   * @member {String} country
   */
  exports.prototype['country'] = undefined;
  /**
   * This field contains the length of the BIN. 
   * @member {String} binLength
   */
  exports.prototype['binLength'] = undefined;
  /**
   * This field contains the first 6 to 8 digits of a primary account number (PAN). The length of the field is determined by [PCI-DSS standards for truncation](https://pcissc.secure.force.com/faq/articles/Frequently_Asked_Question/What-are-acceptable-formats-for-truncation-of-primary-account-numbers). 
   * @member {String} accountPrefix
   */
  exports.prototype['accountPrefix'] = undefined;
  /**
   * This field contains the customer service phone number for the issuer. 
   * @member {String} phoneNumber
   */
  exports.prototype['phoneNumber'] = undefined;



  return exports;
}));


