/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/TmsBusinessInformationAcquirer', 'model/TmsBusinessInformationAddress'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./TmsBusinessInformationAcquirer'), require('./TmsBusinessInformationAddress'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.TmsBusinessInformation = factory(root.CyberSource.ApiClient, root.CyberSource.TmsBusinessInformationAcquirer, root.CyberSource.TmsBusinessInformationAddress);
  }
}(this, function(ApiClient, TmsBusinessInformationAcquirer, TmsBusinessInformationAddress) {
  'use strict';




  /**
   * The TmsBusinessInformation model module.
   * @module model/TmsBusinessInformation
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>TmsBusinessInformation</code>.
   * @alias module:model/TmsBusinessInformation
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>TmsBusinessInformation</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/TmsBusinessInformation} obj Optional instance to populate.
   * @return {module:model/TmsBusinessInformation} The populated <code>TmsBusinessInformation</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('doingBusinessAs')) {
        obj['doingBusinessAs'] = ApiClient.convertToType(data['doingBusinessAs'], 'String');
      }
      if (data.hasOwnProperty('address')) {
        obj['address'] = TmsBusinessInformationAddress.constructFromObject(data['address']);
      }
      if (data.hasOwnProperty('websiteUrl')) {
        obj['websiteUrl'] = ApiClient.convertToType(data['websiteUrl'], 'String');
      }
      if (data.hasOwnProperty('businessIdentificationType')) {
        obj['businessIdentificationType'] = ApiClient.convertToType(data['businessIdentificationType'], 'String');
      }
      if (data.hasOwnProperty('businessIdentificationValue')) {
        obj['businessIdentificationValue'] = ApiClient.convertToType(data['businessIdentificationValue'], 'String');
      }
      if (data.hasOwnProperty('acquirer')) {
        obj['acquirer'] = TmsBusinessInformationAcquirer.constructFromObject(data['acquirer']);
      }
    }
    return obj;
  }

  /**
   * Name of the network token merchant.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Name the network token merchant does business as
   * @member {String} doingBusinessAs
   */
  exports.prototype['doingBusinessAs'] = undefined;
  /**
   * @member {module:model/TmsBusinessInformationAddress} address
   */
  exports.prototype['address'] = undefined;
  /**
   * Website of network token merchant.
   * @member {String} websiteUrl
   */
  exports.prototype['websiteUrl'] = undefined;
  /**
   * The Identifier associated with the business type; required unless both acquirerId and acquirerMerchantId are provided. 
   * @member {String} businessIdentificationType
   */
  exports.prototype['businessIdentificationType'] = undefined;
  /**
   * The value associated with the business identifier type; required unless both acquirerId and acquirerMerchantId are provided. 
   * @member {String} businessIdentificationValue
   */
  exports.prototype['businessIdentificationValue'] = undefined;
  /**
   * @member {module:model/TmsBusinessInformationAcquirer} acquirer
   */
  exports.prototype['acquirer'] = undefined;



  return exports;
}));


