/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/TmsCardArtBrandLogoAsset', 'model/TmsCardArtCombinedAsset', 'model/TmsCardArtIconAsset', 'model/TmsCardArtIssuerLogoAsset'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./TmsCardArtBrandLogoAsset'), require('./TmsCardArtCombinedAsset'), require('./TmsCardArtIconAsset'), require('./TmsCardArtIssuerLogoAsset'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.TmsCardArt = factory(root.CyberSource.ApiClient, root.CyberSource.TmsCardArtBrandLogoAsset, root.CyberSource.TmsCardArtCombinedAsset, root.CyberSource.TmsCardArtIconAsset, root.CyberSource.TmsCardArtIssuerLogoAsset);
  }
}(this, function(ApiClient, TmsCardArtBrandLogoAsset, TmsCardArtCombinedAsset, TmsCardArtIconAsset, TmsCardArtIssuerLogoAsset) {
  'use strict';




  /**
   * The TmsCardArt model module.
   * @module model/TmsCardArt
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>TmsCardArt</code>.
   * Card art associated with the tokenized card. 
   * @alias module:model/TmsCardArt
   * @class
   */
  var exports = function() {
    var _this = this;






  };

  /**
   * Constructs a <code>TmsCardArt</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/TmsCardArt} obj Optional instance to populate.
   * @return {module:model/TmsCardArt} The populated <code>TmsCardArt</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('foregroundColor')) {
        obj['foregroundColor'] = ApiClient.convertToType(data['foregroundColor'], 'String');
      }
      if (data.hasOwnProperty('combinedAsset')) {
        obj['combinedAsset'] = TmsCardArtCombinedAsset.constructFromObject(data['combinedAsset']);
      }
      if (data.hasOwnProperty('brandLogoAsset')) {
        obj['brandLogoAsset'] = TmsCardArtBrandLogoAsset.constructFromObject(data['brandLogoAsset']);
      }
      if (data.hasOwnProperty('issuerLogoAsset')) {
        obj['issuerLogoAsset'] = TmsCardArtIssuerLogoAsset.constructFromObject(data['issuerLogoAsset']);
      }
      if (data.hasOwnProperty('iconAsset')) {
        obj['iconAsset'] = TmsCardArtIconAsset.constructFromObject(data['iconAsset']);
      }
    }
    return obj;
  }

  /**
   * Card foreground color. 
   * @member {String} foregroundColor
   */
  exports.prototype['foregroundColor'] = undefined;
  /**
   * @member {module:model/TmsCardArtCombinedAsset} combinedAsset
   */
  exports.prototype['combinedAsset'] = undefined;
  /**
   * @member {module:model/TmsCardArtBrandLogoAsset} brandLogoAsset
   */
  exports.prototype['brandLogoAsset'] = undefined;
  /**
   * @member {module:model/TmsCardArtIssuerLogoAsset} issuerLogoAsset
   */
  exports.prototype['issuerLogoAsset'] = undefined;
  /**
   * @member {module:model/TmsCardArtIconAsset} iconAsset
   */
  exports.prototype['iconAsset'] = undefined;



  return exports;
}));


