/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.TmsNetworkTokenServicesAmericanExpressTokenService = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The TmsNetworkTokenServicesAmericanExpressTokenService model module.
   * @module model/TmsNetworkTokenServicesAmericanExpressTokenService
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>TmsNetworkTokenServicesAmericanExpressTokenService</code>.
   * @alias module:model/TmsNetworkTokenServicesAmericanExpressTokenService
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>TmsNetworkTokenServicesAmericanExpressTokenService</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/TmsNetworkTokenServicesAmericanExpressTokenService} obj Optional instance to populate.
   * @return {module:model/TmsNetworkTokenServicesAmericanExpressTokenService} The populated <code>TmsNetworkTokenServicesAmericanExpressTokenService</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('enableService')) {
        obj['enableService'] = ApiClient.convertToType(data['enableService'], 'Boolean');
      }
      if (data.hasOwnProperty('enableTransactionalTokens')) {
        obj['enableTransactionalTokens'] = ApiClient.convertToType(data['enableTransactionalTokens'], 'Boolean');
      }
      if (data.hasOwnProperty('tokenRequestorId')) {
        obj['tokenRequestorId'] = ApiClient.convertToType(data['tokenRequestorId'], 'String');
      }
      if (data.hasOwnProperty('seNumber')) {
        obj['seNumber'] = ApiClient.convertToType(data['seNumber'], 'String');
      }
    }
    return obj;
  }

  /**
   * Indicates if the service for network tokens for the American Express card association are enabled
   * @member {Boolean} enableService
   */
  exports.prototype['enableService'] = undefined;
  /**
   * Indicates if network tokens for the American Express card association are enabled for transactions
   * @member {Boolean} enableTransactionalTokens
   */
  exports.prototype['enableTransactionalTokens'] = undefined;
  /**
   * Token Requestor ID provided by American Express during the registration process for the Tokenization Service  Pattern: ^[0-9]{11}\\\\z$\" Min Length: 11 Max Length: 11 Example: \"12345678912\" 
   * @member {String} tokenRequestorId
   */
  exports.prototype['tokenRequestorId'] = undefined;
  /**
   * SE Number assigned by American Express for the merchant's account  Pattern: \"^[0-9]{11}\\\\z$\" Min Length: 10 Max Length: 10 Example: \"9876543212\" 
   * @member {String} seNumber
   */
  exports.prototype['seNumber'] = undefined;



  return exports;
}));


