/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.TmsTokenFormats = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The TmsTokenFormats model module.
   * @module model/TmsTokenFormats
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>TmsTokenFormats</code>.
   * @alias module:model/TmsTokenFormats
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>TmsTokenFormats</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/TmsTokenFormats} obj Optional instance to populate.
   * @return {module:model/TmsTokenFormats} The populated <code>TmsTokenFormats</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('customer')) {
        obj['customer'] = ApiClient.convertToType(data['customer'], 'String');
      }
      if (data.hasOwnProperty('paymentInstrument')) {
        obj['paymentInstrument'] = ApiClient.convertToType(data['paymentInstrument'], 'String');
      }
      if (data.hasOwnProperty('instrumentIdentifierCard')) {
        obj['instrumentIdentifierCard'] = ApiClient.convertToType(data['instrumentIdentifierCard'], 'String');
      }
      if (data.hasOwnProperty('instrumentIdentifierBankAccount')) {
        obj['instrumentIdentifierBankAccount'] = ApiClient.convertToType(data['instrumentIdentifierBankAccount'], 'String');
      }
    }
    return obj;
  }

  /**
   * Format for customer tokens.  Possible Values:   - '16_DIGIT'   - '19_DIGIT'   - '22_DIGIT'   - '32_HEX' 
   * @member {String} customer
   */
  exports.prototype['customer'] = undefined;
  /**
   * Format for payment instrument tokens.  Possible Values:   - '16_DIGIT'   - '19_DIGIT'   - '22_DIGIT'   - '32_HEX' 
   * @member {String} paymentInstrument
   */
  exports.prototype['paymentInstrument'] = undefined;
  /**
   * Format for card based instrument identifier tokens.  Possible Values:   - '16_DIGIT'   - '16_DIGIT_LAST_4'   - '19_DIGIT'   - '19_DIGIT_LAST_4'   - '22_DIGIT'   - '32_HEX' 
   * @member {String} instrumentIdentifierCard
   */
  exports.prototype['instrumentIdentifierCard'] = undefined;
  /**
   * Format for bank account based instrument identifier tokens.  Possible Values:    - '16_DIGIT'   - '19_DIGIT'   - '22_DIGIT'   - '32_HEX' 
   * @member {String} instrumentIdentifierBankAccount
   */
  exports.prototype['instrumentIdentifierBankAccount'] = undefined;



  return exports;
}));


