/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.Tmsv2TokenizedCardMetadataIssuer = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The Tmsv2TokenizedCardMetadataIssuer model module.
   * @module model/Tmsv2TokenizedCardMetadataIssuer
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>Tmsv2TokenizedCardMetadataIssuer</code>.
   * Issuer associated with the tokenized card. 
   * @alias module:model/Tmsv2TokenizedCardMetadataIssuer
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>Tmsv2TokenizedCardMetadataIssuer</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Tmsv2TokenizedCardMetadataIssuer} obj Optional instance to populate.
   * @return {module:model/Tmsv2TokenizedCardMetadataIssuer} The populated <code>Tmsv2TokenizedCardMetadataIssuer</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('shortDescription')) {
        obj['shortDescription'] = ApiClient.convertToType(data['shortDescription'], 'String');
      }
      if (data.hasOwnProperty('longDescription')) {
        obj['longDescription'] = ApiClient.convertToType(data['longDescription'], 'String');
      }
    }
    return obj;
  }

  /**
   * issuer name. 
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * issuer short description. 
   * @member {String} shortDescription
   */
  exports.prototype['shortDescription'] = undefined;
  /**
   * issuer long  description. 
   * @member {String} longDescription
   */
  exports.prototype['longDescription'] = undefined;



  return exports;
}));


