/**
 * CyberSource Merged Spec
 * All CyberSource API specs merged together. These are available at https://developer.cybersource.com/api/reference/api-reference.html
 *
 * OpenAPI spec version: 0.0.1
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.38
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.CyberSource) {
      root.CyberSource = {};
    }
    root.CyberSource.TssV2TransactionsGet200ResponsePaymentInformationBankAccount = factory(root.CyberSource.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The TssV2TransactionsGet200ResponsePaymentInformationBankAccount model module.
   * @module model/TssV2TransactionsGet200ResponsePaymentInformationBankAccount
   * @version 0.0.1
   */

  /**
   * Constructs a new <code>TssV2TransactionsGet200ResponsePaymentInformationBankAccount</code>.
   * @alias module:model/TssV2TransactionsGet200ResponsePaymentInformationBankAccount
   * @class
   */
  var exports = function() {
    var _this = this;








  };

  /**
   * Constructs a <code>TssV2TransactionsGet200ResponsePaymentInformationBankAccount</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/TssV2TransactionsGet200ResponsePaymentInformationBankAccount} obj Optional instance to populate.
   * @return {module:model/TssV2TransactionsGet200ResponsePaymentInformationBankAccount} The populated <code>TssV2TransactionsGet200ResponsePaymentInformationBankAccount</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('suffix')) {
        obj['suffix'] = ApiClient.convertToType(data['suffix'], 'String');
      }
      if (data.hasOwnProperty('prefix')) {
        obj['prefix'] = ApiClient.convertToType(data['prefix'], 'String');
      }
      if (data.hasOwnProperty('checkNumber')) {
        obj['checkNumber'] = ApiClient.convertToType(data['checkNumber'], 'String');
      }
      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('checkDigit')) {
        obj['checkDigit'] = ApiClient.convertToType(data['checkDigit'], 'String');
      }
      if (data.hasOwnProperty('encoderId')) {
        obj['encoderId'] = ApiClient.convertToType(data['encoderId'], 'String');
      }
    }
    return obj;
  }

  /**
   * Last four digits of the customer's payment account number. 
   * @member {String} suffix
   */
  exports.prototype['suffix'] = undefined;
  /**
   * Bank Identification Number (BIN). This is the initial four to six numbers on a credit card account number. 
   * @member {String} prefix
   */
  exports.prototype['prefix'] = undefined;
  /**
   * Check number.  Chase Paymentech Solutions - Optional. CyberSource ACH Service - Not used. RBS WorldPay Atlanta - Optional on debits. Required on credits. TeleCheck - Strongly recommended on debit requests. Optional on credits. 
   * @member {String} checkNumber
   */
  exports.prototype['checkNumber'] = undefined;
  /**
   * Account type.  Possible values:  - **C**: Checking.  - **G**: General ledger. This value is supported only on Wells Fargo ACH.  - **S**: Savings (U.S. dollars only).  - **X**: Corporate checking (U.S. dollars only). 
   * @member {String} type
   */
  exports.prototype['type'] = undefined;
  /**
   * Name used on the bank account. You can use this field only when scoring a direct debit transaction 
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Code used to validate the customer's account number. Required for some countries if you do not or are not allowed to provide the IBAN instead. You may use this field only when scoring a direct debit transaction. 
   * @member {String} checkDigit
   */
  exports.prototype['checkDigit'] = undefined;
  /**
   * Identifier for the bank that provided the customer's encoded account number.  To obtain the bank identifier, contact your processor. 
   * @member {String} encoderId
   */
  exports.prototype['encoderId'] = undefined;



  return exports;
}));


